VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StringList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E0671B5007C"
Option Explicit

'local variable(s) to hold property Value(s)

Private mlngCount As Long
Private mStringLine() As String
Private mlngCurLine As Long

'other
Private strErrSource As String
Private lngError As Long

Public Event Change()

Public Sub Add(NewString As String, Optional InsertPos As Long = -1)
  Dim lngPos As Long
  
  'if no position passed
  If InsertPos <= -1 Then
    'add to end
    InsertPos = mlngCount
  End If
  'if set past end of collection
  If InsertPos > mlngCount Then
    InsertPos = mlngCount
  End If
  
  'adds the new string
  ReDim Preserve mStringLine(mlngCount)
  
  'start at end of
  lngPos = mlngCount
  
  'move all strings above insertion point up one
  Do While lngPos > InsertPos
    'move position at lngPos-1 to lngpos
    mStringLine(lngPos) = mStringLine(lngPos - 1)
    'decrement counter
    lngPos = lngPos - 1
  Loop
  'now add new string at insertion point
  mStringLine(InsertPos) = NewString
  'increment Count
  mlngCount = mlngCount + 1
  
  'raise change event
  RaiseEvent Change
End Sub


Public Property Get AllLines() As String()
  'return a reference to itself
  AllLines = mStringLine
  
End Property
Public Sub Assign(ByVal sInput As Variant, Optional ByVal Delimiter As String = vbNewLine)
  'if a non-array string is passed, parse it
  'if an array of strings is passed,
  'just assign the array
  
  On Error GoTo ErrHandler
  
  'only strings, or array of strings allowed
  Select Case VarType(sInput)
  Case vbString 'a single string
    
    'try another approach
    'how to deal with lf, cr, and crlf all as ONE new line???
    sInput = Replace(sInput, vbCrLf, vbCr)
    sInput = Replace(sInput, vbLf, vbCr)
    sInput = Replace(sInput, vbVerticalTab, vbCr)
    
'    'force out linefeeds
'    sInput = Replace(sInput, vbLf, vbNullString)
    
    'now split based on vbCr
    Delimiter = vbCr
    
    'now parse the string
    mStringLine = Split(sInput, Delimiter)
    mlngCount = UBound(mStringLine()) + 1
    
  Case vbString + vbArray 'an array of strings
    mlngCount = UBound(sInput) + 1
    ReDim mStringLine(mlngCount - 1)
    mStringLine = sInput
    
  Case Else
    'if not a stringlist,
    If Not (TypeOf sInput Is StringList) Then
      'any other variable passed causes an error
      On Error GoTo 0: Err.Raise vbObjectError + 520, strErrSource, LoadResString(520)
      Exit Sub
    End If
    'just assign
    mlngCount = sInput.Count
    'ReDim mStringLine(mlngCount - 1)
    mStringLine = sInput.AllLines
  End Select
  
  'raise change event
  RaiseEvent Change
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub Clear()
  'clear out the string array, reset Count
  ReDim mStringLine(0)
  mlngCount = 0
  'raise change event
  RaiseEvent Change
End Sub



Friend Property Let CurLine(ByVal NewLine As Long)
  'validate position
  Select Case NewLine
  Case Is < 0 'no non-negative values
    On Error GoTo 0: Err.Raise vbObjectError + 518, strErrSource, LoadResString(518)
    Exit Property
  Case Is > mlngCount - 1 'cant point past eor
    On Error GoTo 0: Err.Raise vbObjectError + 519, strErrSource, LoadResString(519)
    Exit Property
  End Select
  
  'set Value for current line
  mlngCurLine = NewLine

  'raise change event
  RaiseEvent Change
End Property


Friend Property Get CurLine() As Long
  'return current line Value
  CurLine = mlngCurLine
  
End Property


Public Sub Sort()
  'sorts the stringlist alphabetically
  Dim lngLine As Long, lngLowLine As Long
  Dim lngCompLine As Long, lngNextLine As Long
  Dim strTemp As String
  
  'step through all items in list
  lngNextLine = 0
  For lngLine = 0 To mlngCount - 2
    'now loop through rest of items
    lngCompLine = lngLine + 1
    lngLowLine = lngLine
    Do Until lngCompLine = mlngCount ' - 1
      If mStringLine(lngCompLine) < mStringLine(lngLowLine) Then
        lngLowLine = lngCompLine
      End If
      lngCompLine = lngCompLine + 1
    Loop
    'now swap strings
    If lngLowLine <> lngLine Then
      strTemp = mStringLine(lngLine)
      mStringLine(lngLine) = mStringLine(lngLowLine)
      mStringLine(lngLowLine) = strTemp
    End If
  Next lngLine
  'raise change event
  RaiseEvent Change
End Sub


Public Property Let StringLine(ByVal Index As Long, NewString As String)
  
  'validate position
  Select Case Index
  Case Is < 0 'no non-negative values
    On Error GoTo 0: Err.Raise vbObjectError + 518, strErrSource, LoadResString(518)
    Exit Property
  Case Is > mlngCount - 1 'cant point past eor
    On Error GoTo 0: Err.Raise vbObjectError + 519, strErrSource, LoadResString(519)
    Exit Property
  End Select

  'set the string
  mStringLine(Index) = NewString
  'raise change event
  RaiseEvent Change
Exit Property

ErrHandler:
  Err.Clear
End Property



Public Property Get StringLine(Optional ByVal Index As Long = -1) As String
Attribute StringLine.VB_UserMemId = 0
Attribute StringLine.VB_MemberFlags = "200"
  
  On Error GoTo ErrHandler
  
  'if current line exceeds limit
  'which can happen if current line was at
  'end of list, and some lines are deleted
  If mlngCurLine > mlngCount - 1 Then
    mlngCurLine = mlngCount - 1
  End If
  
  'if a Value is passed,
  If Index <> -1 Then
    'validate position
    If Index < 0 Or Index > mlngCount - 1 Then
      On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
      Exit Property
    End If
    
'    If LenB(mStringLine(Index)) <> 0 Then
'      Debug.Assert Asc(Right$(mStringLine(Index), 1)) <> 13
'    End If
    
    'set current line to index
    mlngCurLine = Index
  End If
  
  'return string at current line
  StringLine = mStringLine(mlngCurLine)
Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property
Public Property Get Count() As Long

    Count = mlngCount
End Property



Public Sub Delete(ByVal Index As Long)

  Dim i As Integer
  
  'if no lines to delete
  If mlngCount = 0 Then
    lngError = 676
    GoTo ErrHandler
  End If
  
  'if a Value is passed,
  If Index <> -1 Then
    'validate position
    Select Case Index
    Case Is < 0 'no non-negative values
      lngError = 518
      GoTo ErrHandler
    Case Is > mlngCount - 1 'cant point past eor
      lngError = 519
      GoTo ErrHandler
    Case Else
      'line is ok
      mlngCurLine = Index
    End Select
  End If
  
  'delete this string, and re-index
  For i = mlngCurLine To mlngCount - 2  'need to stop at one under ubound(mstringline)
    'copy the line above to the current line
    mStringLine(i) = mStringLine(i + 1)
  Next i
  
  'reduce Count by 1
  mlngCount = mlngCount - 1
  
  'ensure index is updated
  If mlngCurLine > mlngCount - 1 Then
    mlngCurLine = mlngCount - 1
  End If
  'if Count is now zero
  If mlngCount = 0 Then
    ReDim mStringLine(0)
  Else
    'redim array to remove last line
    ReDim Preserve mStringLine(mlngCount - 1)
  End If
  
  'raise change event
  RaiseEvent Change
Exit Sub

ErrHandler:
  Err.Clear
  On Error GoTo 0: Err.Raise vbObjectError + lngError, strErrSource, LoadResString(lngError)
End Sub


Private Sub Class_Initialize()
  strErrSource = "WINAGI.StringList"

End Sub


