VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGIExits"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"AGIExit"
Attribute VB_Ext_KEY = "Member0" ,"AGIExit"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection

Public Function Add(ByVal ID As Long, ByVal Room As Integer, ByVal Reason As EEReason, ByVal Style As Integer, Optional ByVal Transfer As Integer = 0, Optional ByVal Leg As Integer) As AGIExit
  'create a new object
  'only 1-255 are valid ID values
  
  Dim tmpExit As AGIExit
  
  If ID < 1 Or ID > 255 Then
    'error
    On Error GoTo 0: Err.Raise 9, "AGIExits", "Subscript out of range"
    Exit Function
  End If
  
  On Error GoTo ErrHandler
  
  Set tmpExit = New AGIExit

  'set the properties passed into the method
  With tmpExit
    .ID = "LE" & format$(ID, "000")
    .Room = Room
    .Reason = Reason
    .Style = Style
    .Transfer = Transfer
    .Leg = Leg
  End With
  
  mCol.Add tmpExit, tmpExit.ID
  'if error
  If Err.Number = 457 Then
    Err.Clear
    On Error GoTo 0: Err.Raise 457, "AGIExits", "This ExitID is already in use"
    Exit Function
  ElseIf Err.Number <> 0 Then
    'some other error?
    Exit Function
    'exiting will likely cause error in calling function
  End If
  
  'return the object created
  Set Add = tmpExit
  Set tmpExit = Nothing
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub Clear()
  'removes all objects
  
  Dim i As Long
  
  For i = mCol.Count To 1 Step -1
    mCol.Remove i
  Next i
End Sub

Public Property Get Item(ByVal Index As Variant) As AGIExit
Attribute Item.VB_UserMemId = 0
  
  'validate index
  'NOTE: need to convert AGI collection which is zero based
  'to VB collection which is 1 based
  
  'index can be a number, whhich returns the exit with this index number in the collection
  'or a string, which returns the exit with the ID passed as Index
  
  If IsNumeric(Index) Then
    If Index < 0 Or Index > mCol.Count - 1 Then
      On Error GoTo 0: Err.Raise 9, "AGIExits", "Subscript out of range"
      Exit Property
    End If
    
    Set Item = mCol(Index + 1)
  Else
    'if not a string
    If VarType(Index) <> vbString Then
      'error
      On Error GoTo 0: Err.Raise 13, "AGIExits", "Type mismatch"
      Exit Property
    End If
    
    On Error Resume Next
    
    Set Item = mCol(Index)
    
    'if error
    If Err.Number <> 0 Then
      Err.Clear
      On Error GoTo 0: Err.Raise 9, "AGIExits", "Subscript out of range"
      Exit Property
    End If
  End If
End Property
Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection.
    Count = mCol.Count
End Property

Public Sub Remove(Index As Variant)

  'validate index
  'NOTE: need to convert AGI collection which is zero based
  'to VB collection which is 1 based
  
  'if numeric
  If IsNumeric(Index) Then
    If Index < 0 Or Index > mCol.Count - 1 Then
      On Error GoTo 0: Err.Raise 9, "AGIExits", "Subscript out of range"
      Exit Sub
    End If
    
    mCol.Remove Index + 1
  Else
  
    'assume user is deleting by ID
    mCol.Remove Index
  End If
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    
  Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

