Attribute VB_Name = "LZW"
Option Explicit

Private intNextCode As Integer, intCurCodeSize As Integer
Private strCodeValues() As String
Private bytCompData() As Byte, lngBitBuffer As Long
Private intBitCount As Integer
Private bytCelData() As Byte
Private lngInPos As Long, lngOutPos As Long
Private intAppendChar() As Integer, intCodePrefix() As Integer
Private intClearCode As Integer, intEndCode As Integer
Private blnMaxedOut As Boolean

Public Sub ExpandFile(strFileIn As String, Optional intCodeSize As Integer = 5)

  Dim intFreeFile As Integer
  Dim strFileOut As String
  
  On Error GoTo ErrHandler
  
        strFileIn = "C:\Users\d3m294\Documents\output.dat"

  'open input file
  intFreeFile = FreeFile()
  Open strFileIn For Binary As #intFreeFile
  'copy data to input array
  ReDim bytCelData(LOF(intFreeFile) - 1)
  Get #intFreeFile, 1, bytCelData()
  'close input file
  Close #intFreeFile
  
  lngInPos = 0
  lngOutPos = 0
  
  If ExpandLZW(intCodeSize) Then
    MsgBox "Success!"
    
    'resize output buffer to match actual amount of data
    ReDim Preserve bytCompData(lngOutPos - 1)
    
    'store the data in a temporary output file
    strFileOut = "C:\Users\d3m294\Documents\expanded.dat"
    On Error Resume Next
    Kill strFileOut
    On Error GoTo ErrHandler
    
    intFreeFile = FreeFile()
    Open strFileOut For Binary As #intFreeFile
    Put #intFreeFile, 1, bytCompData()
    Close #intFreeFile
    
  Else
    MsgBox "error in compress function :-("
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
  
End Sub


Public Function GifLZW(ByRef bytCelData() As Byte) As Byte()

  Dim lngLen As Long
  
  Dim wSTRING As String, wCHAR As String
  Dim curCode As Integer, oldCode As Integer
  Dim blnCleared As Boolean
  Dim i As Integer, intCodeSize As Integer

  
  
  On Error GoTo ErrHandler
  'intCodeSize is code size; for sixteen colors, initial code size should be 5
  intCodeSize = 5
  
  'make output byte array same size; after compression, we'll shrink it down to min size
  ReDim bytCompData(UBound(bytCelData()))
  
  'reset everything
  lngInPos = 0
  lngOutPos = 0
  
  intCurCodeSize = intCodeSize
  intClearCode = 2 ^ (intCodeSize - 1)
  
  'reserve 'end' code (clear code +1)
  intEndCode = intClearCode + 1
  lngBitBuffer = 0
  intBitCount = 0
  
  'send 'clear' code to output
  WriteCode intClearCode
  
  'set pointer to next available code to end code +1
  intNextCode = intEndCode + 1
  
  'reset code table
  ReDim strCodeValues(2 ^ intCurCodeSize - 1)
  
  'prepopulate with regular characters
  Debug.Assert intClearCode <= 256
  For i = 0 To intClearCode - 1
    strCodeValues(i) = Chr(i)
  Next i
  
  'NOW BEGIN THE COMPRESSION
  
  'get first character
  wSTRING = Chr(bytCelData(0))
  lngInPos = 1
  lngLen = UBound(bytCelData())
  'first code is just the character Value of first byte
  oldCode = bytCelData(0)
  
  Do Until lngInPos > lngLen
    'get next character
    wCHAR = Chr(bytCelData(lngInPos))
    lngInPos = lngInPos + 1
    
    'if the combination of wSTRING+wCHAR is already in the table, then
    'combine them to new wSTRING Value, and get the next character
    'if not, add the code for current sSTRING to output, add new entry to table for wSTRING+wCHAR
    'and reset current wSTRING to single wCHAR
    
    curCode = FindCodeInTable(wSTRING & wCHAR)
    If curCode <> -1 Then
      wSTRING = wSTRING & wCHAR
      oldCode = curCode
    Else
      'output code for wSTRING
      WriteCode oldCode
      
      'add new entry for wSTRING+wCHAR:
      'need to check if table is full, first
      If intNextCode = 2 ^ intCurCodeSize Then
        'increase size IF room (Max codesize is 12 bits)
        If intCurCodeSize < 12 Then
          intCurCodeSize = intCurCodeSize + 1
          
          ReDim Preserve strCodeValues(2 ^ intCurCodeSize - 1)
        Else
          'too big- clear everything; reset to initial code width
          blnCleared = True
          
          'output clear code
          WriteCode intClearCode
          
          'reset code size and code table
          intCurCodeSize = intCodeSize
          ReDim strCodeValues(2 ^ intCurCodeSize - 1)
          For i = 0 To intClearCode - 1
            strCodeValues(i) = Chr(i)
          Next i
          intNextCode = intEndCode + 1
        End If
      End If
      
      'if not resetting,
      If Not blnCleared Then
        'now add new entry for wSTRING+wCHAR
        strCodeValues(intNextCode) = wSTRING & wCHAR
        intNextCode = intNextCode + 1
        
      Else
        'if cleared, write out next char
        'WriteCode curCode
        
        'reset 'reset'
        blnCleared = False
      End If
      
      'reset wSTRING
      wSTRING = wCHAR
      oldCode = Asc(wCHAR)
    End If
  Loop
  
  'output last string code (wSTRING)
  WriteCode oldCode
  
  'output a 'end' code
  WriteCode intEndCode
  
  'if any bits left in buffer, need to add them
  If intBitCount > 0 Then
    'write out last byte
    Debug.Assert intBitCount < 8
    bytCompData(lngOutPos) = CByte(lngBitBuffer)
  End If
  
  ReDim Preserve bytCompData(lngOutPos)
  'if no errors, return compressed array
  GifLZW = bytCompData()
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Function FindCodeInTable(strCodeVal As String) As Integer

  'searches the code table, and returns the code number if strCodeVal is found
  'otherwise returns -1
  
  Dim i As Integer, intMax As Integer
  
  intMax = intNextCode - 1
  
  For i = 0 To intMax
    If strCodeValues(i) = strCodeVal Then
      FindCodeInTable = i
      Exit Function
    End If
  Next i
  
  'not found
  FindCodeInTable = -1
End Function

Private Sub WriteCode(ByVal CodeValue As Integer)

  'adds this codevalue to the output buffer,
  'and writes bytes to the buffer when enough bits are in the buffer
  
  'if necessary, this subroutine will also expand the output data array
  '(I think we can mathematically prove it's not possible for it to get bigger,
  'at least if we start with 9bit codes; but just in case, leave option
  'to expand size of output array if necessary)
  
  'as a reminder, we are using LSB packing:
  '       byte4           byte3           byte2           byte2           byte1           byte0
  ' ... 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0
  '     ... 8 7 6 5 4 3 2 1 0|8 7 6 5 4 3 2 1 0|8 7 6 5 4 3 2 1 0|8 7 6 5 4 3 2 1 0|8 7 6 5 4 3 2 1 0
  '             code4             code3             code2             code1             code0
  
  Dim lngCodeIn As Long, lngByteOut As Long
  
  On Error GoTo ErrHandler
  Debug.Assert CodeValue <= &HFFF
  
  
  'convert code to long
  lngCodeIn = CLng(CodeValue) And &HFFFF&
  
  'if there are already bits in the buffer, shift the code before adding it to the buffer
  If intBitCount Then
    lngCodeIn = SHL(lngCodeIn, intBitCount)
  End If
  
  'add code to the buffer
  lngBitBuffer = lngBitBuffer Or lngCodeIn
  
  'increment bit Count
  intBitCount = intBitCount + intCurCodeSize
  
  'if there are at least eight bits in the buffer, we need to pull off the byte, and add it to output
  Do While intBitCount >= 8
    'get lower 8 bits
    lngByteOut = lngBitBuffer And &HFF&
    
    'convert to a byte, and store in output buffer
    Debug.Assert lngOutPos <= UBound(bytCompData)
    
    If lngOutPos > UBound(bytCompData()) Then
    ReDim Preserve bytCompData(UBound(bytCompData) + 1024)
    End If
    
    bytCompData(lngOutPos) = CByte(lngByteOut)
    'increment output pointer
    lngOutPos = lngOutPos + 1
    
    'shift buffer right by 8 positions
    lngBitBuffer = SHR(lngBitBuffer, 8)
  
    'decrement bit Count
    intBitCount = intBitCount - 8
  Loop
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
  
End Sub

Public Function SHL(ByVal Value As Long, Optional ByVal ShiftAmount As Integer = 1) As Long
  'performs an unsigned shift-left of a four-byte long integer
  'since integers are signed, we need to deal with the highest bit in a different way
  
  Dim lngBit30 As Long
  
  'if shift is zero, return input
  If ShiftAmount = 0 Then
    SHL = Value
    Exit Function
  End If
  
  'shift amount is only valid between 1 and 32
  If ShiftAmount < 1 Then ShiftAmount = 1
  If ShiftAmount > 32 Then ShiftAmount = 32
  'need real error handling here, but not going to worry about it for now
  
  Do
    'strip off bit 31 (it's going away anyway)
    Value = Value And &H7FFFFFFF
    
    'get bit at position 30
    lngBit30 = Value And &H40000000
    'if it's not zero, strip it off as well
    If lngBit30 Then
      Value = Value And &H3FFFFFFF
    End If
    
    'shift by multiplying
    Value = Value * 2
    
    'add bit30 to position 31, if there was a bit30
    If lngBit30 Then
      Value = Value Or &H80000000
    End If
    
    ShiftAmount = ShiftAmount - 1
  Loop Until ShiftAmount = 0
  
  SHL = Value
  
End Function

Public Function SHR(ByVal Value As Long, Optional ByVal ShiftAmount As Integer = 1) As Long
  'performs an unsigned shift-right of a four-byte integer
  'since integers are signed, we need to deal with the highest bit in a different way

  Dim lngBit31 As Long
  
  'shift amount is only valid between 1 and 32
  If ShiftAmount < 1 Then ShiftAmount = 1
  If ShiftAmount > 32 Then ShiftAmount = 32
  'need real error handling here, but not going to worry about it for now
  
  Do
    'save bit 31, then clear it
    lngBit31 = Value And &H80000000
    Value = Value And &H7FFFFFFF
    
    'remove bit 0 (otherwise we get rounding errors)
    Value = Value And &HFFFFFFFE
    
    'shift by dividing
    Value = Value / 2
    
    'add bit31 to position 30, if there was one
    If lngBit31 Then
      Value = Value Or &H40000000
    End If
    
    ShiftAmount = ShiftAmount - 1
  Loop Until ShiftAmount = 0
  
  SHR = Value
End Function


Public Function ExpandLZW(intCodeSize As Integer) As Boolean

  Dim intCode As Integer, intAppendCode As Integer
  
  On Error GoTo ErrHandler
  
  'reset everything
  intCurCodeSize = intCodeSize
  intClearCode = 2 ^ (intCodeSize - 1)
  'reserve 'end' code (clear code +1)
  intEndCode = intClearCode + 1
  'set pointer for next available code
  intNextCode = intEndCode + 1
  lngBitBuffer = 0
  intBitCount = 0
  
  'initialize code tables (values up to clear code are not needed in the tables)
  ReDim intAppendChar(4095 - 2 ^ (intCodeSize - 1) + 1)
  ReDim intCodePrefix(4095 - 2 ^ (intCodeSize - 1) + 1)
  
  'intialize output buffer
  ReDim bytCompData(255)
  
  'get first code
  intCode = GetNextCode()
  
  'verify it's a clear code
  If intCode <> intClearCode Then
    ExpandLZW = False
    Exit Function
  End If
  
  'get next code (first code of actual data)
  intCode = GetNextCode()
  'write it to output
  WriteByte CByte(intCode)
  'store this byte as prefix for first code after the 'end' code
  intCodePrefix(intNextCode - intEndCode - 1) = intCode
  'increment nextcode pointer
  intNextCode = intNextCode + 1
  
  'now read off codes, one at a time
  Do
    intCode = GetNextCode()
    Debug.Assert intCode < &HFFF + 1
    
    'if it's an end code, exit
    If intCode = intEndCode Then
      ExpandLZW = True
      Exit Do
    End If
    
    'if it's a clear code
    If intCode = intClearCode Then
      'need to reset
      blnMaxedOut = False
      intCurCodeSize = intCodeSize
      ReDim intAppendChar(4095 - 2 ^ (intCodeSize - 1) + 1)
      ReDim intCodePrefix(4095 - 2 ^ (intCodeSize - 1) + 1)
      intNextCode = intEndCode + 1
      
      'start over
      intCode = GetNextCode()
      'write it to output
      WriteByte CByte(intCode)
      'store this byte as prefix for first code after the 'end' code
      intCodePrefix(intNextCode - intEndCode - 1) = intCode
      'increment nextcode pointer
      intNextCode = intNextCode + 1
    Else
    
      'if it is a base char,
      If intCode < intEndCode Then
        'just output it to output stream
        WriteByte CByte(intCode)
        intAppendCode = intCode
      Else
          'convert code to string of bytes and write them to output
          'return Value is first character of string, which is needed
          'to build the table entry
          intAppendCode = CLng(OutputCode(intCode))
      End If
      
      'store this byte as prefix for next code
      intCodePrefix(intNextCode - intEndCode - 1) = intCode
      'add this code as append char to previous code
      intAppendChar(intNextCode - intEndCode - 2) = CByte(intAppendCode)
      
      'increment nextcode pointer
      intNextCode = intNextCode + 1
      If intNextCode = 2 ^ intCurCodeSize + 1 Then
        'need to assess potential reset here?
        'if already at 12 bits
        If intCurCodeSize = 12 Then
          'tell compiler no more codes until a reset comes
          blnMaxedOut = True
          'for now, we don't do anything, as we expect the
          'compressor to properly reset before we have this problem
        Else
          intCurCodeSize = intCurCodeSize + 1
        End If
      End If
    End If
    
  Loop Until lngInPos > UBound(bytCelData)
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next

End Function

Private Function OutputCode(ByVal intCodeIn As Integer) As Integer

  Dim bytOutput() As Byte, intPos As Integer
  Dim intCode As Integer, i As Integer
  
  On Error GoTo ErrHandler
  
  'intCode should never be greater than next code Value;
  Debug.Assert intCode <= intNextCode
  
  'need to recurse through code table until we build the completed string of output characters
  
  ReDim bytOutput(0)
  intCode = intCodeIn
  
  Do
    'expand output buffer by one byte
    ReDim Preserve bytOutput(UBound(bytOutput()) + 1)
    'move everything over one space
    For i = UBound(bytOutput()) To 1 Step -1
      bytOutput(i) = bytOutput(i - 1)
    Next i
    
    'get prefix code
    intCode = intCodePrefix(intCode - intEndCode - 1)
    
  
    If intCode < intEndCode Then
      'add this code
      bytOutput(0) = CByte(intCode)
    Else
      'add the prefix
      bytOutput(0) = intAppendChar(intCode - intEndCode - 1)
    End If
    
  Loop Until intCode < intEndCode
  
  'if this code is the next code Value:
  If intCodeIn >= intNextCode Then
   ' Debug.Assert False
  End If
  If intCodeIn = intNextCode - 1 Then
    'end char is same as start char
    bytOutput(UBound(bytOutput())) = bytOutput(0)
  Else
    'add append char for input code
    'Debug.Assert intAppendChar(intCodeIn - intEndCode - 1) <> 0
    bytOutput(UBound(bytOutput())) = intAppendChar(intCodeIn - intEndCode - 1)
  End If
   
  'now output the bytes
  For i = 0 To UBound(bytOutput())
    WriteByte bytOutput(i)
  Next i
  
  'return first char so it can be used in adding table entries
  OutputCode = bytOutput(0)
  
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Sub WriteByte(ByVal ByteVal As Byte)

  'make sure output buffer has room; if not, expand it by 256 bytes
  If lngOutPos > UBound(bytCompData()) Then
    ReDim Preserve bytCompData(UBound(bytCompData()) + 256)
  End If
  
  'add the byte
  bytCompData(lngOutPos) = ByteVal
  'increment pointer
  lngOutPos = lngOutPos + 1
  
End Sub

Public Function GetNextCode() As Integer

  Dim intCodeMask As Integer
  Dim lngNextByte As Long
  
  On Error GoTo ErrHandler
  
  Debug.Assert intCurCodeSize < 13
  
  'add bits to the buffer until enough are added to read out the next code
  Do Until intBitCount >= intCurCodeSize
    'get next byte from input and shift it to end of current bitbuffer
    lngNextByte = SHL(CLng(bytCelData(lngInPos)), intBitCount)
    'increment pointer
    lngInPos = lngInPos + 1
    
    'add byte to buffer
    lngBitBuffer = lngBitBuffer Or lngNextByte
    
    'increment bit counter
    intBitCount = intBitCount + 8
  Loop
  
  'now extract off the code
  intCodeMask = 2 ^ intCurCodeSize - 1
  GetNextCode = lngBitBuffer And intCodeMask
  
  'shift buffer to right
  lngBitBuffer = SHR(lngBitBuffer, intCurCodeSize)
  
  'decrement bit Count
  intBitCount = intBitCount - intCurCodeSize
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function



