VERSION 5.00
Begin VB.UserControl SaveDialog 
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   InvisibleAtRuntime=   -1  'True
   Picture         =   "SaveDialog.ctx":0000
   ScaleHeight     =   32
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   32
   ToolboxBitmap   =   "SaveDialog.ctx":0C42
End
Attribute VB_Name = "SaveDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

  'properties
  Private mstrDefaultExt As String
  Private mstrDialogTitle As String
  Private mstrFullName As String
  Private mstrFileName As String
  Private mstrFilter As String
  Private mlngFilterIndex As Long
  Private mlngFlags As Long
  Private mstrInitDir As String
  Private mlngMaxFileNameSize As Long
  Private mlngMaxFullNameSize As Long
  Private mlnghWndOwner As Long
  Private mblnCancelError As Boolean
  Private mintFileNamePos As Integer
  Private mintExtensionPos As Integer
  Private mblnNoPlaces As Boolean 'if true, hides the Places portion of save window

Public Property Get CancelError() As Boolean
  CancelError = mblnCancelError
End Property

Public Property Let CancelError(ByVal NewValue As Boolean)
  mblnCancelError = NewValue
  PropertyChanged "CancelError"
End Property

Public Property Get DefaultExt() As String
  DefaultExt = mstrDefaultExt
End Property

Public Property Let DefaultExt(ByVal NewVal As String)
  mstrDefaultExt = NewVal
  PropertyChanged "DefaultExt"
End Property

Public Property Get DialogTitle() As String
  DialogTitle = mstrDialogTitle
End Property

Public Property Let DialogTitle(NewValue As String)
  mstrDialogTitle = NewValue
  PropertyChanged "DialogTitle"
End Property

Public Property Get ExtensionPos() As Integer
  ExtensionPos = mintExtensionPos
End Property

Public Property Get FullName() As String
  FullName = mstrFullName
End Property

Public Property Let FullName(ByVal NewValue As String)

  'if exceeds current Max
  If Len(NewValue) > mlngMaxFullNameSize - 1 Then
    'invalid
    On Error GoTo 0: Err.Raise 380, "SaveDialog", "Invalid property Value: exceeds maximum allowable length"
    Exit Property
  End If
  
  mstrFullName = NewValue
  PropertyChanged "FullName"
  
  'reset filename property
  mstrFileName = vbNullString
End Property

Public Property Get FileNamePos() As Integer
  FileNamePos = mintFileNamePos
End Property

Public Property Get FileName() As String
  FileName = mstrFileName
End Property

Public Property Get Filter() As String
  Filter = mstrFilter
End Property

Public Property Let Filter(ByVal NewValue As String)
  mstrFilter = NewValue
  PropertyChanged "Filter"
End Property

Public Property Get FilterIndex() As Long
  FilterIndex = mlngFilterIndex
End Property

Public Property Let FilterIndex(ByVal NewValue As Long)
  mlngFilterIndex = NewValue
  PropertyChanged "FilterIndex"
End Property

Public Property Get Flags() As Long

  Flags = mlngFlags
End Property

Public Property Let Flags(ByVal NewFlags As Long)

  mlngFlags = NewFlags
  
  PropertyChanged "Flags"
End Property

Public Property Get hWndOwner() As Long
  hWndOwner = mlnghWndOwner
End Property

Public Property Let hWndOwner(ByVal NewValue As Long)
  mlnghWndOwner = NewValue
  PropertyChanged "hWndOwner"
End Property

Public Property Get InitDir() As String
  InitDir = mstrInitDir
End Property

Public Property Let InitDir(ByVal NewValue As String)
  mstrInitDir = NewValue
  PropertyChanged "InitDir"
End Property

Public Property Get MaxFileNameSize() As Long
  MaxFileNameSize = mlngMaxFileNameSize
End Property

Public Property Let MaxFileNameSize(ByVal NewValue As Long)
  
  'no negative or zero Value
  If NewValue <= 0 Then
    On Error GoTo 0: Err.Raise 380, "SaveDialog", "Invalid property Value"
    Exit Property
  End If
  
  mlngMaxFileNameSize = NewValue
  PropertyChanged "MaxFileNameSize"
End Property

Public Property Get MaxFullNameSize() As Long
  MaxFullNameSize = mlngMaxFullNameSize
End Property

Public Property Let MaxFullNameSize(ByVal NewVal As Long)

  'no negative or zero Value
  If NewVal <= 0 Then
    On Error GoTo 0: Err.Raise 380, "SaveDialog", "Invalid property Value"
    Exit Property
  End If
  
  mlngMaxFullNameSize = NewVal
  PropertyChanged "MaxFullNameSize"
End Property

Public Property Get NoPlaces() As Boolean
  NoPlaces = mblnNoPlaces
End Property

Public Property Let NoPlaces(ByVal NewValue As Boolean)

  mblnNoPlaces = NewValue
  PropertyChanged "NoPlaces"
End Property
Public Sub ShowSaveAs()
  'displays the dialog box
  
  On Error GoTo ErrHandler
  
  Dim rtn As Long
  Dim bKeyState(255) As Byte
  
  'set filename structure
  With ofn
    .lStructSize = Len(ofn)
    'if this is windows 98
    If (WinVer.dwMajorVersion = 4 And WinVer.dwMinorVersion = 10) Then
      .lStructSize = .lStructSize - 12
    End If
    .hWndOwner = mlnghWndOwner
    .lpstrFilter = Replace(mstrFilter, "|", ChrW$(0)) & ChrW$(0) & ChrW$(0)
    .nFilterIndex = mlngFilterIndex
    .lpstrFile = mstrFullName & ChrW$(0) & Space$(mlngMaxFullNameSize - 1 - Len(mstrFullName))
    .lpstrFileTitle = Space$(mlngMaxFileNameSize)
    .lpstrInitialDir = mstrInitDir & ChrW$(0)
    .nMaxFile = mlngMaxFullNameSize
    .nMaxFileTitle = mlngMaxFileNameSize
    .lpstrTitle = mstrDialogTitle
    .Flags = OFN_ENABLEHOOK Or OFN_ENABLESIZING Or mlngFlags
    .lpfnHook = ByValAddressOf(AddressOf SaveDlgHook)
    .lpstrDefExt = mstrDefaultExt & ChrW$(0)
    .FlagsEx = mblnNoPlaces And OFN_EX_NOPLACESBAR
  End With
  
  'create and show the save dialog
  rtn = GetSaveFileName(ofn)
  
  'NOTE:  If user presses return to close the dialog box
  '       a keyup is generated that is is processed by the
  '       object that called the ShowSaveAs method.
  '       I have not yet figured out how to get that keyup
  '       event cleared/deleted; therefore, the calling object
  '       must be able to handle an unexpected key up event
  '       after calling this method
  
  'if canceled or other error
  If rtn = 0 Then
    On Error Resume Next
    'get error
    rtn = CommDlgExtendedError()
    Select Case rtn
    Case FNERR_BUFFERTOOSMALL
      On Error GoTo 0: Err.Raise vbObjectError + 101, "SaveDialog", "filename exceeds buffer size"
    Case FNERR_FILENAMECODES
      On Error GoTo 0: Err.Raise vbObjectError + 102, "SaveDialog", "file name codes error"
    Case FNERR_INVALIDFILENAME
      On Error GoTo 0: Err.Raise vbObjectError + 103, "SaveDialog", "invalid filename"
    Case FNERR_SUBCLASSFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 104, "SaveDialog", "subclass failure"
    Case CDERR_DIALOGFAILURE
    On Error GoTo 0: Err.Raise vbObjectError + 105, "SaveDialog", "dialog failure"
    Case CDERR_FINDRESFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 106, "SaveDialog", "find res failure"
    Case CDERR_GENERALCODES
      If mblnCancelError Then
        On Error GoTo 0: Err.Raise cdlCancel, "SaveDialog", "Cancel was selected"
      Else
        Exit Sub
      End If
    Case CDERR_INITIALIZATION
      On Error GoTo 0: Err.Raise vbObjectError + 107, "SaveDialog", "initialization"
    Case CDERR_LOADRESFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 108, "SaveDialog", "load res failure"
    Case CDERR_LOADSTRFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 109, "SaveDialog", "load str failure"
    Case CDERR_LOCKRESFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 110, "SaveDialog", "lock res failure"
    Case CDERR_MEMALLOCFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 111, "SaveDialog", "memalloc failure"
    Case CDERR_MEMLOCKFAILURE
      On Error GoTo 0: Err.Raise vbObjectError + 112, "SaveDialog", "memlock failure"
    Case CDERR_NOHINSTANCE
      On Error GoTo 0: Err.Raise vbObjectError + 113, "SaveDialog", "no hinstance"
    Case CDERR_NOHOOK
      On Error GoTo 0: Err.Raise vbObjectError + 114, "SaveDialog", "no hook"
    Case CDERR_NOTEMPLATE
      On Error GoTo 0: Err.Raise vbObjectError + 115, "SaveDialog", "no template"
    Case CDERR_REGISTERMSGFAIL
      On Error GoTo 0: Err.Raise vbObjectError + 116, "SaveDialog", "register msg failure"
    Case CDERR_STRUCTSIZE
      On Error GoTo 0: Err.Raise vbObjectError + 117, "SaveDialog", "struct size error"
    Case Else
      On Error GoTo 0: Err.Raise vbObjectError + 118, "SaveDialog", "unknown savedialog error"
    End Select
    
  Else
    'extract filename variables
    With ofn
      mlngFilterIndex = .nFilterIndex
      mlngFlags = &HFF7FFFDF And .Flags
      If InStr(1, .lpstrFile, ChrW$(0)) <> 0 Then
        mstrFullName = Left$(.lpstrFile, InStr(1, .lpstrFile, ChrW$(0)) - 1)
      Else
        mstrFullName = Trim$(.lpstrFile)
      End If
      mstrFileName = Left$(.lpstrFileTitle, Len(.lpstrFileTitle) - 1)
      mstrFileName = Trim$(mstrFileName)
      mstrFileName = Left$(mstrFileName, Len(mstrFileName) - 1)
      mintFileNamePos = .nFileOffset
      mintExtensionPos = .nFileExtension
    End With
  End If
Exit Sub

ErrHandler:
  
  On Error GoTo 0: Err.Raise vbObjectError + 119, "SaveDialog", "unknown savedialog error"
End Sub

Private Sub UserControl_InitProperties()

  'set default values
  mstrDialogTitle = "Save As"
  mlngMaxFileNameSize = 256
  mlngMaxFullNameSize = 1024
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)

  'can i ignore keys?
End Sub


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

  'read properties
  mstrDefaultExt = PropBag.ReadProperty("DefaultExt", vbNullString)
  mstrDialogTitle = PropBag.ReadProperty("Dialog Title", "Save As")
  mstrFullName = PropBag.ReadProperty("FullName", vbNullString)
  mstrFilter = PropBag.ReadProperty("Filter", vbNullString)
  mlngFilterIndex = PropBag.ReadProperty("FilterIndex", 0)
  mlngFlags = PropBag.ReadProperty("Flags", 0)
  mstrInitDir = PropBag.ReadProperty("InitDir", vbNullString)
  mlngMaxFileNameSize = PropBag.ReadProperty("MaxFileNameSize", 256)
  mlnghWndOwner = PropBag.ReadProperty("hWndOwner", 0)
  mlngMaxFullNameSize = PropBag.ReadProperty("MaxFullNameSize", 1024)
  mblnCancelError = PropBag.ReadProperty("CancelError", False)
  mblnNoPlaces = PropBag.ReadProperty("NoPlaces", False)
End Sub
Private Sub UserControl_Resize()

  'NEVER allow resizing
  UserControl.Width = 32 * Screen.TwipsPerPixelX
  UserControl.Height = 32 * Screen.TwipsPerPixelY
End Sub




Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

  PropBag.WriteProperty "DefaultExt", mstrDefaultExt
  PropBag.WriteProperty "DialogTitle", mstrDialogTitle
  PropBag.WriteProperty "FullName", mstrFullName
  PropBag.WriteProperty "Filter", mstrFilter
  PropBag.WriteProperty "FilterIndex", mlngFilterIndex
  PropBag.WriteProperty "Flags", mlngFlags
  PropBag.WriteProperty "InitDir", mstrInitDir
  PropBag.WriteProperty "MaxFileNameSize", mlngMaxFileNameSize
  PropBag.WriteProperty "hWndOwner", mlnghWndOwner
  PropBag.WriteProperty "MaxFullNameSize", mlngMaxFullNameSize
  PropBag.WriteProperty "CancelError", mblnCancelError
  PropBag.WriteProperty "NoPlaces", mblnNoPlaces
End Sub

