VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBitmap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mDC As Long
Private mBMP As Long
Private mOldObj As Long

Private mHeight As Long
Private mWidth As Long
Private mPlanes As Long
Private mBitCount As Long


Public Property Get BitCount() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  BitCount = mBitCount
End Property

Public Property Get BMP() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  BMP = mBMP
End Property

Public Property Get hDC() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  hDC = mDC
End Property

Public Property Get Height() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  Height = mHeight
End Property

Public Sub NewBMP(ByVal bWidth As Long, ByVal bHeight As Long, ByVal bPlanes As Long, ByVal bBitCount As Long)
  'creates a bitmap from api calls
  
  ' params for the desired bitmap:
  '
  '  width
  '  height
  '  planes (usually always 1)
  '  bits per pixel
  
  'if bitmap already created, raise error
  If mDC <> 0 Then
    Err.Raise vbObjectError + 511, "VBitmap", "Bitmap already initialized"
    Exit Sub
  End If

  On Error GoTo ErrHandler
  
  'create DC
  mDC = CreateCompatibleDC(0)
  
  'if monochrome, use createbitmap
  'if color, use createcompatiblebitmap
  If bBitCount = 1 Then
    'create the bitmap
    mBMP = CreateBitmap(bWidth, bHeight, bPlanes, bBitCount, ByVal (0&))
  Else
    mBMP = CreateCompatibleBitmap(mDC, bWidth, bHeight)
  End If
    
  If mBMP = 0 Then
    'delete the DC
    rtn = DeleteDC(mDC)
    Exit Sub
  End If

  'save old bmp, and select this object into the bitmaps
  mOldObj = SelectObject(mDC, mBMP)
  If mOldObj = 0 Then
    rtn = DeleteObject(mBMP)
    rtn = DeleteDC(mDC)
    mBMP = 0
    mDC = 0
    Exit Sub
  End If

Exit Sub

ErrHandler:
  Err.Clear
End Sub

Public Property Get Planes() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  Planes = mPlanes
End Property

Public Sub ReleaseBMP()

  If mOldObj <> 0 Then
    'reassign original object, and release bitmap
    rtn = SelectObject(mDC, mOldObj)
    rtn = DeleteObject(mBMP)
    rtn = DeleteDC(mDC)
  End If
  
  mDC = 0
  mOldObj = 0
  mBMP = 0
End Sub

Public Property Get Width() As Long
  
  If mOldObj = 0 Then
    Err.Raise vbObjectError + 512, "VBitmap", "Bitmap not initialized"
    Exit Property
  End If
  
  Width = mWidth
End Property

Private Sub Class_Terminate()

  'make sure we release objects if they were assigned,
  ReleaseBMP
End Sub

