VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ViewUndo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'ViewUndo
  Public UDAction As udvActionType
  Public UndoLoop As AGILoop
  Public UDLoopNo As Byte
  Public UndoCel As AGICel
  Public UDCelNo As Byte
  Public OldText As String
  Private mUndoData() As Long
  Private mCelData() As AGIColors

  Public Enum udvActionType
    udvAddLoop
    udvAddCel
    udvDelLoop
    udvDelCel
    udvChangeID
    udvChangeDesc
    udvChangeVDesc
    udvIncHeight
    udvIncWidth
    udvDecHeight
    udvDecWidth
    udvFlipH
    udvFlipV
    udvLine
    udvBox
    udvBoxFill
    udvDraw
    udvErase
    udvPaintFill
    udvMirror
    udvChangeTransCol
    udvPasteLoop
    udvPasteCel
    udvCutSelection
    udvDelSelection
    udvPasteSelection
    udvMoveSelection
    udvClearLoop
    udvClearCel
    udvCutLoop
    udvCutCel
  End Enum

Public Property Get CelData() As AGIColors()
  CelData = mCelData
  
End Property

Public Property Let CelData(ByRef NewData() As AGIColors)
  mCelData = NewData
  
End Property

Public Property Get UndoData(ByVal Index As Long) As Long
  'error checking
  If Index < LBound(mUndoData) Or Index > UBound(mUndoData) Then
    On Error GoTo 0: Err.Raise 9, "ViewUndo", "Subscript out of range"
    Exit Property
  End If
  
  UndoData = mUndoData(Index)
End Property
Public Property Let UndoData(ByVal Index As Long, ByVal NewData As Long)
  'error checking?
  If Index < LBound(mUndoData) Or Index > UBound(mUndoData) Then
    On Error GoTo 0: Err.Raise 9, "ViewUndo", "Subscript out of range"
    Exit Property
  End If
  
  mUndoData(Index) = NewData
End Property

Public Sub ResizeData(ByVal NewSize As Long)

  'validate size
  If NewSize < 0 Then
    On Error GoTo 0: Err.Raise 9, "ViewUndo", "Subscript out of range"
    Exit Sub
  End If
  
  ReDim Preserve mUndoData(NewSize)
End Sub

Private Sub Class_Initialize()
  'set olddata to a single element
  ReDim mUndoData(0)
End Sub

Private Sub Class_Terminate()
  'ensure objects have been released
  Set UndoLoop = Nothing
  Set UndoCel = Nothing
End Sub
