VERSION 5.00
Begin VB.Form frmCharPicker 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Character Selector"
   ClientHeight    =   5955
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   5055
   LinkTopic       =   "Form2"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmCharPicker.frx":0000
   ScaleHeight     =   397
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   337
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Timer tmrCursor 
      Interval        =   500
      Left            =   240
      Top             =   5400
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   345
      Left            =   3825
      TabIndex        =   3
      Top             =   5550
      Width           =   1125
   End
   Begin VB.CommandButton cmdInsert 
      Caption         =   "Insert"
      Height          =   360
      Left            =   2565
      TabIndex        =   2
      Top             =   5550
      Width           =   1125
   End
   Begin VB.PictureBox picInsert 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   360
      Left            =   120
      MouseIcon       =   "frmCharPicker.frx":8082
      MousePointer    =   3  'I-Beam
      ScaleHeight     =   24
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   322
      TabIndex        =   1
      Top             =   5130
      Width           =   4830
   End
   Begin VB.PictureBox picSelect 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   12
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   5055
      Left            =   0
      ScaleHeight     =   337
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   337
      TabIndex        =   0
      Top             =   0
      Width           =   5055
   End
End
Attribute VB_Name = "frmCharPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Cancel As Boolean
Public InsertString As String

Private mX As Single, mY As Single

Private SelX As Byte, SelY As Byte, SelChar As Long
Private SelStart As Long, SelEnd As Long, CursorPos As Long
Private blnCursor As Boolean

Private MakeSel As Boolean, DragSel As Boolean, DragPos As Long
Private Sub AddChar(ByVal intChar As Integer)

  On Error GoTo ErrHandler
  
  'adds a character to the InsertString string
  'at the current cursorpos, and replacing any selection
  
  If SelStart <> SelEnd Then
    'replace the selection with the new char and reset cursor
    InsertString = Left$(InsertString, SelStart) & Chr$(intChar) & Right$(InsertString, Len(InsertString) - SelEnd)
    CursorPos = SelStart + 1
    SelStart = CursorPos
    SelEnd = CursorPos
  Else
    'insert char at cursor position
    InsertString = Left$(InsertString, CursorPos) & Chr$(intChar) & Right$(InsertString, Len(InsertString) - CursorPos)
    CursorPos = CursorPos + 1
    SelStart = CursorPos
    SelEnd = CursorPos
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub DisplaySelText()

  'displays the insert text, highlight any selection, and add cursor if appropriate
  
  Dim i As Long, lngSelLen As Long
  Dim cx As Long, cy As Long, intChar As Integer
  Dim lngROP As Long
  
  'avoid flickering
  SendMessage picInsert.hWnd, WM_SETREDRAW, 0, 0
  
  picInsert.Cls
  
  'if sellength >0 need to invert selection
  lngSelLen = SelEnd - SelStart
  
  'draw each char, one at a time
  For i = 0 To Len(InsertString) - 1
    intChar = Asc(Mid$(InsertString, i + 1, 1))
    cx = intChar Mod 16
    cy = intChar \ 16
    
    If lngSelLen > 0 And i >= SelStart And i < SelEnd Then
      lngROP = SRCINVERT
    Else
      lngROP = SRCCOPY
    End If
    BitBlt picInsert.hDC, i * 17 + 1, 2, 16, 16, frmCharPicker.hDC, cx * 16, cy * 16, lngROP
    
    'if not at end of selection, extend selection past the cursor space
    If (lngROP = SRCINVERT) And ((i + 1) < SelEnd) Then
      picInsert.Line ((i + 1) * 17, 2)-Step(0, 16), vbBlack
    End If
    
  Next i
  
  'refresh
  SendMessage picInsert.hWnd, WM_SETREDRAW, 1, 0
  picInsert.Refresh
  
  'adjust cursor based on mode
  If DragSel Then
    'show the drag cursor at drag point
    picInsert.Line (DragPos * 17 + 1, 0)-Step(0, 19), vbBlack
    
    'disable normal cursor
    tmrCursor.Enabled = False
    
  Else
    'force normal cursor to display
    blnCursor = False
    tmrCursor.Enabled = False
    tmrCursor_Timer
    tmrCursor.Enabled = True
  End If
End Sub

Public Sub DrawGrid()

  'redraw entire charselect grid
  
  Dim i As Long, j As Long, rtn As Long
  
  picSelect.Cls
  
  'draw grid lines
  For i = 1 To 15
    picSelect.Line (i * 21, 0)-(i * 21, 336), &HC0C0C0
    picSelect.Line (0, i * 21)-(336, i * 21), &HC0C0C0
  Next i
  
  'outside border
  picSelect.Line (0, 0)-(336, 336), vbBlack, B
  
  'draw characters
  For j = 0 To 15
    For i = 0 To 15
      Select Case j * 15 + i
      Case 0, 8, 9, 10, 13
        rtn = AlphaBlend(picSelect.hDC, 21 * i + 3, j * 21 + 3, 16, 16, frmCharPicker.hDC, i * 16, j * 16, 16, 16, &H600000)
      Case Else
        rtn = BitBlt(picSelect.hDC, i * 21 + 3, j * 21 + 3, 16, 16, frmCharPicker.hDC, i * 16, j * 16, SRCCOPY)
      End Select
    Next i
  Next j
End Sub

Public Sub SelectChar(ByVal NewX As Byte, ByVal NewY As Byte)

  'first, unselect current char
  picSelect.Line (SelX * 21 + 2, SelY * 21 + 2)-Step(17, 17), vbWhite, B
  
  'set new selected x, y
  SelX = NewX
  SelY = NewY
  picSelect.Line (SelX * 21 + 2, SelY * 21 + 2)-Step(17, 17), &H808080, B
  
  'and select the character
  SelChar = SelY * 16 + SelX
End Sub

Private Sub cmdCancel_Click()

  Cancel = True
  Me.Hide
  
End Sub

Private Sub cmdCancel_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
      cmdCancel.MousePointer = vbCustom
End Sub

Private Sub cmdInsert_Click()

  Cancel = False
  Me.Hide
  
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'if form has focus, shift it to select box
  picSelect.SetFocus
  picSelect_KeyDown KeyCode, Shift
End Sub

Private Sub Form_Load()

  'always draw chars on grid
  DrawGrid
  
  'select char 1
  SelectChar 1, 0
  
  'assume cancel until OK is chosen
  Cancel = True
End Sub

Private Sub picInsert_GotFocus()

  'draw a line around the box?
  picInsert.BorderStyle = 1
  picInsert.Move 8, 342
End Sub

Private Sub picInsert_KeyDown(KeyCode As Integer, Shift As Integer)

  Dim blnUpdate As Boolean
  
  On Error GoTo ErrHandler
  
  Select Case Shift
  Case 0
    Select Case KeyCode
    Case vbKeyRight
      'if there is a selection, collapse to right
      If SelStart <> SelEnd Then
        CursorPos = SelEnd
        SelStart = SelEnd
        blnUpdate = True
      Else
        'move cursor one place to right
        If CursorPos < Len(InsertString) Then
          CursorPos = CursorPos + 1
          SelStart = CursorPos
          SelEnd = CursorPos
          blnUpdate = True
        End If
      End If
      
    Case vbKeyLeft
      'if there is a selection, collapse to left
      If SelStart <> SelEnd Then
        CursorPos = SelStart
        SelEnd = SelStart
        blnUpdate = True
      Else
        'move cursor one place to left
        If CursorPos > 0 Then
          CursorPos = CursorPos - 1
          SelStart = CursorPos
          SelEnd = CursorPos
          blnUpdate = True
        End If
      End If
    Case vbKeyDelete
      If SelStart <> SelEnd Then
        'delete the selection, and collapse to start
        InsertString = Left$(InsertString, SelStart) & Right$(InsertString, Len(InsertString) - SelEnd)
        CursorPos = SelStart
        SelEnd = SelStart
        blnUpdate = True
      Else
        'delete char after cursor, cursor stays the same
        If CursorPos < Len(InsertString) Then
          InsertString = Left$(InsertString, CursorPos) & Right$(InsertString, Len(InsertString) - CursorPos - 1)
          blnUpdate = True
        End If
      End If
    
    Case Else
      Exit Sub
    End Select
    
  Case vbShiftMask
    Select Case KeyCode
    Case vbKeyRight
      'if there is a selection,
      'expand or shrink depending on cursorpos
      If SelStart <> SelEnd Then
        If CursorPos = SelStart Then
          'shrink the selection
          Debug.Assert CursorPos < Len(InsertString) - 1
          CursorPos = CursorPos + 1
          SelStart = CursorPos
          blnUpdate = True
        Else
          'expand the selection if there is room
          If CursorPos < Len(InsertString) Then
            CursorPos = CursorPos + 1
            SelEnd = CursorPos
            blnUpdate = True
          End If
        End If
      Else
        'expand the selection if there is room
        If CursorPos < Len(InsertString) - 1 Then
          CursorPos = CursorPos + 1
          SelEnd = CursorPos
          blnUpdate = True
        End If
      End If
      
    Case vbKeyLeft
      'if there is a selection,
      'expand or shrink depending on cursorpos
      If SelStart <> SelEnd Then
        If CursorPos = SelEnd Then
          'shrink the selection
          Debug.Assert CursorPos > 0
          CursorPos = CursorPos - 1
          SelEnd = CursorPos
          blnUpdate = True
        Else
          'expand the selection if there is room
          If CursorPos > 0 Then
            CursorPos = CursorPos - 1
            SelStart = CursorPos
            blnUpdate = True
          End If
        End If
      Else
        'expand the selection if there is room
        If CursorPos > 0 Then
          CursorPos = CursorPos - 1
          SelStart = CursorPos
          blnUpdate = True
        End If
      End If
      
    Case Else
      Exit Sub
    End Select
  End Select
  
  'did anything change?
  If blnUpdate Then
    DisplaySelText
    KeyCode = 0
    Exit Sub
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picInsert_KeyPress(KeyAscii As Integer)

  Dim blnUpdate As Boolean
  
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 8
    'backspace
    If SelStart <> SelEnd Then
      'delete the selection, and collapse to start
      InsertString = Left$(InsertString, SelStart) & Right$(InsertString, Len(InsertString) - SelEnd)
      CursorPos = SelStart
      SelEnd = SelStart
      blnUpdate = True
      
    Else
      'delete char in front of cursor, and move cursor
      If CursorPos > 0 Then
        InsertString = Left$(InsertString, CursorPos - 1) & Right$(InsertString, Len(InsertString) - CursorPos)
        CursorPos = CursorPos - 1
        SelStart = CursorPos
        SelEnd = CursorPos
        blnUpdate = True
      End If
    End If
    
  Case Is < 31, Is > 254
    'do nothing
  Case Else
    'add the character
    AddChar KeyAscii
    blnUpdate = True
  End Select
  
  'did anything change?
  If blnUpdate Then
    DisplaySelText
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
  
End Sub


Private Sub picInsert_LostFocus()

  picInsert.BorderStyle = 0
'  picInsert.Move picInsert.Left + 2, picInsert.Top + 2
  picInsert.Move 10, 344
End Sub

Private Sub picInsert_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  Dim CurX As Integer
  
  'only care about left button
  If Button <> vbLeftButton Then
    Exit Sub
  End If
  
  'use empirical offset to get best rounding
  'to determine which position was clicked
  CurX = (X + 1) / 17
  
  'limit cursor position to allowable values
  If CurX < 0 Then CurX = 0
  If CurX > Len(InsertString) Then CurX = Len(InsertString)
  
  'if in a selection, drag
  If CurX >= SelStart And CurX < SelEnd Then
    DragSel = True
  
  'otherwise, make a new selection
  Else
    
    'put cursor at this spot
    CursorPos = CurX
    SelStart = CurX
    SelEnd = CurX
    DisplaySelText
    'enable mouse selection
    MakeSel = True
    tmrCursor = False
    Exit Sub
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
    
End Sub

Private Sub picInsert_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  Dim CurX As Integer
  
  'use empirical offset to get best rounding
  'to determine which position was clicked
  CurX = (X + 1) / 17
  
  'limit cursor position to allowable values
  If CurX < 0 Then CurX = 0
  If CurX > Len(InsertString) Then CurX = Len(InsertString)
    
  Select Case Button
  Case 0
    'if no button, adjust mouse pointer
    
    If SelStart <> SelEnd Then
      If CurX >= SelStart And CurX < SelEnd Then
        picInsert.MousePointer = vbArrow
      Else
        picInsert.MousePointer = vbIbeam
      End If
    Else
      picInsert.MousePointer = vbIbeam
    End If
      
    Exit Sub
    
  Case vbLeftButton
    'if selecting, adjust selection as appropriate
    If MakeSel Then
      If CurX < CursorPos Then
        SelStart = CurX
        SelEnd = CursorPos
      Else
        SelStart = CursorPos
        SelEnd = CurX
      End If
      DisplaySelText
    End If
    
    'if dragging, show drag cursor
    If DragSel Then
      'if moving, show a cursor?
      picInsert.MousePointer = vbCustom
      
      'position drag point
      DragPos = CurX
      
      'redraw the text box
      DisplaySelText
      
    End If
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picInsert_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  Dim CurX As Integer, strSel As String
  
  'use empirical offset to get best rounding
  'to determine which position was clicked
  CurX = (X + 1) / 17
  
  'limit cursor position to allowable values
  If CurX < 0 Then CurX = 0
  If CurX > Len(InsertString) Then CurX = Len(InsertString)
    
  'if selecting, stop selecting
  If MakeSel Then
    MakeSel = False
    tmrCursor.Enabled = True
    Exit Sub
  End If
  
  'if dragging, finish the drag
  If DragSel Then
    DragSel = False
    
    Debug.Assert SelStart <> SelEnd
    Debug.Assert CurX = DragPos
    
    'if cursor is within selection, do nothing
    If CurX >= SelStart And CurX < SelEnd Then
      'show the arrow cursor
      picInsert.MousePointer = vbArrow
      
    Else
      'drop the selected text at drag pos
      If DragPos < SelStart Then
        InsertString = Left(InsertString, DragPos) & Mid$(InsertString, SelStart + 1, SelEnd - SelStart) & Mid$(InsertString, DragPos + 1, SelStart - DragPos) & Right$(InsertString, Len(InsertString) - SelEnd)
        CursorPos = DragPos + SelEnd - SelStart
        SelStart = CursorPos
        SelEnd = CursorPos
      Else
        InsertString = Left(InsertString, SelStart) & Mid$(InsertString, SelEnd + 1, DragPos - SelEnd) & Mid$(InsertString, SelStart + 1, SelEnd - SelStart) & Right$(InsertString, Len(InsertString) - DragPos)
        CursorPos = DragPos
        SelStart = CursorPos
        SelEnd = CursorPos
      End If
      DisplaySelText
      
      'restore cursor
      picInsert.MousePointer = vbIbeam
    End If
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picSelect_DblClick()

  Dim intChar As Integer
  Dim CurX As Long, CurY As Long
  
  'get current pos based on mouse location
  CurX = mX \ 21
  CurY = mY \ 21
  
  If CurX < 0 Then CurX = 0
  If CurX > 15 Then CurX = 15
  If CurY < 0 Then CurY = 0
  If CurY > 15 Then CurY = 15
  
  intChar = CurX + CurY * 16
  
  'set cursor to nodrop if on char 0
  Select Case intChar
  Case 0, 8, 9, 10, 13
    Exit Sub
  Case Else
    SelectChar CurX, CurY
    AddChar intChar
    DisplaySelText
  End Select
  
End Sub

Private Sub picSelect_GotFocus()

  'outside border
  picSelect.Line (0, 0)-(336, 336), vbBlack, B

End Sub

Private Sub picSelect_KeyDown(KeyCode As Integer, Shift As Integer)

  Dim CurX As Long, CurY As Long
  
  Select Case Shift
  Case 0
    Select Case KeyCode
    Case vbKeyUp
      If SelY = 0 Then
        Exit Sub
      End If
      CurY = SelY - 1
      CurX = SelX
      
    Case vbKeyDown
      If SelY = 15 Then
        Exit Sub
      End If
      CurY = SelY + 1
      CurX = SelX
      
    Case vbKeyRight
      If SelX = 15 Then
        Exit Sub
      End If
      CurX = SelX + 1
      CurY = SelY
      
    Case vbKeyLeft
      If SelX = 0 Then
        Exit Sub
      End If
      CurX = SelX - 1
      CurY = SelY
      
    Case Else
      Exit Sub
    End Select
    
    'do not select 0,8,9,10,13
    If CurY = 0 Then
      Select Case CurX
      Case 0, 8, 9, 10, 13
        Exit Sub
      End Select
    End If
    SelectChar CurX, CurY
    
  End Select
End Sub

Private Sub picSelect_KeyPress(KeyAscii As Integer)

  If KeyAscii = 13 Then
'''    'same as dbl click, but with selection, not current
'''    frmMain.EditChar SelY * 16 + SelX
'''    frmMain.SetFocus
  End If
  
  
End Sub

Private Sub picSelect_LostFocus()

  'outside border
  picSelect.Line (0, 0)-(336, 336), &HC0C0C0, B
End Sub

Private Sub picSelect_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  'save current position, to use in dblclick
  mX = X
  mY = Y
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picSelect_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  Dim intChar As Integer
  Dim CurX As Long, CurY As Long
  
  'ignore mouse down events
  If Button <> 0 Then
    Exit Sub
  End If
  
  'get current pos based on mouse location
  CurX = X \ 21
  CurY = Y \ 21
  
  If CurX < 0 Then CurX = 0
  If CurX > 15 Then CurX = 15
  If CurY < 0 Then CurY = 0
  If CurY > 15 Then CurY = 15
  
  intChar = CurX + CurY * 16
  
  'set cursor to nodrop if on char 0
  Select Case intChar
  Case 0, 8, 9, 10, 13
    Me.MousePointer = vbNoDrop
  Case Else
    Me.MousePointer = vbDefault
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picSelect_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  Dim intChar As Integer
  Dim CurX As Long, CurY As Long
  
  'only left-clicks mouse down events
  If Button <> 1 Then
    Exit Sub
  End If
  
  'get current pos based on mouse location
  CurX = X \ 21
  CurY = Y \ 21
  
  If CurX < 0 Then CurX = 0
  If CurX > 15 Then CurX = 15
  If CurY < 0 Then CurY = 0
  If CurY > 15 Then CurY = 15
  
  intChar = CurX + CurY * 16
  
  'set cursor to nodrop if on char 0
  Select Case intChar
  Case 0, 8, 9, 10, 13
    Exit Sub
  Case Else
    SelectChar CurX, CurY
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
  
End Sub

Private Sub tmrCursor_Timer()

  'if no selection, flash the cursor
  If SelStart = SelEnd Then
    blnCursor = Not blnCursor
    If blnCursor Then
      'turn it on
      picInsert.Line (CursorPos * 17 + 1, 0)-Step(0, 19), vbBlack
    Else
      'turn it off
      picInsert.Line (CursorPos * 17 + 1, 0)-Step(0, 19), vbWhite
    End If
  End If
End Sub


