VERSION 5.00
Begin VB.Form frmEditDescription 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Edit ID and Description"
   ClientHeight    =   3195
   ClientLeft      =   30
   ClientTop       =   330
   ClientWidth     =   3300
   Icon            =   "frmEditDescription.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   3300
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtID 
      Height          =   285
      Left            =   30
      TabIndex        =   1
      Top             =   300
      Width           =   1800
   End
   Begin VB.CheckBox chkUpdate 
      Caption         =   "Update Logics"
      Height          =   255
      Left            =   1905
      TabIndex        =   2
      Top             =   300
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   1860
      TabIndex        =   6
      Top             =   2820
      Width           =   1185
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   255
      TabIndex        =   5
      Top             =   2820
      Width           =   1185
   End
   Begin VB.TextBox txtDescription 
      Height          =   1845
      Left            =   30
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   885
      Width           =   3240
   End
   Begin VB.Label lblID 
      Caption         =   "&Resource ID:"
      Height          =   270
      Left            =   135
      TabIndex        =   0
      Top             =   60
      Width           =   2025
   End
   Begin VB.Label lblDescription 
      Caption         =   "&Description:"
      Height          =   270
      Left            =   135
      TabIndex        =   3
      Top             =   645
      Width           =   2025
   End
End
Attribute VB_Name = "frmEditDescription"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Canceled As Boolean
Dim SelCtrl As Long '0=none, 1=ID, 2=description

Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Public Sub SetMode(ByVal EWMode As AGIResType, ByVal OldID As String, ByVal OldDescription As String, ByVal InGame As Boolean, ByVal FirstProp As Long)
  'configures the form to the desired edit mode
  
  Select Case EWMode
  Case rtLogic, rtPicture, rtView, rtSound
    'if in game, show the 'change in logics' checkbox
    If InGame Then
      txtID.Width = 1800
      chkUpdate.Visible = True
      chkUpdate.Value = DefUpdateVal
    Else
      txtID.Width = 3420
      chkUpdate.Visible = False
    End If
    
  Case rtWords, rtObjects 'words and objects
    'hide resource ID text box
    txtID.Visible = False
    lblID.Visible = False
    'move desc box up and resize
    lblDescription.Top = lblID.Top
    txtDescription.Height = txtDescription.Height + txtDescription.Top - txtID.Top
    txtDescription.Top = txtID.Top
    
    If EWMode = rtObjects Then
      Caption = "Edit OBJECT Description"
    Else
      Caption = "Edit WORDS.TOK Description"
    End If
  End Select
  
  'insert old values
  txtDescription.Text = OldDescription
  txtID.Text = OldID
  
  'if NOT in a game
  If Not InGame Then
    'disable id, select description
    txtID.Enabled = False
    SelCtrl = 2
  Else
    'select ID/description based on firstprop val
    SelCtrl = FirstProp
  End If
End Sub


Private Sub cmdCancel_Click()
  Canceled = True
  Hide
End Sub

Private Sub cmdOK_Click()
  Canceled = False
  Hide
End Sub

Private Sub Form_Activate()

  'when ever activated, set focus to correct
  'property based on SelCtrl Value
    
  Select Case SelCtrl
  'Case 0
    'no action taken
  Case 1
    'select id
    With txtID
      .SelStart = 0
      .SelLength = Len(.Text)
      .SetFocus
    End With
  
  Case 2
    With txtDescription
      .SelStart = 0
      .SelLength = Len(.Text)
      .SetFocus
    End With
  End Select

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'check for help key
  If Shift = 0 And KeyCode = vbKeyF1 Then
    If ActiveControl Is txtDescription Then
      'help with description
      HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Managing Resources.htm#descriptions"
    Else
      'help with ID
      HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Managing Resources.htm#resourceids"
    End If
    KeyCode = 0
  End If
End Sub


Private Sub txtDescription_Change()

  'after any change, enable OK button
'  cmdOK.Enabled = True
End Sub

Private Sub txtID_Change()
  'blank ID not allowed
  cmdOK.Enabled = (LenB(txtID.Text) <> 0)
End Sub


Private Sub txtID_KeyPress(KeyAscii As Integer)

  'some characters not allowed:
  '  {space} ',"()/?\|{}[]*&-+=^#`~:;<>
  Select Case KeyAscii
  Case 32, 34, 35, 38, 39, 40, 41, 42, 43, 44, 45, 47, 58, 59, 60, 61, 62, 63, 91, 92, 93, 94, 96, 123, 124, 125, 126
    KeyAscii = 0
  End Select
End Sub

