VERSION 5.00
Begin VB.Form frmPalette 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Modify Color Palette"
   ClientHeight    =   4800
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5025
   Icon            =   "frmPalette.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4800
   ScaleWidth      =   5025
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   2505
      TabIndex        =   2
      Top             =   3390
      Width           =   1185
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   1110
      TabIndex        =   1
      Top             =   3390
      Width           =   1185
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "&Load NAGI Palette"
      Height          =   390
      Left            =   2670
      TabIndex        =   4
      Top             =   270
      Width           =   1995
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save NAGI Palette"
      Height          =   390
      Left            =   2670
      TabIndex        =   5
      Top             =   877
      Width           =   1995
   End
   Begin VB.PictureBox picPalette 
      DrawWidth       =   2
      FillStyle       =   0  'Solid
      Height          =   1935
      Left            =   120
      ScaleHeight     =   125
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   125
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   120
      Width           =   1935
   End
   Begin VB.PictureBox picColChange 
      Height          =   435
      Left            =   1905
      ScaleHeight     =   375
      ScaleWidth      =   915
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   2445
      Width           =   975
   End
   Begin VB.CommandButton cmdDefColors 
      Caption         =   "&Restore Default Palette"
      Height          =   390
      Left            =   2670
      TabIndex        =   6
      Top             =   1485
      Width           =   1995
   End
   Begin VB.CommandButton cmdColorDlg 
      Caption         =   "..."
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2895
      TabIndex        =   9
      Top             =   2490
      Width           =   315
   End
   Begin VB.Label Label33 
      Alignment       =   1  'Right Justify
      Caption         =   "AGI Default:"
      Height          =   210
      Left            =   735
      TabIndex        =   7
      Top             =   2550
      Width           =   1035
   End
   Begin VB.Label lblCurCol 
      Caption         =   "Current Color"
      Height          =   240
      Left            =   3375
      TabIndex        =   10
      Top             =   2535
      Width           =   1350
   End
   Begin VB.Label Label35 
      Caption         =   "NOTE: You will have to close and re-open picture and view editors to apply a new palette."
      Height          =   435
      Left            =   60
      TabIndex        =   0
      Top             =   4320
      Width           =   4890
   End
End
Attribute VB_Name = "frmPalette"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private SelColor As Long
Private lngDefCol(15) As Long
Private strColName(15) As String
Private lngTempCol(15) As Long
Private FormMode As Long ' 0 = palette mode; 1 = prevwin bkgd color mode

Private Sub LoadPalette(ByVal LoadFile As String)

  'opens the load file, and finds the palette section
  'the file should be a NAGI.ini file
  
  Dim intFile As Integer, Index As Long
  Dim i As Long, strLine As String
  Dim blnFound As Boolean, strValues() As String
  
  On Error Resume Next
  intFile = FreeFile()
  Open LoadFile For Input As intFile
  If Err.Number <> 0 Then
    MsgBox "Unable to open this file. Try another one.", vbCritical + vbOKOnly, "Load Palette Error"
    Exit Sub
  End If
  
  On Error GoTo ErrHandler
  
  'load lines until palette found
  Do
    Line Input #intFile, strLine
    
    If LCase$(strLine) = "[palette]" Then
      'found it!
      blnFound = True
      Exit Do
    End If
  Loop Until EOF(intFile)
  
  If Not blnFound Then
    'no palette
    MsgBox "This file does not contain a NAGI palette entry. Try another file.", vbInformation + vbOKOnly, "Load Palette Error"
    Exit Sub
  End If
  
  'load colors, one at a time
  Do
    'get next line
    Line Input #intFile, strLine
    strLine = Trim$(strLine)
    
    'avoid error with blank line, by using single space
    If strLine = vbNullString Then strLine = ";"
    
    'action depends on ascii Value of line
    Select Case Asc(strLine)
    Case 91  '[ == starting another section
      Exit Do
    Case 59 '; == comment; ignore line
    
    Case 99  'c == probably  a color line
      'if this is a color line
      If Left$(strLine, 6) = "color" Then
        'strip off color
        strLine = Right$(strLine, Len(strLine) - 6)
        'get color index val
        Index = CLng(Val(strLine))
        
        'strip off only stuff past equal sign
        strValues = Split(strLine, "=")
        
        'should be two elements
        If UBound(strValues) = 1 Then
          'replace '0x' with '&H'
          strValues(1) = Replace(strValues(1), "0x", "&H")
          'split into three values
          strValues = Split(Trim$(strValues(1)), ",")
          
          'now, should be three elements
          If UBound(strValues) = 2 Then
            'each element should be in hex (0x00) format
            If Left$(strValues(0), 2) = "&H" And _
               Left$(strValues(1), 2) = "&H" And _
               Left$(strValues(2), 2) = "&H" Then
              'build color Value by using hex values
              lngTempCol(Index) = Val(strValues(2)) * &H10000 + _
                                  Val(strValues(1)) * &H100& + _
                                  Val(strValues(0))
            End If 'values start '&H'
          End If  'three values
        End If  'correct assignment to color line
      End If  'valid color entry
              
    Case Else ' what the heck is going on; just ignore
    End Select
      
  Loop Until EOF(intFile)
  
  'close the file
  Close intFile
  
  'force update of color grid
  picPalette_Paint
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub SavePalette(ByVal SaveFile As String)

  'saves color palette to nagi.ini file
  
  'opens the load file, and finds the palette section
  'the file should be a NAGI.ini file
  
  Dim intFile1 As Integer, intFile2 As Integer
  Dim blnFound As Boolean
  Dim i As Long, strLine As String
  Dim strTempFile As String
  
  'open the save file
  On Error Resume Next
  intFile1 = FreeFile()
  Open SaveFile For Input As intFile1
  If Err.Number <> 0 Then
    MsgBox "Unable to open this file. Try another one.", vbCritical + vbOKOnly, "Save Palette Error"
    Close intFile1
    Exit Sub
  End If
  
  'open temp file
  strTempFile = TempFileName()
  intFile2 = FreeFile()
  Open strTempFile For Output As intFile2
  
  If Err.Number <> 0 Then
    MsgBox "Unable to save to this file. Try another one.", vbCritical + vbOKOnly, "Save Palette Error"
    Close intFile1, intFile2
    Exit Sub
  End If
  
  On Error GoTo ErrHandler
  'transfer lines to new file, skipping palette section
  Do
    Line Input #intFile1, strLine
    
    If blnFound Then
      'check for start of another section
      If Trim$(strLine) = vbNullString Then
      ElseIf Asc(Trim$(strLine)) = 91 Then
        'start of another section
        blnFound = False
      End If
    Else
      If LCase$(strLine) = "[palette]" Then
        'found it!
        blnFound = True
      End If
    End If
    
    'now add line IF not in palette section
    If Not blnFound Then
      'add it to new file
      Print #intFile2, strLine
    End If
    
  Loop Until EOF(intFile1)
  
  'done with original file
  Close intFile1
  
  'now build new palette section
  Print #intFile2, "[palette]"
  Print #intFile2, ";palette option allows you to change the colors used by NAGI"
  Print #intFile2, ";default colors are used if a color is not defined"
  Print #intFile2, ";define colors as three hexadecimal values, representing"
  Print #intFile2, ";red, green, blue components"

  'add color lines
  For i = 0 To 15
    strLine = "color" & CStr(i) & "=" & "0x" & Hex2(lngTempCol(i) And &HFF&) & "," & _
                                   "0x" & Hex2((lngTempCol(i) And &HFF00&) \ &H100&) & "," & _
                                   "0x" & Hex2(lngTempCol(i) \ &H10000)
    
    Print #intFile2, strLine
  Next i
  Print #intFile2, , vbNullString
  'done with the temp file
  Close #intFile2
  
  'now copy temp file to desired file
  On Error Resume Next
  Kill SaveFile
  FileCopy strTempFile, SaveFile
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub SetPWBCMode()

  'changes form to show PreviewWindow Bkgd Color Change dialog
  '(default is to change color palette)
  
  On Error GoTo ErrHandler
  
  FormMode = 1
  Me.Width = 2265
  Me.Height = 3675
  Me.Caption = "New Bkgd Color:"
  cmdOK.Top = 2680
  cmdOK.Left = 150
  cmdOK.Width = 870
  cmdOK.Default = True
  cmdCancel.Top = 2680
  cmdCancel.Left = 1170
  cmdCancel.Width = 870
  cmdCancel.Cancel = True
  cmdColorDlg.Caption = "Reset to Default"
  cmdColorDlg.FontBold = False
  cmdColorDlg.Left = 150
  cmdColorDlg.Width = 1890
  cmdColorDlg.Top = 2245
  
  
  Label33.Visible = False
  picColChange.Visible = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub cmdCancel_Click()

  'just unload the settings form
  Unload Me
  
  'if in palette mode, show property form
  If FormMode = 0 Then
    frmGameProperties.Show vbModal, frmMDIMain
  End If
End Sub

Private Sub cmdColorDlg_Click()

  'show color dialog
    
  On Error GoTo ErrHandler
  
  Select Case FormMode
  Case 0 'palette change
    With MainDialog
      .DialogTitle = "Choose New AGI Palette Color"
      .Color = lngTempCol(SelColor)
          
      .Flags = cdlCCRGBInit Or cdlCCFullOpen
      .ShowColor
      
      lngTempCol(SelColor) = .Color
      
      'update picture
      picPalette_Paint
      picColChange_Paint
    End With
    picPalette.SetFocus
  
  Case 1 'change prevwin bkgd color
    PrevWinBColor = &H8000000F
    'hide the form by canceling
    cmdCancel_Click
  End Select
Exit Sub

ErrHandler:
  'if canceling,
  If Err.Number = cdlCancel Then
    Exit Sub
  End If
    
  Debug.Assert False
  Resume Next
End Sub


Private Sub cmdDefColors_Click()

  Dim i As Long
  
  For i = 0 To 15
    lngTempCol(i) = lngDefCol(i)
  Next i
  
  picPalette_Paint
End Sub

Private Sub cmdLoad_Click()

  'get a file name
  
  On Error GoTo ErrHandler
  
  'show dialog
  With MainDialog
    .Flags = cdlOFNHideReadOnly + cdlOFNFileMustExist
    .DialogTitle = "Open NAGI INI File"
    .DefaultExt = "ini"
    .Filter = "INI files (*.ini)|*.ini|All files (*.*)|*.*"
    .FilterIndex = 1
    .FileName = vbNullString
    .InitDir = DefaultResDir
    
    .ShowOpen
  
    'load this file
    LoadPalette .FileName
    
    DefaultResDir = JustPath(.FileName)
  End With
Exit Sub

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Sub
  End If
  
  Debug.Assert False
  Resume Next
End Sub

Private Sub cmdOK_Click()

  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'hide form and set colors
  Me.Hide
  
  'action depends on mode
  Select Case FormMode
  Case 0 'palette change mode
    'set new colors
    For i = 0 To 15
      EGAColor(i) = lngTempCol(i)
      lngEGACol(i) = lngTempCol(i)
      'and write them to settings list
      WriteAppSetting SettingsList, sCOLORS, "Color" & CStr(i), "&H" & Hex(EGAColor(i))
    Next i
  
    'show property form
    frmGameProperties.Show vbModal, frmMDIMain
    
  Case 1  'change prev window background color
    PrevWinBColor = EGAColor(SelColor)
    
  End Select
  
  'unload the palette form
  Unload Me
  
Exit Sub
 
ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub cmdSave_Click()
 
  On Error GoTo ErrHandler
  
  'set up commondialog
  'show dialog
  With MainDialog
    .Flags = cdlOFNHideReadOnly + cdlOFNFileMustExist
    .DialogTitle = "Save to NAGI INI File"
    .DefaultExt = "ini"
    .Filter = "INI files (*.ini)|*.ini|All files (*.*)|*.*"
    .FilterIndex = 1
    .FileName = vbNullString
    .InitDir = DefaultResDir
    
    .ShowSave
  
    'save this palette
    SavePalette .FileName
    
    DefaultResDir = JustPath(.FileName)
  End With
  
Exit Sub

ErrHandler:
  'if NOT canceled,
  If Err.Number <> cdlCancel Then
    Debug.Assert False
    Resume Next
  End If
End Sub

Private Sub Form_Load()

  Dim i As Long
  
  'colors
  For i = 0 To 15
    lngTempCol(i) = EGAColor(i)
  Next i

  'create default palette colors
  lngDefCol(0) = 0&         'black
  lngDefCol(1) = &HA00000   'blue
  lngDefCol(2) = &HA000&    'green
  lngDefCol(3) = &HA0A000     'cyan
  lngDefCol(4) = &HA0&   'red
  lngDefCol(5) = &HA00080   'magenta
  lngDefCol(6) = &H50A0     'brown
  lngDefCol(7) = &HA0A0A0   'light gray
  lngDefCol(8) = &H505050   'dark gray
  lngDefCol(9) = &HFF5050   'light blue
  lngDefCol(10) = &H50FF00    'light green
  lngDefCol(11) = &HFFFF50  'light cyan
  lngDefCol(12) = &H5050FF  'light red
  lngDefCol(13) = &HFF50FF  'light magenta
  lngDefCol(14) = &H50FFFF  'yellow
  lngDefCol(15) = &HFFFFFF  'white
End Sub

Private Sub picColChange_Paint()

  'draw the current color and the default color in the change box
  With picColChange
    picColChange.Line (0, 0)-Step(.Width / 2 - 30, .Height), lngDefCol(SelColor), BF
    picColChange.Line (.Width / 2 - 30, 0)-(.Width, .Height), lngTempCol(SelColor), BF
    picColChange.Line (.Width / 2 - 30, 0)-Step(0, .Height), vbBlack
  End With
  
End Sub


Private Sub picPalette_DblClick()

  Select Case FormMode
  Case 0
    'if in palette mode, then dblclick automatically edit this color...
    cmdColorDlg_Click
    
  Case 1
    'if in change prevwin bkgd color mode, dblclick selects and closes
    cmdOK_Click
  End Select
  
End Sub

Private Sub picPalette_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'select a color, based on cursor pos
  Dim sngRow As Single, sngCol As Single
  Dim intRow As Integer, intCol As Integer
  
  On Error GoTo ErrHandler
  
  'check if inside left/top margin
  If X < 5 Or Y < 5 Then
    Exit Sub
  End If
  
  'convert x,y to row/col
  sngRow = (Y - 5) / 30
  sngCol = (X - 5) / 30
  intRow = Int(sngRow)
  intCol = Int(sngCol)
  
  'if either element exceeds more than .8333
  'then cursor must be inbetween boxes
  If (sngRow - intRow) > 0.83333333333333 Or _
     (sngCol - intCol) > 0.83333333333333 Then
    Exit Sub
  End If
  
  'verify values
  If intRow > 3 Or intCol > 3 Then
    'ignore it
    Exit Sub
  End If
  
  'select the color, and update the palette
  SelColor = intCol * 4 + intRow
  picPalette_Paint
  picColChange_Paint
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub picPalette_Paint()

  'draw the current color palette
  
  Dim i As Long, j As Long
  Dim lngHiLite As Long
  
  On Error GoTo ErrHandler
  
  picPalette.Cls
  
  For i = 0 To 3
    For j = 0 To 3
      'draw the palette color block first
      picPalette.Line (i * 30 + 5, j * 30 + 5)-Step(25, 25), lngTempCol(4 * i + j), BF
      
      'if this is the selected color, then highlight it
      If SelColor = 4 * i + j Then
      
        'draw hilite over selected color
        With picPalette
          .DrawStyle = vbDot
          .DrawWidth = 1
          .FillStyle = vbFSTransparent
          If SelColor <= 9 Then
            lngHiLite = vbWhite
          Else
            lngHiLite = vbBlack
          End If
          picPalette.Line (i * 30 + 5, j * 30 + 5)-Step(25, 25), lngHiLite, B
          
          .DrawStyle = vbSolid
        End With
      End If
    Next j
  Next i
  
  'show color name on label
  lblCurCol.Caption = CStr(SelColor) & ": " & LoadResString(COLORNAME + SelColor)
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
