VERSION 5.00
Begin VB.Form frmTemplate 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Select a Template"
   ClientHeight    =   2535
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   5055
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2535
   ScaleWidth      =   5055
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtDescription 
      Height          =   855
      Left            =   2160
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   960
      Width           =   2775
   End
   Begin VB.ListBox lstTemplates 
      Height          =   1380
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   1815
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1080
      TabIndex        =   6
      Top             =   2040
      Width           =   1215
   End
   Begin VB.Label lblVersion 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3600
      TabIndex        =   3
      Top             =   360
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Template Description:"
      Height          =   255
      Left            =   2160
      TabIndex        =   4
      Top             =   720
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "Template Version:"
      Height          =   255
      Left            =   2160
      TabIndex        =   2
      Top             =   360
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Available Templates:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2535
   End
End
Attribute VB_Name = "frmTemplate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Canceled As Boolean

Private strVersions(15) As String

Public Sub Activate()
  'bridge method to call the form's Activate event method
  
  'not used for this form
  'Form_Activate
End Sub

Private Sub GetTemplateInfo()
  
  'extract game version and game description from the .wag file located
  'in the template directory currently selected in lstTemplates
  
  Dim strValue As String
  Dim i As Long
  Dim wagFile As StringList
  Dim strVersion As String, strDescription As String
  
  On Error GoTo ErrHandler
  
  'clear description and version textg boxes
  lblVersion.Caption = vbNullString
  txtDescription.Text = vbNullString
  
  
  'check for game file
  strValue = Dir(App.Path & "\Templates\" & lstTemplates.Text & "\*.wag")
  Set wagFile = OpenSettingList(App.Path & "\Templates\" & lstTemplates.Text & "\" & strValue)
  
  'verify version
  strValue = ReadSettingString(wagFile, "General", "WinAGIVersion")
  'if version is incompatible
  Select Case strValue
  Case "1.2.3"
    'ok
  Case "1.2.2"
    'ok, but need to update it
    WriteAppSetting wagFile, "General", "WinAGIVersion", "1.2.3"
  Case Else
    'not valid
    MsgBox "The WinAGI gamefile is corrupt. This is not a valid template directory.", vbCritical + vbOKOnly, "Invalid Template Directory"
    RemoveBadTemplate
    Exit Sub
  End Select
  
  'get version and description
  strVersion = ReadSettingString(wagFile, "General", "Interpreter")
  strDescription = ReadSettingString(wagFile, "General", "Description")
  
  'version is NOT optional
  If LenB(strVersion) = 0 Then
    'error
    MsgBox "The interpreter version for this game is missing. This is not a valid template directory.", vbCritical + vbOKOnly, "Invalid Template Directory"
    RemoveBadTemplate
    Exit Sub
  End If
  
  For i = 0 To 15
    If strVersions(i) = strVersion Then
      Exit For
    End If
  Next i
  'if not found (i=16)
  If i = 16 Then
    MsgBox "The interpreter version for this game does not match known Sierra versions. This is not a valid template directory.", vbCritical + vbOKOnly, "Invalid Template Directory"
    RemoveBadTemplate
  End If

  'populate the form
  lblVersion.Caption = strVersion
  txtDescription.Text = strDescription
  
Exit Sub

ErrHandler:
  'problem accessing the agi gamefile; assume not valid
  MsgBox "Error occurred trying to validate this template directory.", vbCritical + vbOKOnly, "Invalid Template Directory"
  RemoveBadTemplate
End Sub


Private Sub RemoveBadTemplate()

  'removes a bad template from the list box
  
  'remove offending item
  lstTemplates.RemoveItem lstTemplates.ListIndex
  
  'disable cmdok
  cmdOK.Enabled = False
End Sub

Public Sub SetForm()

  'load available templates into list box
  
  Dim strTempDir As String, i As Long
  
  'assume canceling until OK button is clicked
  Canceled = True
  
  'step through all subdirectories in the templates directory
  'if the directory contains a .wag file,
  'get the description and version
  
  strTempDir = Dir(App.Path & "\Templates\*", vbDirectory)
  
  'add all items to listbox
  Do Until LenB(strTempDir) = 0
    If strTempDir <> "." And strTempDir <> ".." Then
      lstTemplates.AddItem strTempDir
    End If
      
    'get next directory
    strTempDir = Dir()
  Loop
  
  'remove all that are not directories
  For i = lstTemplates.ListCount - 1 To 0 Step -1
    If LenB(Dir(App.Path & "\Templates\" & lstTemplates.List(i), vbNormal)) <> 0 Then
      'remove it
      lstTemplates.RemoveItem i
    End If
  Next i
  
  'now remove all that do not have exactly one .wag file
  For i = lstTemplates.ListCount - 1 To 0 Step -1
    'if the directory has a .wag file,
    If LenB(Dir(App.Path & "\Templates\" & lstTemplates.List(i) & "\*.wag")) <> 0 Then
      'check to see if more than one
      If LenB(Dir()) <> 0 Then
        'too many;
        lstTemplates.RemoveItem i
      End If
    Else
      'this dir doesn't have a .wag file
      lstTemplates.RemoveItem i
    End If
  Next i
End Sub

Private Sub cmdCancel_Click()

  'hide form, leave canceled flag at true
  Hide
End Sub

Private Sub cmdOK_Click()

  'clear canceled flag and hide form
  Canceled = False
  Hide
End Sub

Private Sub Form_Load()

  'load versions
  strVersions(0) = "2.089"
  strVersions(1) = "2.272"
  strVersions(2) = "2.411"
  strVersions(3) = "2.425"
  strVersions(4) = "2.426"
  strVersions(5) = "2.435"
  strVersions(6) = "2.439"
  strVersions(7) = "2.440"
  strVersions(8) = "2.915"
  strVersions(9) = "2.917"
  strVersions(10) = "2.936"
  strVersions(11) = "3.002086"
  strVersions(12) = "3.002098"
  strVersions(13) = "3.002102"
  strVersions(14) = "3.002107"
  strVersions(15) = "3.002149"

End Sub

Private Sub lstTemplates_Click()

  'enable ok button
  cmdOK.Enabled = (lstTemplates.ListIndex <> -1)
  
  If lstTemplates.ListIndex <> -1 Then
  'refresh version and description
  GetTemplateInfo
  End If
End Sub


