VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGILogic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E067277007C"
Option Explicit
Option Compare Text

Implements AGIResource

Private WithEvents agRes As AGIResource
Attribute agRes.VB_VarHelpID = -1

Private mResID As String
Private mDescription As String

Private mIsDirty As Boolean
Private mWriteProps As Boolean

Private mIsRoom As Boolean

'source code properties
Private mSourceFile As String
Private mSourceText As String
Private mCompiledCRC As Long
Private mCRC As Long
Private mSourceDirty As Boolean

'other
Private strErrSource As String

Friend Property Let CompiledCRC(NewCRC As Long)

  mCompiledCRC = NewCRC
End Property

Friend Property Let CRC(ByVal NewCRC As Long)

  mCRC = NewCRC
End Property

Public Property Let IsRoom(ByVal NewVal As Boolean)

  'if in a game, and logic 0
  If agRes.InGame And agRes.Number = 0 Then
    On Error GoTo 0: Err.Raise 450, "Can't assign to read-only property"
    Exit Property
  End If

  'if changing
  If mIsRoom <> NewVal Then
    mIsRoom = NewVal

    WriteGameSetting "Logic" & CStr(agRes.Number), "IsRoom", CStr(mIsRoom)
  End If
End Property

Public Property Get IsRoom() As Boolean

  'if logic 0 in a game
  If agRes.InGame And agRes.Number = 0 Then
    IsRoom = False
  Else
    IsRoom = mIsRoom
  End If
End Property

Private Sub SaveProps()

  'save properties
  WriteGameSetting "Logic" & CStr(agRes.Number), "ID", mResID
  WriteGameSetting "Logic" & CStr(agRes.Number), "Description", mDescription
  WriteGameSetting "Logic" & CStr(agRes.Number), "CRC32", "&H" & Hex$(mCRC)
  WriteGameSetting "Logic" & CStr(agRes.Number), "CompCRC32", "&H" & Hex$(mCompiledCRC)
  WriteGameSetting "Logic" & CStr(agRes.Number), "IsRoom", CStr(mIsRoom)

  'set flag indicating all props are uptodate
  mWriteProps = False
End Sub

Friend Sub SetFlags(ByRef IsDirty As Boolean, ByRef WriteProps As Boolean)

  IsDirty = mIsDirty
  WriteProps = mWriteProps
End Sub


Public Property Get Compiled() As Boolean

  'return true if source code CRC is same as stored compiled crc
  
  'if not in a game, compiled is normally undefined, but in case
  'of a Logic copied from an InGame resource, this property will work
  
  On Error GoTo ErrHandler
  
'''  'not valid outside a game
'''  If Not agRes.InGame Then
'''    On Error GoTo 0: Err.Raise vbObjectError + 618, strErrSource, LoadResString(618)
'''    Exit Sub
'''  End If
  
  'if crc is 0, means crc not loaded from a file, or calculated yet;  OR ERROR!!!
  If mCRC = 0 Then
    'load the sourcetext to get the crc (also sets compiledcrc if
    'no sourcefile exists)
    If Not agRes.Loaded Then
      agRes.Load
      LoadSource
      agRes.Unload
      'done with sourcetext
      mSourceText = ""
    End If
    
  End If
  Compiled = (mCRC = mCompiledCRC)
Exit Property

ErrHandler:
  'presumably due to decompiling error;
  'return value of false?
  Debug.Assert False
  Compiled = False
End Property

Public Property Get CompiledCRC() As Long

  On Error Resume Next

  'if not in a game
  If Not agRes.InGame Then
    CompiledCRC = 0
  Else
    CompiledCRC = mCompiledCRC
  End If

End Property
Public Sub Clear()
  'clears out source code text
  'and clears the resource data

  On Error GoTo ErrHandler

  If agRes.InGame Then
    If Not agRes.Loaded Then
      'nothing to clear
      On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
      Exit Sub
    End If
  End If
  
  'clear the source code by setting it to 'return' command
  mSourceText = agCmds(0).Name & "();" & vbCr & vbCr & "[ messages"

  If agRes.InGame Then
    'reset crcs
    mCRC = CRC32(StrConv(mSourceText, vbFromUnicode))
    mCompiledCRC = mCRC
  
    'clear resource
    agRes.Clear
    'write end of logic code (&H0)
    agRes.WriteByte 0
    agRes.WriteByte &H1, 0
    agRes.WriteByte &H0
    agRes.WriteByte &H0
    agRes.WriteByte &H0
    agRes.WriteByte &H2
    agRes.WriteByte &H0
  End If
  
  'note change by marking resource as dirty
  mIsDirty = True
  mSourceDirty = True
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Property Get Description() As String
  Description = mDescription
End Property

Public Property Let Description(ByVal NewDescription As String)

  'limit description to 1K
  NewDescription = Left$(NewDescription, 1024)

  'if changing
  If NewDescription <> mDescription Then
    mDescription = NewDescription

    If agRes.InGame Then
      WriteGameSetting "Logic" & CStr(agRes.Number), "Description", mDescription
    End If
  End If
End Property


Public Sub Export(ExportFile As String, Optional ByVal ResetDirty As Boolean = True)

  Dim intFile As Integer
  Dim strTempFile As String

  'exports a compiled resource; ingame only
  '(since only ingame logics can be compiled)
  
  'if not in a game,
  If Not agRes.InGame Then
    'not allowed; nothing to export
    On Error GoTo 0: Err.Raise vbObjectError + 668, strErrSource, LoadResString(668)
  End If

  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If

  On Error GoTo ErrHandler

  'export a logic resource file
  agRes.Export ExportFile
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub


Public Sub Import(ImportFile As String, ByVal AsSource As Boolean)

  'imports a logic resource

  'i.e., opens from a standalone file
  'doesn't matter if ingame or not
  
  'if importing a logic, it will overwrite current source text with decompiled source
  
  On Error GoTo ErrHandler

  'create new resource (which marks the resource as loaded)
  agRes.NewResource

  'if importing source code
  If AsSource Then
    'load the source code
    mSourceFile = ImportFile
    LoadSource False
  Else
    'import the compiled resource
    agRes.Import ImportFile

    'if there was an error,
    If Err.Number <> 0 Then
      lngError = Err.Number
      strErrSrc = Err.Source
      strError = Err.Description

      Unload
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If

    On Error Resume Next
    'load the source code by decompiling
    LoadSource True
    
    'force filename to null
    mSourceFile = vbNullString

    If Err.Number <> 0 Then
      'pass along error (by exiting without clearing it)
      Exit Sub
    End If
  End If

  'reset dirty flags
  mIsDirty = False
  mSourceDirty = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Friend Sub Init(ByVal ResNum As Byte, ByVal VOL As Long, ByVal Loc As Long)

  On Error GoTo ErrHandler
  
  'initialize resource file
  agRes.Init ResNum, VOL, Loc

  Debug.Assert Not (agGameProps Is Nothing)
  
  'if first time loading this game, there will be nothing in the propertyfile
  mResID = ReadSettingString(agGameProps, "Logic" & CStr(ResNum), "ID", "")
  If Len(mResID) = 0 Then
    'no properties to load; save default ID
    mResID = "Logic" & CStr(ResNum)
    'load resource to get size
    agRes.Load
    'save ID and size to WAG file
    WriteGameSetting "Logic" & CStr(ResNum), "ID", mResID
    WriteGameSetting "Logic" & CStr(ResNum), "Size", agRes.Size
    'unload when done
    agRes.Unload
    
    'save CRC and CompCRC values as defaults; they'll be adjusted first time loguic is accessed
    WriteGameSetting "Logic" & CStr(ResNum), "CRC32", "0"
    WriteGameSetting "Logic" & CStr(ResNum), "CompCRC32", "0"
    
  Else
    'get ID and description and other properties from wag file
    mDescription = ReadSettingString(agGameProps, "Logic" & CStr(ResNum), "Description", "")
    agRes.Size = ReadSettingLong(agGameProps, "Logic" & CStr(ResNum), "Size", -1)
'''    Debug.Assert agRes.Size <> -1
    mCRC = ReadSettingLong(agGameProps, "Logic" & CStr(ResNum), "CRC32")
    mCompiledCRC = ReadSettingLong(agGameProps, "Logic" & CStr(ResNum), "CompCRC32")
    mIsRoom = ReadSettingBool(agGameProps, "Logic" & CStr(ResNum), "IsRoom")
  End If
  
  'if res is zero
  If ResNum = 0 Then
    'make sur isroom flag is false
    mIsRoom = False
  End If
  
Exit Sub

ErrHandler:
  
  'pass along the error
  Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext
  Resume Next
End Sub
Public Property Get Loaded() As Boolean

  Loaded = agRes.Loaded
End Property

Public Property Get ID() As String

  ID = mResID
End Property


Public Property Let ID(ByVal NewID As String)
  'sets the ID for a resource;
  'resource IDs must be unique to each resource type
  'max length of ID is 64 characters
  'min of 1 character

  Dim tmpLog As AGILogic

  Err.Clear
  On Error GoTo ErrHandler

  'validate length
  If LenB(NewID) = 0 Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 667, strErrSource, LoadResString(667)
    Exit Property
  ElseIf Len(NewID) > 64 Then
    NewID = Left$(NewID, 64)
  End If

  'if changing,
  If NewID <> mResID Then
    'if in a game,
    If agRes.InGame Then
      'step through other resources
      For Each tmpLog In agLogs
        'if resource IDs are same
        If tmpLog.ID = NewID Then
          'if not the same logic
          If tmpLog.Number <> agRes.Number Then
            'error
            On Error GoTo 0: Err.Raise vbObjectError + 623, strErrSource, LoadResString(623)
            Exit Property
          End If
        End If
      Next
      'source file always tracks ID for ingame resources
      mSourceFile = agResDir & NewID & agSrcExt
    End If

    'save ID
    mResID = NewID
    If agRes.InGame Then
      WriteGameSetting "Logic" & CStr(agRes.Number), "ID", mResID
    End If

    'reset compiler list of ids
    blnSetIDs = False
  End If
Exit Property

ErrHandler:
  lngError = Err.Number
  strErrSrc = Err.Source
  strError = Err.Description

  Debug.Assert False
  On Error GoTo 0: Err.Raise vbObjectError + 686, strErrSrc, Replace(Replace(LoadResString(686), ARG1, "Logic"), ARG2, strError)
End Property
Public Property Get SourceDirty() As Boolean

  SourceDirty = mSourceDirty
End Property

Public Property Get SourceFile() As String

  'if in a game,
  If agRes.InGame Then
    'sourcefile is predefined
    SourceFile = agResDir & mResID & agSrcExt
  Else
    SourceFile = mSourceFile
  End If
End Property

Public Sub SetLogic(CopyLogic As AGILogic)
  'copies logic data from CopyLogic into this logic

  Dim i As Long
  Dim blnLoaded As Boolean
  
  On Error GoTo ErrHandler

  With CopyLogic
    'add WinAGI items
    mResID = .ID
    mDescription = .Description
    mIsRoom = .IsRoom

    'if NOT loaded, need to load if ingame to get source text
    blnLoaded = .Loaded
    If Not blnLoaded Then
      .Load
    End If
    
    'crc data
    mCompiledCRC = .CompiledCRC
    mCRC = .CRC
    
    mSourceText = .SourceText
    mSourceDirty = .SourceDirty
    mSourceFile = .SourceFile

    agRes.SetRes .Resource
    'add resource data
    agRes.AllData = .Resource.AllData

    'copy dirty flag and writeprop flag
    .SetFlags mIsDirty, mWriteProps
    
    'unload if was'nt loaded earlier
    If Not blnLoaded Then
      .Unload
    End If
  End With
Exit Sub

ErrHandler:
  'if error is NOT the no crc error,
  If Err.Number <> vbObjectError + 592 Then
    Debug.Assert False
  End If
  Resume Next
End Sub

Public Property Let SourceFile(NewName As String)

  'if in a game,
  If agRes.InGame Then
    'sourcefile is predefined; raise error
    On Error GoTo 0: Err.Raise 450, "Can't assign to read-only property"
    Exit Property
  Else
    mSourceFile = NewName
  End If
End Property


Public Property Get CRC() As Long

  On Error Resume Next

  CRC = mCRC
End Property


Private Sub LoadSource(Optional ByVal Decompile As Boolean = False)
  
  'loads LoadFile as the source code
  'for not-ingame, calling code must first set sourcefile name
  
  Dim intFile As Integer, strInput As String
  Dim LoadFile As String
  
  On Error GoTo ErrHandler

  'if in a game,
  If agRes.InGame Then
    'load file is predefined
    LoadFile = agResDir & mResID & agSrcExt
'''    Debug.Assert mSourceFile = LoadFile
    mSourceFile = LoadFile
    
    'if it does not exist,
    If Not FileExists(LoadFile) Then
      'check for AGI Studio file format
      If FileExists(agResDir & "logic" & agRes.Number & ".txt") And agSrcExt = ".lgc" Then
        'rename it to correct format
        Name agResDir & "logic" & agRes.Number & ".txt" As LoadFile
      ElseIf FileExists(agResDir & mResID & ".txt") And agSrcExt = ".lgc" Then
        'rename it to correct format
        Name agResDir & mResID & ".txt" As LoadFile
      Else
        'default file does not exist; AGI Studio file does not exist;
        'set to null string to force decompile
        LoadFile = vbNullString
      End If
    End If
  Else
    LoadFile = mSourceFile
  End If

  'if no name, (OR forcing decompile)
  If LenB(LoadFile) = 0 Or Decompile Then
    'get source code by decoding the resource
    strInput = Join(DecodeLogic(agRes.AllData).AllLines, vbCr)
    'make sure decompile flag is set (so crc can be saved)
    Decompile = True
    
    'if in a game, always save this newly created source
  Else
    'load sourcecode from file
    On Error Resume Next

    intFile = FreeFile()
    Open LoadFile For Binary As intFile
    'if error,
    If Err.Number <> 0 Then
      'close file
      Close intFile
      'return error
      On Error GoTo 0: Err.Raise vbObjectError + 502, strErrSource, Replace(Replace(LoadResString(502), ARG1, CStr(Err.Number)), "%2", LoadFile)
      Exit Sub
    End If

    On Error GoTo ErrHandler

    'get source code
    strInput = String$(LOF(intFile), 0)
    Get intFile, 1, strInput
    Close intFile
  End If

  'convert extended characters
   ByteToExtChar strInput
  'send text in source code string list
  mSourceText = strInput

  'calculate source crc
  mCRC = CRC32(StrConv(strInput, vbFromUnicode))
  If agRes.InGame Then
    WriteGameSetting "Logic" & CStr(agRes.Number), "CRC32", "&H" & Hex$(mCRC)
    'if decompiling, also save the source and the compiled crc(it's the same as the source crc!)
    If Decompile Then
      SaveSource
      mCompiledCRC = mCRC
      WriteGameSetting "Logic" & CStr(agRes.Number), "CompCRC32", "&H" & Hex$(mCompiledCRC)
    End If
  End If
  
  'set loaded flag and dirty status
  mIsDirty = False
  mSourceDirty = False
  
  'clear any errors
  Err.Clear
Exit Sub

ErrHandler:
  'pass along error
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Public Property Let SourceText(NewSource As String)
  'assigns new text to the sourcetext

  Dim i As Long, lngLen As Long
  
  On Error GoTo ErrHandler
  
  'huh, still fighting with logics, oh well
  'I *think* logic has to be loaded before sourcetext can be changed,
  'but before enabling this, let's do a little check, shall we?
  Debug.Assert agRes.Loaded
'''  'if not loaded
'''  If Not agRes.Loaded Then
'''    'error
'''    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
'''    Exit Property
'''  End If
  
  mSourceText = NewSource
  
  'strip off any CRs at the end (unless it's the only character)
  lngLen = Len(mSourceText)
  If lngLen > 1 Then
    For i = 1 To lngLen - 1
      If Asc(Right(mSourceText, i)) <> 13 Then
        Exit For
      End If
    Next i
    'remove the extras
    mSourceText = Left(mSourceText, lngLen - i + 1)
  End If

  'if in a game, save the crc value
  If agRes.InGame Then
    'calculate new crc value
    mCRC = CRC32(StrConv(mSourceText, vbFromUnicode))
    mSourceDirty = True
  End If
Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property
Public Property Get SourceText() As String
  'returns source text as a single string
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
    
  SourceText = mSourceText
End Property


Public Sub SaveSource(Optional SaveFile As String)
  'saves the source code for this logic to file
  Dim strTempFile As String
  Dim intFile As Integer
  Dim bytText() As Byte

  On Error GoTo ErrHandler

  'no filename needed for ingame logics,
  'but must have filename if NOT ingame
  
  'huh, still fighting with logics, oh well
  'I *think* logic has to be loaded before sourcetext can be changed,
  'but before enabling this, let's do a little check, shall we?
  Debug.Assert agRes.Loaded
'''  'if not loaded
'''  If Not agRes.Loaded Then
'''    'error
'''    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
'''    Exit Property
'''  End If
  
  If LenB(SaveFile) = 0 Then
    'if in a game
    If agRes.InGame Then
      'filename is predfined
      SaveFile = mSourceFile
      Debug.Assert SaveFile = agResDir & mResID & agSrcExt
    Else
      'raise an error
      On Error GoTo 0: Err.Raise vbObjectError + 599, strErrSource, LoadResString(599)
      Exit Sub
    End If
  End If

  'get temporary file
  strTempFile = TempFileName()

  'open file for output
  intFile = FreeFile()
  Open strTempFile For Binary As intFile

 'convert any extended characters to correct byte value
  bytText() = ExtCharToByte(mSourceText)

  'write text to file
  Put #intFile, 1, bytText()

  'close file,
  Close intFile

  'if savefile exists
  If FileExists(SaveFile) Then
    On Error Resume Next
    'delete it
    Kill SaveFile
    On Error GoTo ErrHandler
  End If

  'copy tempfile to savefile
  FileCopy strTempFile, SaveFile

  'if error
  If Err.Number <> 0 Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 582, strErrSource, LoadResString(582)
    Exit Sub
  End If

  'delete temp file
  Kill strTempFile
  Err.Clear

  'reset source dirty flag
  mSourceDirty = False
  
  'if in a game, update the source crc
  If agRes.InGame Then
  
    'save the crc value
    WriteGameSetting "Logic" & CStr(agRes.Number), "CRC32", "&H" & Hex$(mCRC)
  
  Else
    'also update id to match savefile name
    mResID = JustFileName(SaveFile)
  End If
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number

  On Error GoTo 0: Err.Raise vbObjectError + 663, strErrSrc, Replace(LoadResString(663), ARG1, CStr(lngError) & ":" & strError)
End Sub


Friend Property Let FriendID(NewID As String)

  'sets the ID for a resource internally
  'does not validate the ID or set dirty flag

  'save ID
  mResID = NewID
  
  If agRes.InGame Then
    mSourceFile = agResDir & mResID & agSrcExt
  Else
    Debug.Assert False
  End If
End Property
Friend Property Let IsDirty(ByVal NewDirtyState As Boolean)

  mIsDirty = NewDirtyState
End Property

Public Sub Load()

  On Error Resume Next

  'if not ingame, the resource should already be loaded
  If Not agRes.InGame Then
    Debug.Assert agRes.Loaded
  End If
  
  'loading ingame:
  '  get logic res data, load sourcefile, decompile if necessary
    
  'if resource data not loaded yet,
  If Not agRes.Loaded Then
    'load resource
    agRes.Load
    If Err.Number <> 0 Then
      'pass along the error (by exiting without clearing it)
      'pass error along
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source

      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If
  End If
    
  'load the sourcetext
  LoadSource

  'compiledCRC Value should already be set,
  'and source crc gets calculated when source is loaded

  'clear dirty flag
  mIsDirty = False
  mSourceDirty = False
  
End Sub

Public Sub Compile()
  'compiles the source code for this logic
  'and saves the resource
  On Error Resume Next

  'if not in a game
  If Not agRes.InGame Then
    On Error GoTo 0: Err.Raise vbObjectError + 618, strErrSource, LoadResString(618)
    Exit Sub
  End If
  
  'if not loaded, raise error
  If Not agRes.Loaded Then
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If

  'if no data in sourcecode
  If LenB(mSourceText) = 0 Then
    On Error GoTo 0: Err.Raise vbObjectError + 546, strErrSource, LoadResString(546)
    Exit Sub
  End If

  Debug.Assert Not mSourceDirty
  
  'compile the logic
  CompileLogic Me

  'save error info
  With Err
    lngError = .Number
    strError = .Description
    strErrSrc = .Source
  End With

  'if no error or warning returned
  If lngError = 0 Or lngError = vbObjectError + 636 Then
    'set dirty flag (forces save to work correctly)
    mIsDirty = True
    'save logic to vol file
    Save
    
    'save compiled source
    Debug.Assert mCompiledCRC = mCRC
'''    WriteGameSetting "Logic" & Cstr(agRes.Number), "CompCRC32", "&H" & Hex$(mCompiledCRC)
  End If

  'pass along errors and/or warnings
  If lngError <> 0 Then
    'pass it along
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
  End If
End Sub

Public Property Get Number() As Byte
  Number = agRes.Number
End Property


Public Property Get Resource() As AGIResource
  Set Resource = agRes
End Property

Public Sub Save(Optional SaveFile As String)
  'this file saves the logic resource to next available VOL file

  'NOTE: this saves the compiled resource NOT the
  'text based source code
  
  'SaveSource saves the source code
  'if Save method is called for a resource NOT in a game,
  'it calls the SaveSource method automatically
  
  Dim i As Long, tmpVal As String

  On Error Resume Next

  'if properties need to be written
  If mWriteProps And agRes.InGame Then
    SaveProps
  End If

  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
  
  'if in a game
  If agRes.InGame Then
    'if dirty
    If mIsDirty Then
      'use the resource save method
      agRes.Save SaveFile
      'if any errors
      If Err.Number <> 0 Then
        'pass error along
        lngError = Err.Number
        strError = Err.Description
        strErrSrc = Err.Source

        On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
        Exit Sub
      End If
    End If
  Else
    'if source is dirty
    If mSourceDirty Then
      'same as savesource
      SaveSource SaveFile
    End If
  End If

  'reset dirty flag
  mIsDirty = False
End Sub

Public Property Get IsDirty() As Boolean

  'if in a game,
  If agRes.InGame Then
    'if resource is dirty, or prop values need writing,
    IsDirty = (mIsDirty Or mWriteProps)
  Else
    IsDirty = mSourceDirty
  End If

End Property


Public Sub Unload()

  'unload resource
  
  On Error GoTo ErrHandler
  
  'if in a game, write the size before unloading
  If agRes.InGame Then
    WriteGameSetting "Logic" & CStr(agRes.Number), "Size", agRes.Size
  End If
  
  agRes.Unload
  mIsDirty = False
  
  mSourceDirty = False
  mSourceText = vbNullString
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Friend Property Let WritePropState(ByVal NewWritePropState As Boolean)

  mWriteProps = NewWritePropState
End Property

Private Property Get AGIResource_AllData() As Byte()
  AGIResource_AllData = agRes.AllData
End Property


Private Sub AGIResource_Clear()
  Clear
End Sub


Private Property Let AGIResource_Data(ByVal Pos As Long, ByVal NewData As Byte)
  agRes.Data(Pos) = NewData

End Property

Private Property Get AGIResource_Data(ByVal Pos As Long) As Byte
  On Error GoTo ErrHandler

  AGIResource_Data = agRes.Data(Pos)
Exit Property

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Property


Private Property Get AGIResource_EORes() As Boolean
  AGIResource_EORes = agRes.EORes
End Property


Private Sub AGIResource_Export(ExportFile As String)
  agRes.Export ExportFile
End Sub



Private Function AGIResource_GetPos() As Long
  AGIResource_GetPos = agRes.GetPos
End Function


Private Property Get AGIResource_InGame() As Boolean
  AGIResource_InGame = agRes.InGame
End Property

Private Sub AGIResource_InsertData(NewData As Variant, Optional ByVal InsertPos As Long = -1&)
  On Error GoTo ErrHandler

  agRes.InsertData NewData, InsertPos
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub


Private Property Get AGIResource_Loaded() As Boolean
  AGIResource_Loaded = agRes.Loaded
End Property



Private Property Get AGIResource_Loc() As Long
  AGIResource_Loc = agRes.Loc

End Property


Private Sub AGIResource_NewResource(Optional ByVal Reset As Boolean = False)
  On Error GoTo ErrHandler

  agRes.NewResource Reset
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Private Property Get AGIResource_Number() As Byte
  AGIResource_Number = agRes.Number
End Property


Private Function AGIResource_ReadByte(Optional ByVal lngPos As Long = MAX_RES_SIZE + 1) As Byte
  On Error GoTo ErrHandler

  AGIResource_ReadByte = agRes.ReadByte(lngPos)
Exit Function

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Function



Private Function AGIResource_ReadWord(Optional ByVal lngPos As Long = -1&, Optional ByVal blnMSLS As Boolean = False) As Long
  On Error GoTo ErrHandler

  AGIResource_ReadWord = agRes.ReadWord(lngPos)
Exit Function

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Function


Private Sub AGIResource_RemoveData(ByVal RemovePos As Long, Optional ByVal RemoveCount As Long = 1)

  On Error GoTo ErrHandler

  agRes.RemoveData RemovePos, RemoveCount
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Private Property Get AGIResource_ResFile() As String
  AGIResource_ResFile = agRes.ResFile
End Property



Private Property Get AGIResource_ResType() As AGIResType
  AGIResource_ResType = agRes.ResType
End Property


Private Sub AGIResource_SetData(NewData() As Byte)

  agRes.SetData NewData
End Sub

Private Sub AGIResource_SetPos(ByVal lngPos As Long)
  On Error GoTo ErrHandler

  agRes.SetPos lngPos
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source

  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub



Private Property Get AGIResource_Size() As Long
  AGIResource_Size = agRes.Size
End Property



Private Property Get AGIResource_SizeInVOL() As Long
  AGIResource_SizeInVOL = agRes.SizeInVol

End Property


Private Property Get AGIResource_Volume() As Long
  AGIResource_Volume = agRes.Volume
End Property



Private Sub Class_Initialize()

  strErrSource = "WinAGI.Logic"
  Set agRes = New AGIResource
  agRes.SetType rtLogic

  'set default resource data
  agRes.NewResource
  agRes.WriteByte &H1, 0
  agRes.WriteByte &H0
  agRes.WriteByte &H0
  agRes.WriteByte &H0
  agRes.WriteByte &H2
  agRes.WriteByte &H0

'''  mIsRoom = True
  mResID = "NewLogic"
  'to avoid having compile property read true if both values are 0, set compiled to -1 on initialization
  mCompiledCRC = -1
End Sub
Private Sub Class_Terminate()

  Set agRes = Nothing
End Sub

