VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGILogics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"agiLogic"
Attribute VB_Ext_KEY = "Member0" ,"agiLogic"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06727802DD"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private strErrSource As String


Friend Sub Clear()
  'removes all items from the collection
  'in preparation for closing the game
  
  Dim i As Long
  
  For i = mCol.Count To 1 Step -1
    If mCol(i).Loaded Then
      mCol(i).Unload
    End If
    mCol.Remove i
  Next i
End Sub



Public Function Add(ByVal ResNum As Byte, Optional NewLogic As AGILogic = Nothing) As AGILogic
  'adds a new logic to a currently open game
  
  Dim agNewLogic As AGILogic
  Dim bytNextNum As Byte
  Dim strID As String
  
  On Error Resume Next

  'attempt to access this Logic
  If mCol("l" & CStr(ResNum)).Loaded Then
  End If

  'if no error,
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Function
  End If
  
  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new logic object
  Set agNewLogic = New AGILogic
  
  'if an object was passed
  If Not (NewLogic Is Nothing) Then
    'copy entire logic
    agNewLogic.SetLogic NewLogic
    'get proposed id
    strID = NewLogic.ID
  Else
    'proposed ID will be default
    strID = "Logic" & CStr(ResNum)
  End If
  
'''  'set load property to true so the logic can be saved
'''  '(MUST do this before initializing, otherwise error is generated)
'''  agNewLogic.Resource.NewResource
  Debug.Assert agNewLogic.Loaded
  
  'initialize the base resource (use placeholders for VOL and Loc - they will be updated by SAVE function)
  agNewLogic.Resource.Init ResNum, -1, -1
  
  'add it
  mCol.Add agNewLogic, "l" & CStr(ResNum)

  'set id to blank, so
  'error checking in ID property
  'can properly identify if
  'proposed ID is in fact unique
  agNewLogic.FriendID = vbNullString
  
  On Error Resume Next
  'assign proposed ID
  agNewLogic.ID = strID
  'validate it
  Do Until Err.Number <> vbObjectError + 623
    bytNextNum = bytNextNum + 1
    agNewLogic.ID = strID & "_" & CStr(bytNextNum)
  Loop
  On Error GoTo ErrHandler
  
  'force flags so save function will work
  agNewLogic.IsDirty = True
  agNewLogic.WritePropState = True
  
  'save new logic
  agNewLogic.Save
  
  'return the object created
  Set Add = agNewLogic
  Set agNewLogic = Nothing
Exit Function

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 645, strErrSrc, Replace(LoadResString(645), ARG1, CStr(lngError) & ":" & strError)
End Function

Public Function Exists(ByVal ResNum As Byte) As Boolean

  'returns true if logic exists; false otherwise
  On Error Resume Next
  
  'attempt to access this Logic
  If mCol("l" & CStr(ResNum)).Loaded Then
  End If

  'if no error, logic exists
  Exists = (Err.Number = 0)
  
  Err.Clear
End Function

Public Property Get Item(ByVal Index As Byte) As AGILogic
Attribute Item.VB_UserMemId = 0
  On Error GoTo ErrHandler
  
  Set Item = mCol("l" & CStr(Index))
Exit Property

ErrHandler:
  'invalid item
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Property

Public Property Get Count() As Long
    
    Count = mCol.Count
End Property



Friend Sub LoadLogic(ByVal ResNum As Byte, ByVal VOL As Byte, ByVal Loc As Long)

  'called by the resource loading method for the initial loading of
  'resources into logics collection
  
  Dim agNewLogic As AGILogic
  Dim strText As String
  
  On Error Resume Next

  'attempt to access this Logic
  If mCol("l" & CStr(ResNum)).Loaded Then
  End If

  'if no error,
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Sub
  End If
  
  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new logic object
  Set agNewLogic = New AGILogic

  'unload it- the resource is already located in the
  'vol file so no need to keep newly created blank logic
  agNewLogic.Resource.Unload
  
  'initialize it
  agNewLogic.Init ResNum, VOL, Loc
  
  'add it
  mCol.Add agNewLogic, "l" & CStr(ResNum)
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  If lngError - vbObjectError = 606 Then
    'pass it along
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
  Else
    'something else; re-frame it
    On Error GoTo 0: Err.Raise vbObjectError + 646, strErrSrc, Replace(LoadResString(646), ARG1, CStr(lngError) & ":" & strError)
  End If
End Sub

Public Sub MarkAllAsDirty()

  On Error GoTo ErrHandler
  
  'change all logic compilecrc values to 0 (to force them
  'to appear out of date)
  Dim tmpLogic As AGILogic
  On Error Resume Next
  For Each tmpLogic In agLogs
    tmpLogic.CompiledCRC = 0
    WriteGameSetting "Logic" & CStr(tmpLogic.Number), "CompCRC32", "&H0"
    SaveSettingList agGameProps
  Next
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub Remove(ByVal Index As Byte)
  
  'removes a logic from the game file
  
  Dim tmpLog As AGILogic
  Dim strKey As String
  
  On Error GoTo ErrHandler
  
  'get temp copy of resource
  strKey = "l" & CStr(Index)
  Set tmpLog = mCol.Item(strKey)
  
  'need to clear the directory file
  UpdateDirFile tmpLog, True
  
  'clear resource properties
  tmpLog.Resource.InGame = False
  tmpLog.Resource.Number = 0
  tmpLog.Resource.Volume = 0
  tmpLog.Resource.Loc = 0
  
  'always unload first
  mCol.Item(strKey).Unload
  'then remove it
  mCol.Remove strKey
  
  'remove all properties from the wag file
  On Error Resume Next
  DeleteSettingSection agGameProps, "Logic" & CStr(Index)
  
Exit Sub

ErrHandler:
  'invalid index
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
  
  Set NewEnum = mCol.[_NewEnum]
End Property
Public Sub Renumber(ByVal OldLogic As Byte, ByVal NewLogic As Byte)
  'renumbers a resource

  Dim tmpLogic As AGILogic
  Dim bytNextNum As Byte
  Dim blnUnload As Boolean
  
  'if no change
  If OldLogic = NewLogic Then
    Exit Sub
  End If
  
  'verify new number is not in collection
  On Error Resume Next
  If mCol("l" & CStr(NewLogic)).Loaded Then
  End If
  If Err.Number = 0 Then
    'number already in use??
    On Error GoTo 0: Err.Raise vbObjectError + 669, strErrSource, LoadResString(669)
    Exit Sub
  End If
  On Error GoTo ErrHandler
  
  'get logic being renumbered
  Set tmpLogic = mCol("l" & CStr(OldLogic))
  
  'if not loaded,
  If Not tmpLogic.Loaded Then
    tmpLogic.Load
    blnUnload = True
  End If

  'remove old properties
  DeleteSettingSection agGameProps, "Logic" & CStr(OldLogic)
  
  'delete logic from old number in dir file
  'by calling update directory file method
  UpdateDirFile tmpLogic, True
  
  'if id is default
  If tmpLogic.ID = "Logic" & CStr(OldLogic) Then
    'change default ID to new ID
    On Error Resume Next
    tmpLogic.ID = "Logic" & CStr(NewLogic)
    Do Until Err.Number = 0
      bytNextNum = bytNextNum + 1
      tmpLogic.ID = "Logic" & CStr(NewLogic) & "_" & CStr(bytNextNum)
    Loop
    'get rid of existing file with same name as new logic
    Kill agResDir & tmpLogic.ID & agSrcExt
    'rename sourcefile
    Name agResDir & "Logic" & CStr(OldLogic) & agSrcExt As agResDir & tmpLogic.ID & agSrcExt
    On Error GoTo ErrHandler
  End If
  
  'change number
  tmpLogic.Resource.Number = NewLogic
  
  'update new logic number in dir file
  UpdateDirFile tmpLogic
  
  'remove from collection
  mCol.Remove "l" & CStr(OldLogic)
  'add with new number
  mCol.Add tmpLogic, "l" & CStr(NewLogic)
  
  'add properties back with new logic number
  WriteGameSetting "Logic" & CStr(NewLogic), "ID", tmpLogic.ID
  WriteGameSetting "Logic" & CStr(NewLogic), "Description", tmpLogic.Description
  WriteGameSetting "Logic" & CStr(NewLogic), "CRC32", "&H" & Hex$(tmpLogic.CRC)
  WriteGameSetting "Logic" & CStr(NewLogic), "CompCRC32", "&H" & Hex$(tmpLogic.CompiledCRC)
  WriteGameSetting "Logic" & CStr(NewLogic), "IsRoom", CStr(tmpLogic.IsRoom)
  
  'force writeprop state back to false
  tmpLogic.WritePropState = False
  
  'unload if necessary
  If blnUnload Then
    tmpLogic.Unload
  End If
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 670, strErrSrc, Replace(LoadResString(670), ARG1, CStr(lngError) & ":" & strError)
End Sub


Public Function ConvertArg(ArgIn As String, ByVal ArgType As ArgTypeEnum, Optional ByVal VarOrNum As Boolean = False) As String

  'tie function to allow access to the LogCompile variable conversion function
  
  Dim dtFileMod As Date
  
  On Error Resume Next
  'if in a game
  If agMainGame.GameLoaded Then
    'initialize global defines
    'get datemodified property
    dtFileMod = FileLastMod(agGameDir & "globals.txt")
    If CRC32(StrConv(CStr(dtFileMod), vbFromUnicode)) <> agGlobalCRC Then
      GetGlobalDefines
    End If
    
    'if ids not set yet
    If Not blnSetIDs Then
      SetResourceIDs
    End If
  End If
  
  'convert argument
  ConvertArgument ArgIn, ArgType, VarOrNum
  'return it
  ConvertArg = LCase$(ArgIn)
End Function

Private Sub Class_Initialize()
    
    'creates the collection when this class is created
    Set mCol = New Collection
    strErrSource = "agiLogics"
End Sub



Private Sub Class_Terminate()
  
  'destroys collection when this class is terminated
  Set mCol = Nothing
End Sub


