VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGIPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06719800F9"
Option Explicit

Implements AGIResource


Private WithEvents agRes As AGIResource
Attribute agRes.VB_VarHelpID = -1

Private mResID As String

Private mDescription As String
Private mBkImgFile As String
Private mBkTrans As Long
Private mBkPos As String
Private mBkSize As String
Private mPriBase As Byte

Private mIsDirty As Boolean
Private mWriteProps As Boolean

Private mPicBMPSet As Boolean
Private mDrawPos As Long
Private mStepDraw As Boolean
Private mCurrentPen As PenStatus

Private mVisData() As Byte
Private mPriData() As Byte

'variables used for low level graphics handling
Private lngVisDC As Long
Private lngPriDC As Long

Private biVis As BitmapInfo
Private biPri As BitmapInfo

Private hVisDIBSec As Long
Private hPriDIBSec As Long

Private lngVisAddr As Long
Private lngPriAddr As Long

Private hOldVisDIB As Long
Private hOldPriDIB As Long

'other
Private strErrSource As String

Public Property Let BkgdImgFile(ByVal NewBkgdFile As String)

  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  mBkImgFile = NewBkgdFile
  mWriteProps = True
'
'  Debug.Print "newfile: "; JustFileName(mBkImgFile), agRes.Number
'
End Property

Public Property Get BkgdImgFile() As String

  BkgdImgFile = mBkImgFile
End Property


Public Property Let BkgdPosition(ByVal NewPos As String)

  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  mBkPos = NewPos
End Property


Public Property Get BkgdPosition() As String

  BkgdPosition = mBkPos
End Property

Public Property Let BkgdSize(ByVal NewSize As String)

  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  mBkSize = NewSize
End Property

Public Property Get BkgdSize() As String

  BkgdSize = mBkSize
End Property

Public Property Let BkgdTrans(ByVal NewTrans As Long)

  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  mBkTrans = NewTrans
End Property

Public Property Get BkgdTrans() As Long

  BkgdTrans = mBkTrans
End Property

Public Property Get PriBase() As Byte

  'if not in a game, or if before v2.936, always return value of 48
  If Not agGameLoaded Or Val(agIntVersion) < 2.936 Then
    mPriBase = 48
  End If
  
  PriBase = mPriBase
End Property

Public Property Let PriBase(ByVal NewPriBase As Byte)

  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  'max value is 158
  If NewPriBase > 158 Then
    mPriBase = 158
  Else
    mPriBase = NewPriBase
  End If
  mWriteProps = True
End Property

Public Property Get VisData() As Byte()

  On Error GoTo ErrHandler
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  VisData = mVisData()

Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property

Public Property Get PriData() As Byte()

  On Error GoTo ErrHandler
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  PriData = mPriData()

Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property


Public Property Get CurrentToolStatus() As PenStatus
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
  
  CurrentToolStatus = mCurrentPen
End Property

Public Property Let DrawPos(NewPos As Long)
  
  On Error GoTo ErrHandler
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  'if not changed
  If NewPos = mDrawPos Then
    Exit Property
  End If
  
  'validate input
  If NewPos < 0 Then
    mDrawPos = -1
  ElseIf NewPos >= agRes.Size Then
    mDrawPos = agRes.Size - 1
  Else
    mDrawPos = NewPos
  End If
  
  'set flag to indicate picture data does not match picture bmps
  mPicBMPSet = False
Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property

Public Property Get DrawPos() As Long
  
  On Error GoTo ErrHandler
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
  
  DrawPos = mDrawPos
Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property


Public Function ObjOnWater(ByVal X As Byte, ByVal Y As Byte, ByVal Length As Byte) As Boolean
  'returns true if testcel at position x,Y is entirely on water
  
  Dim i As Long
  Dim CurPri As AGIColors
  Dim EndX As Byte
  
  On Error GoTo ErrHandler
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'validate x,Y
  If X > 159 Or Y > 167 Then
    On Error GoTo 0: Err.Raise vbObjectError + 621, strErrSource, LoadResString(621)
    Exit Function
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
    If Err.Number <> 0 Then
      'pass along error
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Function
    End If
  End If
  
  'ensure enough room for length
  If X + Length > 159 Then
    Length = 160 - X
  End If
  
  'step through all pixels on this line
  EndX = X + Length - 1
  For i = X To EndX
    CurPri = mPriData(i + 160 * Y)
    If CurPri <> agCyan Then
      'not on water- return false
      Exit Function
    End If
  Next i
  
  'if not exited, must be on water
  ObjOnWater = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Public Function PixelControl(ByVal X As Byte, ByVal Y As Byte, Optional ByVal Length As Byte = 1) As AGIColors
  'returns the actual lowest priority code for a line,
  'including control codes
  
  Dim i As Long
  Dim CurPri As Long
  
  On Error GoTo ErrHandler
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'validate x,Y
  If X > 159 Or Y > 167 Then
    On Error GoTo 0: Err.Raise vbObjectError + 621, strErrSource, LoadResString(621)
    Exit Function
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  'default to max Value
  PixelControl = 15
  
  'ensure enough room for length
  If X + Length > 159 Then
    Length = 160 - X
  End If
  
  'get lowest pixel priority on the line
  Do
    CurPri = mPriData(X + i + 160 * Y)
    If CurPri < PixelControl Then
      PixelControl = CurPri
    End If
    i = i + 1
  Loop Until i = Length
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function VisPixel(ByVal X As Byte, ByVal Y As Byte) As AGIColors
  'returns visual pixel color
  
  Dim i As Long
  Dim CurPri As Long
  
  On Error GoTo ErrHandler
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'validate x,Y
  If X > 159 Or Y > 167 Then
    On Error GoTo 0: Err.Raise vbObjectError + 621, strErrSource, LoadResString(621)
    Exit Function
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  VisPixel = mVisData(X + i + 160 * Y)
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function PriPixel(ByVal X As Byte, ByVal Y As Byte) As AGIColors
  'returns priority pixel color
  
  Dim i As Long
  Dim CurPri As Long
  
  On Error GoTo ErrHandler
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'validate x,y
  If X > 159 Or Y > 167 Then
    On Error GoTo 0: Err.Raise vbObjectError + 621, strErrSource, LoadResString(621)
    Exit Function
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  PriPixel = mPriData(X + i + 160 * Y)
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Public Function PixelPriority(ByVal X As Byte, ByVal Y As Byte) As AGIColors
  'returns the priority for a pixel from the pixel picture
  
  On Error GoTo ErrHandler
    
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'validate x,Y
  If X > 159 Or Y > 167 Then
    On Error GoTo 0: Err.Raise vbObjectError + 621, strErrSource, LoadResString(621)
    Exit Function
  End If
  
  'if picture data changed,
  If Not mPicBMPSet Then
    'load pictures
    BuildPictures
  End If
  
  'set default to 15
  PixelPriority = 15
  
  'need to loop to find first pixel that is NOT a control color (0-2)
  Do
    'get pixel priority
    PixelPriority = mPriData(X + 160 * Y)
    'move down to next row
    Y = Y + 1
  Loop Until PixelPriority >= 3 Or Y = 168
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Friend Sub SetFlags(ByRef IsDirty As Boolean, ByRef WriteProps As Boolean)
  
  IsDirty = mIsDirty
  WriteProps = mWriteProps
End Sub

Public Sub SetPicture(CopyPicture As AGIPicture)
  'copies picture data from CopyPicture into this picture
  
  On Error GoTo ErrHandler
  
  With CopyPicture
    'add WinAGI items
    mResID = .ID
    mDescription = .Description
    mBkImgFile = .BkgdImgFile
    mBkTrans = .BkgdTrans
    mBkPos = .BkgdPosition
    mBkSize = .BkgdSize
    mPriBase = .PriBase
    
    'add resource data
    agRes.SetRes .Resource
    
    'if loaded,
    If .Loaded Then
      'load data
      agRes.AllData = .Resource.AllData
      'load pictures
      BuildPictures
    End If
    
    'copy dirty flag and writeprop flag
    .SetFlags mIsDirty, mWriteProps
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub



Public Property Get Description() As String
  Description = mDescription
End Property

Public Property Let Description(ByVal NewDescription As String)

  'limit description to 1K
  NewDescription = Left$(NewDescription, 1024)
  
  'if changing
  If NewDescription <> mDescription Then
    mDescription = NewDescription
    If agRes.InGame Then
      WriteGameSetting "Picture" & CStr(agRes.Number), "Description", mDescription
    End If
  End If
End Property


Public Sub Export(ExportFile As String, Optional ByVal ResetDirty As Boolean = True)
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
  
  On Error GoTo ErrHandler
  
  agRes.Export ExportFile
  
  'if not in a game,
  If Not agRes.InGame Then
    'ID always tracks the resfile name
    mResID = JustFileName(ExportFile)
    If Len(mResID) > 64 Then
      mResID = Left$(mResID, 64)
    End If
    
    If ResetDirty Then
      'clear dirty flag
      mIsDirty = False
    End If
  End If
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Public Property Get ID() As String
  
  ID = mResID
End Property

Public Property Let ID(ByVal NewID As String)
  'sets the ID for a resource;
  'resource IDs must be unique to each resource type
  'max length of ID is 64 characters
  'min of 1 character
  
  Dim tmpPic As AGIPicture
  
  Err.Clear
  On Error GoTo ErrHandler
  
  'validate length
  If LenB(NewID) = 0 Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 667, strErrSource, LoadResString(667)
    Exit Property
  ElseIf Len(NewID) > 64 Then
    NewID = Left$(NewID, 64)
  End If
  
  'if changing,
  If NewID <> mResID Then
    'if in a game,
    If agRes.InGame Then
      'step through other resources
      For Each tmpPic In agPics
        'if resource IDs are same AND NOT resource being changed
        If tmpPic.ID = NewID Then
          If tmpPic.Number <> agRes.Number Then
            'error
            On Error GoTo 0: Err.Raise vbObjectError + 623, strErrSource, LoadResString(623)
            Exit Property
          End If
        End If
      Next
    End If
    
    'save ID
    mResID = NewID
    If agRes.InGame Then
      WriteGameSetting "Picture" & agRes.Number, "ID", mResID
    End If
    
    'reset compiler list of ids
    blnSetIDs = False
  End If
Exit Property

ErrHandler:
  lngError = Err.Number
  strErrSrc = Err.Source
  strError = Err.Description
  
  Debug.Assert False
  On Error GoTo 0: Err.Raise vbObjectError + 686, strErrSrc, Replace(Replace(LoadResString(686), ARG1, "Logic"), ARG2, strError)
End Property



Friend Property Let FriendID(NewID As String)

  'sets the ID for a resource internally
  'does not validate the ID or set dirty flag
  
  'save ID
  mResID = NewID
End Property


Public Sub Import(ImportFile As String)
  'imports a picture resource
  
  On Error GoTo ErrHandler
  
  'import the resource
  agRes.Import ImportFile
  
  'if there was an error,
  If Err.Number <> 0 Then
    'pass along error (by exiting without clearing)
    Exit Sub
  End If
  
  'set ID
  mResID = JustFileName(ImportFile)
  If Len(mResID) > 64 Then
    mResID = Left$(mResID, 64)
  End If

  If Err.Number <> 0 Then
    'pass along error (by exiting without clearing it)
    Exit Sub
  End If
  
  'reset dirty flag
  mIsDirty = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Friend Property Let IsDirty(ByVal NewState As Boolean)
  
  mIsDirty = NewState
End Property


Friend Property Let WritePropState(ByVal NewWritePropState As Boolean)

  mWriteProps = NewWritePropState
End Property


Public Property Get IsDirty() As Boolean
    
  'if resource is dirty, or (prop values need writing AND in game)
  IsDirty = (mIsDirty Or (mWriteProps And agRes.InGame))
End Property



Public Sub Clear()
  'replaces the picture with a blank picture
  On Error GoTo ErrHandler
  
  'if data is set,
  If agRes.Loaded Then
    'clear the resource
    agRes.Clear
    
    'write end of resource code (&HFF)
    agRes.Data(0) = &HFF
    
    'reset position pointer
    mDrawPos = 1
    
    'load pictures
    BuildPictures
    
    'set dirty flag
    mIsDirty = True
  Else
    'nothing to clear
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Friend Sub Init(ByVal ResNum As Byte, ByVal VOL As Long, ByVal Loc As Long)
  
  On Error GoTo ErrHandler
  Dim strID As String
  
  'initialize resource object
  agRes.Init ResNum, VOL, Loc
  
  'if first time loading this game, there will be nothing in the propertyfile
  mResID = ReadSettingString(agGameProps, "Picture" & CStr(ResNum), "ID", "")
  If Len(mResID) = 0 Then
    'no properties to load; save default ID
    mResID = "Picture" & CStr(ResNum)
    'load resource to get size
    agRes.Load
    'save ID and size to WAG file
    WriteGameSetting "Picture" & CStr(ResNum), "ID", mResID
    WriteGameSetting "Picture" & CStr(ResNum), "Size", agRes.Size
   'unload when done
    agRes.Unload
  Else
    'get ID and description and other properties from wag file
    mDescription = ReadSettingString(agGameProps, "Picture" & CStr(ResNum), "Description", "")
    agRes.Size = ReadSettingLong(agGameProps, "Picture" & CStr(ResNum), "Size", -1)
'''    Debug.Assert agRes.Size <> -1
  End If
Exit Sub

ErrHandler:
'''  Debug.Assert False
  'if it's because vol file is missing, pass along that info
'''  If Err.Number - vbObjectError = 606 Then
'''    'let calling function know
'''
'''  Else
    'pass along the error
    Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext
'''  End If

End Sub


Public Sub Load()
  'load data into the bitmap data area for
  'this set of bitmaps
  
  On Error Resume Next
  
  'if not ingame, the resource should already be loaded
  If Not agRes.InGame Then
    Debug.Assert agRes.Loaded
  End If
  
  'if resource data not loaded yet,
  If Not agRes.Loaded Then
    'load resource
    agRes.Load
    If Err.Number <> 0 Then
      'pass along the error
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If
  End If
  
  If agRes.InGame Then
    'load bkgd info, if there is such
    mBkImgFile = ReadSettingString(agGameProps, "Picture" & CStr(agRes.Number), "BkgdImg", "")
    If Len(mBkImgFile) <> 0 Then
      mBkTrans = ReadSettingLong(agGameProps, "Picture" & CStr(agRes.Number), "BkgdTrans", 0)
      mBkPos = ReadSettingString(agGameProps, "Picture" & CStr(agRes.Number), "BkgdPosn", "")
      mBkSize = ReadSettingString(agGameProps, "Picture" & CStr(agRes.Number), "BkgdSize", "")
    End If
  End If
  
  'load picture bmps
  BuildPictures
  If Err.Number <> 0 Then
    'pass error along
    lngError = Err.Number
    strError = Err.Description
    strErrSrc = Err.Source
    
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
    Exit Sub
  End If
  
  'clear dirty flag
  mIsDirty = False
End Sub




Public Property Get Loaded() As Boolean
  
  Loaded = agRes.Loaded
End Property
Public Property Get PriorityBMP() As Long
  Dim rtn As Long
  
  On Error Resume Next
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  'if pictures not built, or have changed,
  If Not mPicBMPSet Then
    'if an old picture is loaded,
    If lngVisDC <> 0 Then
      'unload current picture resource
      rtn = SelectObject(lngVisDC, hOldVisDIB)
      rtn = SelectObject(lngPriDC, hOldPriDIB)
      rtn = DeleteDC(lngVisDC)
      rtn = DeleteDC(lngPriDC)
      rtn = DeleteObject(hVisDIBSec)
      rtn = DeleteObject(hPriDIBSec)
      lngVisDC = 0
      lngPriDC = 0
      hOldVisDIB = 0
      hOldPriDIB = 0
      lngVisAddr = 0
      lngPriAddr = 0
      hVisDIBSec = 0
      hPriDIBSec = 0
    End If
    
    'load pictures to get correct pictures
    BuildPictures
    'if errors,
    If Err.Number <> 0 Then
      'pass error along
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If
  End If
  
  PriorityBMP = lngPriDC
End Property


Public Property Get Resource() As AGIResource
  Set Resource = agRes
End Property


Public Sub Save()
  'saves the picture resource
  
  On Error Resume Next
  
  Dim strPicKey As String
  
  'if properties need to be written
  If mWriteProps And agRes.InGame Then
    'save ID and description to ID file
    strPicKey = "Picture" & CStr(agRes.Number)
    
    WriteGameSetting strPicKey, "ID", mResID
    WriteGameSetting strPicKey, "Description", mDescription
    WriteGameSetting strPicKey, "BkgdImg", mBkImgFile
    If mPriBase <> 48 Then
      WriteGameSetting strPicKey, "PriBase", mPriBase
    Else
      DeleteSettingKey agGameProps, strPicKey, "PriBase"
    End If
    
    'if no bkgdfile, delete other settings
    If Len(mBkImgFile) = 0 Then
      DeleteSettingKey agGameProps, "Picture" & CStr(agRes.Number), "BkgdTrans"
      DeleteSettingKey agGameProps, "Picture" & CStr(agRes.Number), "BkgdPosn"
      DeleteSettingKey agGameProps, "Picture" & CStr(agRes.Number), "BkgdSize"
    Else
      WriteGameSetting "Picture" & CStr(agRes.Number), "BkgdTrans", mBkTrans
      WriteGameSetting "Picture" & CStr(agRes.Number), "BkgdPosn", mBkPos
      WriteGameSetting "Picture" & CStr(agRes.Number), "BkgdSize", mBkSize
    End If
    mWriteProps = False
  End If
  
  'if not loaded
  If Not agRes.Loaded Then
    'error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Sub
  End If
    
  'if dirty
  If mIsDirty Then
    '(no picture-specific action needed, since changes in picture are
    'made directly to resource data)
    
    'use the resource save method
    agRes.Save
    'check for errors
    If Err.Number <> 0 Then
      'pass error along
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If
    
    'reset flag
    mIsDirty = False
  End If
End Sub


Public Sub SetPictureData(PicData() As Byte)
  'sets the picture resource data to PicData()
  '
  'if the data is invalid, the resource will
  'be identified as corrupted
  '(clear the picture, replace it with valid data
  'or unload it without saving to recover from
  'invalid input data)
  
  On Error GoTo ErrHandler
  
  'copy the picture data
  agRes.AllData = PicData
  
  'if resource is loaded
  If agRes.Loaded Then
    'rebuild pictures
    BuildPictures
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Friend Sub BuildPictures()

  Dim rtn As Long, i As Long
  
  On Error GoTo ErrHandler

  'if picture bmps already exist
  If lngVisDC <> 0 Or lngPriDC <> 0 Then
    'cleanup picture resources
    rtn = SelectObject(lngVisDC, hOldVisDIB)
    rtn = SelectObject(lngPriDC, hOldPriDIB)
    rtn = DeleteObject(hVisDIBSec)
    rtn = DeleteObject(hPriDIBSec)
    rtn = DeleteDC(lngVisDC)
    rtn = DeleteDC(lngPriDC)
    
    lngVisDC = 0
    lngPriDC = 0
    hOldVisDIB = 0
    hOldPriDIB = 0
    lngVisAddr = 0
    lngPriAddr = 0
    hVisDIBSec = 0
    hPriDIBSec = 0
  End If
  
  'load the colors
  For i = 0 To 15
    biVis.bmiColor(i).rgbBlue = lngEGARevCol(i) Mod &H100
    biVis.bmiColor(i).rgbGreen = (lngEGARevCol(i) And &HFF00&) / &H100
    biVis.bmiColor(i).rgbRed = (lngEGARevCol(i) And &HFF0000) / &H10000
    
    biPri.bmiColor(i).rgbBlue = lngEGARevCol(i) Mod &H100
    biPri.bmiColor(i).rgbGreen = (lngEGARevCol(i) And &HFF00&) / &H100
    biPri.bmiColor(i).rgbRed = (lngEGARevCol(i) And &HFF0000) / &H10000
  Next i

  On Error Resume Next
  'build arrays of bitmap data
  BuildBMPs mVisData, mPriData, agRes.AllData, IIf(mStepDraw, mDrawPos, -1), mDrawPos
  
  'if error,
  If Err.Number <> 0 Then
    'pass it along (by exiting)
    lngError = Err.Number
    strError = Err.Description
    strErrSrc = Err.Source
    On Error GoTo 0
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
    Exit Sub
  End If
  
  'get pen status
  mCurrentPen = GetToolStatus
  
  'create compatible DCs to use
  lngVisDC = CreateCompatibleDC(0)
  If lngVisDC = 0 Then
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If
  
  'get handles to dibsection (bitmaps)
  'Do
    hVisDIBSec = CreateDIBSection(lngVisDC, biVis, DIB_RGB_COLORS, lngVisAddr, 0&, 0&)
'    hVisDIBSec = CreateDIBSection(lngVisDC, biVis, DIB_PAL_COLORS, lngVisAddr, 0&, 0&)
  'Loop Until hVisDIBSec <> 0
  'rtn = GetLastError()
  If hVisDIBSec = 0 Then
    rtn = DeleteDC(lngVisDC)
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If
  
  'save old DIBsec, and select this object into the bitmaps
  hOldVisDIB = SelectObject(lngVisDC, hVisDIBSec)
  If hOldVisDIB = 0 Then
    rtn = DeleteDC(lngVisDC)
    rtn = DeleteObject(hVisDIBSec)
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If

  'create compatible DCs to use
  lngPriDC = CreateCompatibleDC(0)
  If lngPriDC = 0 Then
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If

  'get handles to dibsection (bitmaps)
  hPriDIBSec = CreateDIBSection(lngPriDC, biPri, DIB_RGB_COLORS, lngPriAddr, 0, 0)
  If hPriDIBSec = 0 Then
    rtn = DeleteDC(lngPriDC)
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If
  
  'save old dibsec, and select this object into the bitmaps
  hOldPriDIB = SelectObject(lngPriDC, hPriDIBSec)
  If hOldPriDIB = 0 Then
    rtn = DeleteDC(lngPriDC)
    rtn = DeleteObject(hPriDIBSec)
    On Error GoTo 0: Err.Raise vbObjectError + 610, strErrSource, LoadResString(610)
    Exit Sub
  End If
  
  'set background color for visual image????
  rtn = SetBkColor(lngVisDC, &HFFFFFF)
  
  'copy data into bitmaps
  CopyMemory ByVal (lngVisAddr), mVisData(0), 26880
  CopyMemory ByVal (lngPriAddr), mPriData(0), 26880
  
  'set flag
  mPicBMPSet = True
Exit Sub

ErrHandler:
  'Debug.Assert False
  Resume Next
End Sub


Public Property Let StepDraw(ByVal NewValue As Boolean)
  
  On Error GoTo ErrHandler
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Property
  End If
  
  'if a change,
  If mStepDraw <> NewValue Then
    'make the change,
    mStepDraw = NewValue
    'set flag to force redraw of picture
    mPicBMPSet = False
  End If
Exit Property

ErrHandler:
  Debug.Assert False
  Resume Next
End Property
Public Property Get StepDraw() As Boolean
  
  On Error Resume Next
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
  
  StepDraw = mStepDraw
End Property

Public Sub Unload()

  'unload resource
  
  On Error GoTo ErrHandler
  
  'if in a game, write the size before unloading
  If agRes.InGame Then
    WriteGameSetting "Picture" & CStr(agRes.Number), "Size", agRes.Size
  End If
  
  agRes.Unload
  mIsDirty = False
  
  Dim rtn As Long
  
  'cleanup picture resources
  rtn = SelectObject(lngVisDC, hOldVisDIB)
  rtn = SelectObject(lngPriDC, hOldPriDIB)
  rtn = DeleteObject(hVisDIBSec)
  rtn = DeleteObject(hPriDIBSec)
  rtn = DeleteDC(lngVisDC)
  rtn = DeleteDC(lngPriDC)
  
  lngVisDC = 0
  lngPriDC = 0
  hOldVisDIB = 0
  hOldPriDIB = 0
  lngVisAddr = 0
  lngPriAddr = 0
  hVisDIBSec = 0
  hPriDIBSec = 0
  
  mPicBMPSet = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Property Get VisualBMP() As Long
  'returns a device context to the bitmap image of the visual screenoutput
  Dim rtn As Long
  
  On Error Resume Next
  
  'if not loaded,
  If Not agRes.Loaded Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 563, strErrSource, LoadResString(563)
    Exit Function
  End If
    
  'if pictures not built, or have changed,
  If Not mPicBMPSet Then
    'if an old picture is loaded,
    If lngVisDC <> 0 Then
      'unload current picture resource
      rtn = SelectObject(lngVisDC, hOldVisDIB)
      rtn = SelectObject(lngPriDC, hOldPriDIB)
      rtn = DeleteDC(lngVisDC)
      rtn = DeleteDC(lngPriDC)
      rtn = DeleteObject(hVisDIBSec)
      rtn = DeleteObject(hPriDIBSec)
      lngVisDC = 0
      lngPriDC = 0
      hOldVisDIB = 0
      hOldPriDIB = 0
      lngVisAddr = 0
      lngPriAddr = 0
      hVisDIBSec = 0
      hPriDIBSec = 0
    End If
    'load pictures to get correct pictures
    BuildPictures
    'if errors,
    If Err.Number <> 0 Then
      'pass error along
      lngError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      
      On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
      Exit Sub
    End If
  End If
  
  VisualBMP = lngVisDC
End Property


Public Property Get Number() As Byte
  Number = agRes.Number
End Property



Private Property Get AGIResource_AllData() As Byte()
  AGIResource_AllData = agRes.AllData
End Property
Private Sub AGIResource_Clear()
  Clear
End Sub


Private Property Let AGIResource_Data(ByVal Pos As Long, ByVal NewData As Byte)

  agRes.Data(Pos) = NewData
End Property

Private Property Get AGIResource_Data(ByVal Pos As Long) As Byte
  On Error GoTo ErrHandler
  
  AGIResource_Data = agRes.Data(Pos)
Exit Property

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Property

Private Property Get AGIResource_EORes() As Boolean

  AGIResource_EORes = agRes.EORes
End Property


Private Sub AGIResource_Export(ExportFile As String)
  Export ExportFile
End Sub


Private Function AGIResource_GetPos() As Long
  AGIResource_GetPos = agRes.GetPos
End Function



Private Property Get AGIResource_InGame() As Boolean
  AGIResource_InGame = agRes.InGame
End Property

Private Sub AGIResource_InsertData(NewData As Variant, Optional ByVal InsertPos As Long = -1&)

  On Error GoTo ErrHandler
  
  agRes.InsertData NewData, InsertPos
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub


Private Sub AGIResource_Load()
  agRes.Load
End Sub


Private Property Get AGIResource_Loaded() As Boolean
  AGIResource_Loaded = agRes.Loaded
End Property



Private Property Get AGIResource_Loc() As Long
  AGIResource_Loc = agRes.Loc
End Property


Private Sub AGIResource_NewResource(Optional ByVal Reset As Boolean = False)
  On Error GoTo ErrHandler
  
  agRes.NewResource Reset
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Private Property Get AGIResource_Number() As Byte
  AGIResource_Number = agRes.Number
End Property


Private Function AGIResource_ReadByte(Optional ByVal lngPos As Long = 65531) As Byte
  On Error GoTo ErrHandler
  
  AGIResource_ReadByte = agRes.ReadByte(lngPos)
Exit Function

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Function



Private Function AGIResource_ReadWord(Optional ByVal lngPos As Long = -1&, Optional ByVal blnMSLS As Boolean = False) As Long
  On Error GoTo ErrHandler
  
  AGIResource_ReadWord = agRes.ReadWord(lngPos)
Exit Function

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Function


Private Sub AGIResource_RemoveData(ByVal RemovePos As Long, Optional ByVal RemoveCount As Long = 1)

  On Error GoTo ErrHandler
  
  agRes.RemoveData RemovePos, RemoveCount
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub


Private Property Get AGIResource_ResFile() As String
  AGIResource_ResFile = agRes.ResFile
End Property


Private Property Get AGIResource_ResType() As AGIResType
  AGIResource_ResType = agRes.ResType
End Property


Private Sub AGIResource_SaveRes(Optional SaveFile As String)
  
End Sub



Private Sub AGIResource_SetData(NewData() As Byte)

  agRes.SetData NewData
End Sub

Private Sub AGIResource_SetPos(ByVal lngPos As Long)
  On Error GoTo ErrHandler
  
  agRes.SetPos lngPos
Exit Sub

ErrHandler:
  'pass error along
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub



Private Property Get AGIResource_Size() As Long
  AGIResource_Size = agRes.Size
End Property



Private Property Get AGIResource_SizeInVOL() As Long
  AGIResource_SizeInVOL = agRes.SizeInVol
End Property


Private Sub AGIResource_UnloadRes()

End Sub


Private Property Get AGIResource_Volume() As Long
  AGIResource_Volume = agRes.Volume
End Property

Private Sub agRes_Change()
  'set flag to indicate picture data does not match picture bmps
  mPicBMPSet = False
  'for picture only, changing resource sets dirty flag
  mIsDirty = True
End Sub


Private Sub Class_Initialize()
  Dim i As Integer
  
  strErrSource = "WINAGI.agiPicture"
  Set agRes = New AGIResource
  agRes.SetType rtPicture
  
  'create default picture with no commands
  agRes.NewResource
  agRes.Data(0) = &HFF
  
  'initialize the DIBSection headers
  With biVis.bmiHeader
    .biSize = 40
    .biWidth = 160
    .biHeight = -168 'negative cuz bitmaps normally go down to up; we build pics going up to down...
    .biPlanes = 1
    .biBitCount = 8
    .biCompression = BI_RGB
    .biSizeImage = 26880
    .biClrUsed = 16 'need to define this because if set to undefined (0), files expect 2^8 entries
  End With
    
  With biPri.bmiHeader
    .biSize = 40
    .biWidth = 160
    .biHeight = -168
    .biPlanes = 1
    .biBitCount = 8
    .biCompression = BI_RGB
    .biSizeImage = 26880
    .biClrUsed = 16
  End With
  
  'default to entire image
  mDrawPos = -1
  
  mResID = "NewPicture"
  
  'default pribase is 48
  mPriBase = 48
End Sub



Private Sub Class_Terminate()
  'resources should be unloaded,
  'but just in case,
  'check in the termination section
  'to do the unload operation
  
  Dim rtn As Long
  
  If agRes.Loaded Then
    'unload it
    Unload
  End If
  
  Set agRes = Nothing
  
  'if picture bmps exist
  If lngVisDC <> 0 Or lngPriDC <> 0 Then
    'cleanup picture resources
    rtn = SelectObject(lngVisDC, hOldVisDIB)
    rtn = SelectObject(lngPriDC, hOldPriDIB)
    rtn = DeleteObject(hVisDIBSec)
    rtn = DeleteObject(hPriDIBSec)
    rtn = DeleteDC(lngVisDC)
    rtn = DeleteDC(lngPriDC)
    
    lngVisDC = 0
    lngPriDC = 0
    hOldVisDIB = 0
    hOldPriDIB = 0
    lngVisAddr = 0
    lngPriAddr = 0
    hVisDIBSec = 0
    hPriDIBSec = 0
  End If
End Sub


