VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGIPictures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "the pictures collection keeps track of pictures loaded into memory"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"agiPicture"
Attribute VB_Ext_KEY = "Member0" ,"agiPicture"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E0672790260"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private strErrSource As String


Public Function Exists(ByVal ResNum As Byte) As Boolean

  'returns true if picture exists; false otherwise
  On Error Resume Next
  
  'attempt to access this Logic
  If mCol("p" & CStr(ResNum)).Loaded Then
  End If

  'if no error, logic exists
  Exists = (Err.Number = 0)
  
  Err.Clear
End Function
Friend Sub Clear()
  'removes all items from the collection
  'in preparation for closing the game
  
  Dim i As Long
  
  For i = mCol.Count To 1 Step -1
    mCol(i).Unload
    mCol.Remove i
  Next i
End Sub



Public Function Add(ByVal ResNum As Byte, Optional NewPicture As AGIPicture = Nothing) As AGIPicture
  'create a new object
  
  Dim agNewPicture As AGIPicture
  Dim bytNextNum As Byte
  Dim strID As String
  
  On Error Resume Next

  'attempt to access this Picture
  If mCol("p" & CStr(ResNum)).Loaded Then
  End If

  'if no error,
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Function
  End If

  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new picture object
  Set agNewPicture = New AGIPicture
  
  'if an object was passed,
  If Not (NewPicture Is Nothing) Then
    'copy entire picture
    agNewPicture.SetPicture NewPicture
    'get proposed ID
    strID = NewPicture.ID
  Else
    'proposed ID will be default
    strID = "Picture" & CStr(ResNum)
  End If
  
'''  'set load property to true so picture can be saved
'''  '(MUST do this before initializing, otherwise error is generated)
'''  agNewPicture.Resource.NewResource
  Debug.Assert agNewPicture.Loaded
  
  'initialize the base resource (use placeholders for VOL and Loc - they will be updated by SAVE function)
  agNewPicture.Resource.Init ResNum, -1, -1
  
  'add it
  mCol.Add agNewPicture, "p" & CStr(ResNum)
  
  'set id to blank, so
  'error checking in ID property
  'can properly identify if
  'proposed ID is in fact unique
  agNewPicture.FriendID = vbNullString
  
  On Error Resume Next
  'assign proposed ID
  agNewPicture.ID = strID
  'validate it
  Do Until Err.Number <> vbObjectError + 623
    bytNextNum = bytNextNum + 1
    agNewPicture.ID = strID & "_" & CStr(bytNextNum)
  Loop
  On Error GoTo ErrHandler
  
  'force flags so save function will work
  agNewPicture.IsDirty = True
  agNewPicture.WritePropState = True
  
  'save it
  agNewPicture.Save
  
  'return the object created
  Set Add = agNewPicture
  Set agNewPicture = Nothing
Exit Function

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 647, strErrSrc, Replace(LoadResString(647), ARG1, CStr(lngError) & ":" & strError)
End Function
Public Property Get Item(ByVal Index As Byte) As AGIPicture
Attribute Item.VB_UserMemId = 0
  On Error GoTo ErrHandler
  
  Set Item = mCol("p" & CStr(Index))
Exit Property

ErrHandler:
  'invalid item
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Property




Public Property Get Count() As Long
    
    Count = mCol.Count
End Property



Friend Sub LoadPicture(ByVal ResNum As Byte, ByVal VOL As Byte, ByVal Loc As Long)

  'called by the resource loading method for the initial loading of
  'resources into pictures collection
  
  Dim agNewPicture As AGIPicture
  
  On Error Resume Next
  
  'attempt to access this picture
  If mCol("p" & CStr(ResNum)).Loaded Then
  End If
  
  'if no error
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Sub
  End If
  
  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new picture object
  Set agNewPicture = New AGIPicture
  
  'unload it- the resource is already located in the
  'vol file so no need to keep newly created blank picture
  agNewPicture.Resource.Unload
  
  'initialize it
  agNewPicture.Init ResNum, VOL, Loc
  
  'add it
  mCol.Add agNewPicture, "p" & CStr(ResNum)
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  If lngError - vbObjectError = 606 Then
    'pass it along
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
  Else
    'something else; re-frame it
    On Error GoTo 0: Err.Raise vbObjectError + 648, strErrSrc, Replace(LoadResString(648), ARG1, CStr(lngError) & ":" & strError)
  End If
End Sub
Public Sub Remove(ByVal Index As Byte)
  'removes a picture from the game file
  
  Dim tmpPic As AGIPicture
  Dim strKey As String
  
  On Error GoTo ErrHandler
  
  strKey = "p" & CStr(Index)
  
  'get temp copy of resource
  Set tmpPic = mCol.Item(strKey)
  
  'need to clear the directory file
  UpdateDirFile tmpPic, True
  
  'reset resource properties
  tmpPic.Resource.InGame = False
  tmpPic.Resource.Number = 0
  tmpPic.Resource.Loc = 0
  tmpPic.Resource.Volume = 0
  
 'always unload first
  tmpPic.Unload
  'then remove it
  mCol.Remove strKey
  
  'remove id and description from .wag file
  On Error Resume Next
  DeleteSettingSection agGameProps, "Picture" & CStr(Index)
Exit Sub

ErrHandler:
  'invalid index
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Sub



Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
    
  Set NewEnum = mCol.[_NewEnum]
End Property


Public Sub Renumber(ByVal OldPicture As Byte, ByVal NewPicture As Byte)
  'renumbers a resource

  Dim tmpPicture As AGIPicture
  Dim bytNextNum As Byte
  
  On Error GoTo ErrHandler
  
  'if no change
  If OldPicture = NewPicture Then
    Exit Sub
  End If
  
  'verify new number is not in collection
  On Error Resume Next
  If mCol("p" & CStr(NewPicture)).Loaded Then
  End If
  If Err.Number = 0 Then
    'number already in use??
    On Error GoTo 0: Err.Raise vbObjectError + 669, strErrSource, LoadResString(669)
    Exit Sub
  End If
  On Error GoTo ErrHandler
  
  'get picture being reunumbered
  Set tmpPicture = mCol("p" & CStr(OldPicture))
  
  'remove old properties
  DeleteSettingSection agGameProps, "Picture" & CStr(OldPicture)
  
  'delete Picture from old number in dir file
  'by calling update directory file method
  UpdateDirFile tmpPicture, True
  
  'if id is default
  If tmpPicture.ID = "Picture" & CStr(OldPicture) Then
    'change default name to new name
    On Error Resume Next
    tmpPicture.ID = "Picture" & CStr(NewPicture)
    Do Until Err.Number = 0
      bytNextNum = bytNextNum + 1
      tmpPicture.ID = "Picture" & CStr(NewPicture) & "_" & CStr(bytNextNum)
    Loop
    On Error GoTo ErrHandler
  End If
  
  'change number
  tmpPicture.Resource.Number = NewPicture
  
  'update new Picture number in dir file
  UpdateDirFile tmpPicture
  
  'remove from collection
  mCol.Remove "p" & CStr(OldPicture)
  'add with new number
  mCol.Add tmpPicture, "p" & CStr(NewPicture)
  
  'add properties back with new picture number
  WriteGameSetting "Picture" & CStr(NewPicture), "ID", tmpPicture.ID
  WriteGameSetting "Picture" & CStr(NewPicture), "Description", tmpPicture.Description
  WriteGameSetting "Picture" & CStr(NewPicture), "BkgdImg", tmpPicture.BkgdImgFile
  'if there is a bkgdfile, copy the other settings
  If Len(tmpPicture.BkgdImgFile) > 0 Then
    WriteGameSetting "Picture" & CStr(NewPicture), "BkgdTrans", tmpPicture.BkgdTrans
    WriteGameSetting "Picture" & CStr(NewPicture), "BkgdPosn", tmpPicture.BkgdPosition
    WriteGameSetting "Picture" & CStr(NewPicture), "BkgdSize", tmpPicture.BkgdSize
  End If
  
  'force writeprop state back to false
  tmpPicture.WritePropState = False
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 670, strErrSrc, Replace(LoadResString(670), ARG1, CStr(lngError) & ":" & strError)
End Sub


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    strErrSource = "agiPictures"
    
End Sub



Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub


