VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGISounds"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"agiSound"
Attribute VB_Ext_KEY = "Member0" ,"agiSound"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06727B02CE"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private strErrSource As String

Private mDefInst(2) As Byte
Private mDefTrackOn(3) As Boolean

Public Function Exists(ByVal ResNum As Byte) As Boolean

  'returns true if sound exists; false otherwise
  On Error Resume Next
  
  'attempt to access this Logic
  If mCol("s" & CStr(ResNum)).Loaded Then
  End If

  'if no error, logic exists
  Exists = (Err.Number = 0)
  
  Err.Clear
End Function

Friend Sub Clear()
  'removes all items from the collection
  'in preparation for closing the game
  
  Dim i As Long
  
  For i = mCol.Count To 1 Step -1
    mCol(i).Unload
    mCol.Remove i
  Next i
End Sub



Public Function Add(ByVal ResNum As Byte, Optional NewSound As AGISound = Nothing) As AGISound
  'create a new object
  
  Dim agNewSound As AGISound
  Dim bytNextNum As Byte
  Dim strID As String
  
  On Error Resume Next

  'attempt to access this Sound
  If mCol("s" & CStr(ResNum)).Loaded Then
  End If

  'if no error,
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Function
  End If

  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new sound object
  Set agNewSound = New AGISound
  
  'if an object was passed
  If Not (NewSound Is Nothing) Then
    'copy entire sound
    agNewSound.SetSound NewSound
    'get proposed ID
    strID = NewSound.ID
  Else
    'proposed ID is default
    strID = "Sound" & CStr(ResNum)
  End If
  
'''  'set load property to true so picture can be saved
'''  '(MUST do this before initializing, otherwise error is generated)
'''  agNewSound.Resource.NewResource
  Debug.Assert agNewSound.Loaded
  
  'initialize the base resource (use placeholders for VOL and Loc - they will be updated by SAVE function)
  agNewSound.Resource.Init ResNum, -1, -1
  
  'add it
  mCol.Add agNewSound, "s" & CStr(ResNum)
  
  'set id to blank, so
  'error checking in ID property
  'can properly identify if
  'proposed ID is in fact unique
  agNewSound.FriendID = vbNullString
  
  On Error Resume Next
  'assign proposed ID
  agNewSound.ID = strID
  'validate it
  Do Until Err.Number <> vbObjectError + 623
    bytNextNum = bytNextNum + 1
    agNewSound.ID = strID & "_" & CStr(bytNextNum)
  Loop
  On Error GoTo ErrHandler
  
  'force flags so save function will work
  agNewSound.IsDirty = True
  agNewSound.WritePropState = True
  
  'save it
  agNewSound.Save
  
  'return the object created
  Set Add = agNewSound
  Set agNewSound = Nothing
Exit Function

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 651, strErrSrc, Replace(LoadResString(651), ARG1, CStr(lngError) & ":" & strError)
End Function
Public Property Get Item(ByVal Index As Byte) As AGISound
Attribute Item.VB_UserMemId = 0
  On Error GoTo ErrHandler
  
  Set Item = mCol("s" & CStr(Index))
Exit Property

ErrHandler:
  'invalid item
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Property




Public Property Get Count() As Long
    
    Count = mCol.Count
End Property



Friend Sub LoadSound(ByVal ResNum As Byte, ByVal VOL As Byte, ByVal Loc As Long)
  'called by the resource loading method for the initial loading of
  'resources into Sounds collection
  
  Dim agNewSound As AGISound
  
  On Error Resume Next
  
  'attempt to access this Sound
  If mCol("p" & CStr(ResNum)).Loaded Then
  End If
  
  'if no error
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Sub
  End If
  
  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new Sound object
  Set agNewSound = New AGISound
  
  'unload it- the resource is already located in the
  'vol file so no need to keep newly created blank sound
  agNewSound.Resource.Unload
  
  'initialize it
  agNewSound.Init ResNum, VOL, Loc
  
  'add it
  mCol.Add agNewSound, "s" & CStr(ResNum)
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  If lngError - vbObjectError = 606 Then
    'pass it along
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
  Else
    'something else; re-frame it
    On Error GoTo 0: Err.Raise vbObjectError + 652, strErrSrc, Replace(LoadResString(652), ARG1, CStr(lngError) & ":" & strError)
  End If
End Sub

Public Sub Remove(ByVal Index As Byte)
  'removes a sound from the game file

  Dim tmpSnd As AGISound
  Dim strKey As String
  
  On Error GoTo ErrHandler
  
  strKey = "s" & CStr(Index)
  
  'get temporary copy of resource
  Set tmpSnd = mCol.Item(strKey)
  
  'need to clear the directory file
  UpdateDirFile tmpSnd, True
  
  'reset ingame flag and number
  tmpSnd.Resource.InGame = False
  tmpSnd.Resource.Number = 0
  tmpSnd.Resource.Volume = 0
  tmpSnd.Resource.Loc = 0
  
  'always unload first
  tmpSnd.Unload
  
  'then remove it
  mCol.Remove strKey
  
  'remove id and description from .wag file
  On Error Resume Next
  DeleteSettingSection agGameProps, "Sound" & CStr(Index)
Exit Sub

ErrHandler:
  'invalid index
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Sub
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
 
 Set NewEnum = mCol.[_NewEnum]
End Property
Public Sub Renumber(ByVal OldSound As Byte, ByVal NewSound As Byte)

  'renumbers a resource

  Dim tmpSound As AGISound
  Dim bytNextNum As Byte
  Dim blnUnload As Boolean
  
  On Error GoTo ErrHandler
  
  'if no change
  If OldSound = NewSound Then
    Exit Sub
  End If
  
  'verify new number is not in collection
  On Error Resume Next
  If mCol("s" & CStr(NewSound)).Loaded Then
  End If
  If Err.Number = 0 Then
    'number already in use??
    On Error GoTo 0: Err.Raise vbObjectError + 669, strErrSource, LoadResString(669)
    Exit Sub
  End If
  On Error GoTo ErrHandler
  
  'get sound being reunumbered
  Set tmpSound = mCol("s" & CStr(OldSound))
  
  'if not loaded
  If Not tmpSound.Loaded Then
    tmpSound.Load
    blnUnload = True
  End If
  
  'remove old properties
  DeleteSettingSection agGameProps, "Sound" & CStr(OldSound)
  
  'delete Sound from old number in dir file
  'by calling update directory file method
  UpdateDirFile tmpSound, True
  
  'if id is default
  If tmpSound.ID = "Sound" & CStr(OldSound) Then
    'change default name to new name
    On Error Resume Next
    tmpSound.ID = "Sound" & CStr(NewSound)
    Do Until Err.Number = 0
      bytNextNum = bytNextNum + 1
      tmpSound.ID = tmpSound.ID = "Sound" & CStr(NewSound) & "_" & CStr(bytNextNum)
    Loop
    On Error GoTo ErrHandler
  End If
  
  'change number
  tmpSound.Resource.Number = NewSound
  
  'update new Sound number in dir file
  UpdateDirFile tmpSound
  
  'remove from collection
  mCol.Remove "s" & CStr(OldSound)
  'add with new number
  mCol.Add tmpSound, "s" & CStr(NewSound)
  
  With tmpSound
    'add properties back with new sound number
    WriteGameSetting "Sound" & CStr(NewSound), "ID", .ID
    WriteGameSetting "Sound" & CStr(NewSound), "Description", .Description
    WriteGameSetting "Sound" & CStr(NewSound), "Key", .Key
    WriteGameSetting "Sound" & CStr(NewSound), "TPQN" & CStr(NewSound), .TPQN
    WriteGameSetting "Sound" & CStr(NewSound), "Visible0", .Track(0).Visible
    WriteGameSetting "Sound" & CStr(NewSound), "Visible1", .Track(1).Visible
    WriteGameSetting "Sound" & CStr(NewSound), "Visible2", .Track(2).Visible
    WriteGameSetting "Sound" & CStr(NewSound), "Visible3", .Track(3).Visible
    WriteGameSetting "Sound" & CStr(NewSound), "Inst0", .Track(0).Instrument
    WriteGameSetting "Sound" & CStr(NewSound), "Inst1", .Track(1).Instrument
    WriteGameSetting "Sound" & CStr(NewSound), "Inst2", .Track(2).Instrument
    WriteGameSetting "Sound" & CStr(NewSound), "Mute0", .Track(0).Muted
    WriteGameSetting "Sound" & CStr(NewSound), "Mute1", .Track(1).Muted
    WriteGameSetting "Sound" & CStr(NewSound), "Mute2", .Track(2).Muted
    WriteGameSetting "Sound" & CStr(NewSound), "Mute3", .Track(3).Muted
  End With
  
  'force writeprop state back to false
  If blnUnload Then
    tmpSound.Unload
  End If
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 670, strErrSrc, Replace(LoadResString(670), ARG1, CStr(lngError) & ":" & strError)
End Sub
Private Sub Class_Initialize()
  'creates the collection when this class is created
  Set mCol = New Collection
  strErrSource = "agiSounds"
  
  'load the sound subclass form
  Load frmSndSubclass
  
'#If DEBUGMODE <> 1 Then
  'hook it
  PrevSndWndProc = SetWindowLong(frmSndSubclass.hWnd, GWL_WNDPROC, AddressOf SndSubclassProc)
'#End If
End Sub



Private Sub Class_Terminate()
  
  Dim rtn As Long
  
  'destroys collection when this class is terminated
  Set mCol = Nothing
  
  'unhook subclassed form
  rtn = SetWindowLong(frmSndSubclass.hWnd, GWL_WNDPROC, PrevSndWndProc)
  
  'unload it
  Unload frmSndSubclass
End Sub

