VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGIViews"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"agiView"
Attribute VB_Ext_KEY = "Member0" ,"agiView"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06727A0251"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private strErrSource As String

Public Function Exists(ByVal ResNum As Byte) As Boolean

  'returns true if view exists; false otherwise
  On Error Resume Next
  
  'attempt to access this Logic
  If mCol("v" & CStr(ResNum)).Loaded Then
  End If

  'if no error, logic exists
  Exists = (Err.Number = 0)
  
  Err.Clear
End Function

Public Function Add(ByVal ResNum As Byte, Optional NewView As AGIView = Nothing) As AGIView
  'create a new object
  
  Dim agNewView As AGIView
  Dim bytNextNum As Byte
  Dim strID As String
  
  On Error Resume Next

  'attempt to access this View
  If mCol("v" & CStr(ResNum)).Loaded Then
  End If

  'if no error,
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Function
  End If

  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new view object
  Set agNewView = New AGIView
  
  'if an object was passed
  If Not (NewView Is Nothing) Then
    'copy entire view
    agNewView.SetView NewView
    'get proposed id
    strID = NewView.ID
  Else
    'proposed id will be default
    strID = "View" & CStr(ResNum)
  End If
  
'''  'set load property to true so picture can be saved
'''  '(MUST do this before initializing, otherwise error is generated)
'''  agNewView.Resource.NewResource
  Debug.Assert agNewView.Loaded
  
  'initialize the base resource (use placeholders for VOL and Loc - they will be updated by SAVE function)
  agNewView.Resource.Init ResNum, -1, -1
  
  'add it
  mCol.Add agNewView, "v" & CStr(ResNum)

  'set id to blank, so
  'error checking in ID property
  'can properly identify if
  'proposed ID is in fact unique
  agNewView.FriendID = vbNullString
  
  On Error Resume Next
  'assign proposed ID
  agNewView.ID = strID
  'validate it
  Do Until Err.Number <> vbObjectError + 623
    bytNextNum = bytNextNum + 1
    agNewView.ID = "View" & CStr(ResNum) & "_" & CStr(bytNextNum)
  Loop
  On Error GoTo ErrHandler
  
  'force flags so save function will work
  agNewView.IsDirty = True
  agNewView.WritePropState = True
  
  'save it
  agNewView.Save
  
  'return the object created
  Set Add = agNewView
  Set agNewView = Nothing
Exit Function

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 649, strErrSrc, Replace(LoadResString(649), ARG1, CStr(lngError) & ":" & strError)
End Function
Public Property Get Item(ByVal Index As Byte) As AGIView
Attribute Item.VB_UserMemId = 0
  On Error GoTo ErrHandler
  
  Set Item = mCol("v" & CStr(Index))
Exit Property

ErrHandler:
  'invalid item
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Property




Public Property Get Count() As Long
    
  Count = mCol.Count
End Property



Friend Sub LoadView(ByVal ResNum As Byte, ByVal VOL As Byte, ByVal Loc As Long)
  'called by the resource loading method for the initial loading of
  'resources into Views collection
  
  Dim agNewView As AGIView
  
  On Error Resume Next
  
  'attempt to access this View
  If mCol("v" & CStr(ResNum)).Loaded Then
  End If
  
  'if no error
  If Err.Number = 0 Then
    'resource already exists
    Err.Clear
    On Error GoTo 0: Err.Raise vbObjectError + 602, strErrSource, LoadResString(602)
    Exit Sub
  End If
  
  'clear error and continue
  Err.Clear
  On Error GoTo ErrHandler
  
  'create new View object
  Set agNewView = New AGIView
  
  'unload it- the resource is already located in the
  'vol file so no need to keep newly created blank view
  agNewView.Resource.Unload
  
  'initialize it
  agNewView.Init ResNum, VOL, Loc
  
  'add it
  mCol.Add agNewView, "v" & CStr(ResNum)
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  If lngError - vbObjectError = 606 Then
    'pass it along
    On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
  Else
    'something else; re-frame it
    On Error GoTo 0: Err.Raise vbObjectError + 650, strErrSrc, Replace(LoadResString(650), ARG1, CStr(lngError) & ":" & strError)
  End If
  
End Sub

Public Sub Remove(ByVal Index As Byte)
  'removes a view from the game file
  
  Dim tmpView As AGIView
  Dim strKey As String
  
  On Error GoTo ErrHandler
  
  strKey = "v" & CStr(Index)
  
  'get temp copy of resource
  Set tmpView = mCol.Item(strKey)
  
  'need to clear the directory file
  UpdateDirFile tmpView, True
  
  'reset ingame flag and number
  tmpView.Resource.InGame = False
  tmpView.Resource.Number = 0
  tmpView.Resource.Loc = 0
  tmpView.Resource.Volume = 0
  
  'always unload first
  tmpView.Unload
  'then remove it
  mCol.Remove strKey
  
  'remove id and description from .wag file
  On Error Resume Next
  DeleteSettingSection agGameProps, "View" & CStr(Index)
Exit Sub

ErrHandler:
  'invalid index
  On Error GoTo 0: Err.Raise vbObjectError + 617, strErrSource, LoadResString(617)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
  
  Set NewEnum = mCol.[_NewEnum]
End Property


Friend Sub Clear()
  'removes all items from the collection
  'in preparation for closing the game
  
  Dim i As Long
  
  For i = mCol.Count To 1 Step -1
    mCol(i).Unload
    mCol.Remove i
  Next i
End Sub

Public Sub Renumber(ByVal OldView As Byte, ByVal NewView As Byte)
  'renumbers a resource

  Dim tmpView As AGIView
  Dim bytNextNum As Byte
  
  On Error GoTo ErrHandler
  
  'if no change
  If OldView = NewView Then
    Exit Sub
  End If
  
  'verify new number is not in collection
  On Error Resume Next
  If mCol("v" & CStr(NewView)).Loaded Then
  End If
  If Err.Number = 0 Then
    'number already in use??
    On Error GoTo 0: Err.Raise vbObjectError + 669, strErrSource, LoadResString(669)
    Exit Sub
  End If
  On Error GoTo ErrHandler
  
  'get view being reunumbered
  Set tmpView = mCol("v" & CStr(OldView))
  
  'remove old properties
  DeleteSettingSection agGameProps, "View" & CStr(OldView)
  
  'delete View from old number in dir file
  'by calling update directory file method
  UpdateDirFile tmpView, True
  
  'if id is default
  If tmpView.ID = "View" & CStr(OldView) Then
    'change default name to new name
    On Error Resume Next
    tmpView.ID = "View" & CStr(NewView)
    Do Until Err.Number = 0
      bytNextNum = bytNextNum + 1
      tmpView.ID = "View" & CStr(NewView) & "_" & CStr(bytNextNum)
    Loop
    On Error GoTo ErrHandler
  End If
  
  'change number
  tmpView.Resource.Number = NewView
  
  'update new View number in dir file
  UpdateDirFile tmpView
  
  'remove from collection
  mCol.Remove "v" & CStr(OldView)
  'add with new number
  mCol.Add tmpView, "v" & CStr(NewView)
  
  'add properties back with new view number
  WriteGameSetting "View" & CStr(NewView), "ID", tmpView.ID
  WriteGameSetting "View" & CStr(NewView), "Description", tmpView.Description

  'force writeprop state back to false
  tmpView.WritePropState = False
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 670, strErrSrc, Replace(LoadResString(670), ARG1, CStr(lngError) & ":" & strError)
End Sub


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    strErrSource = "agiViews"
End Sub



Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

