Attribute VB_Name = "SoundFunctions"
Option Explicit

Public Type MCISoundInfo
  DeviceID As Long
  SoundID As String
End Type

Public SoundInfo(15) As MCISoundInfo
  
Public Type MCI_OPEN_PARMS
  dwCallback As Long
  wDeviceID As Long
  lpstrDeviceType As String
  lpstrElementName As String
  lpstrAlias As String
End Type

Public Type MCI_PLAY_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
End Type

Public Type MCI_STATUS_PARMS
  dwCallback As Long
  dwReturn As Long
  dwItem As Long
  dwTrack As Integer
End Type

Public Type MCI_SEQ_SET_PARMS
  dwCallback As Long
  dwTimeFormat As Long
  dwAudio As Long
  dwTempo As Long
  dwPort As Long
  dwSlave As Long
  dwMaster As Long
  dwOffset As Long
End Type

Public Type MMTIME
  wType As Long
  u As Long
End Type

Public Type MIDIEVENT
  dwDeltaTime As Long          '  Ticks since last event
  dwStreamID As Long           '  Reserved; must be zero
  dwEvent As Long              '  Event type and parameters
  dwParms(1) As Long           '  Parameters if this is a long event
End Type

Public Type MIDIHDR
  lpData As String
  dwBufferLength As Long
  dwBytesRecorded As Long
  dwUser As Long
  dwFlags As Long
  lpNext As Long
  Reserved As Long
End Type

Public Type MIDIOUTCAPS
  wMid As Integer
  wPid As Integer
  vDriverVersion As Long
  szPname As String * 32 'MAXPNAMELEN
  wTechnology As Integer
  wVoices As Integer
  wNotes As Integer
  wChannelMask As Integer
  dwSupport As Long
End Type

Public Type MIDIPROPTEMPO
  cbStruct As Long
  dwTempo As Long
End Type

Public Type MIDIPROPTIMEDIV
  cbStruct As Long
  dwTimeDiv As Long
End Type

Public Type MIDISTRMBUFFVER
  dwVersion As Long                  '  Stream buffer format version
  dwMid As Long                      '  Manufacturer ID as defined in MMREG.H
  dwOEMVersion As Long               '  Manufacturer version for custom ext
End Type

Public Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Public Declare Function mciSendCommand Lib "winmm.dll" Alias "mciSendCommandA" (ByVal wDeviceID As Long, ByVal uMessage As Long, ByVal dwMsgFlags As Long, ByVal dwParam2 As Any) As Long
Public Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal dwError As Long, ByVal lpstrBuffer As String, ByVal uLength As Long) As Long
Public Declare Function mciExecute Lib "winmm.dll" (ByVal lpstrCommand As String) As Long
Public Declare Function mciGetCreatorTask Lib "winmm.dll" (ByVal wDeviceID As Long) As Long
Public Declare Function mciGetDeviceID Lib "winmm.dll" Alias "mciGetDeviceIDA" (ByVal lpstrName As String) As Long
Public Declare Function mciGetDeviceIDFromElementID Lib "winmm.dll" Alias "mciGetDeviceIDFromElementIDA" (ByVal dwElementID As Long, ByVal lpstrType As String) As Long
Public Declare Function mciGetYieldProc Lib "winmm" (ByVal mciId As Long, pdwYieldData As Long) As Long
Public Declare Function mciSetYieldProc Lib "winmm" (ByVal mciId As Long, ByVal fpYieldProc As Long, ByVal dwYieldData As Long) As Long

Public Declare Function midiConnect Lib "winmm.dll" (ByVal hmi As Long, ByVal hmo As Long, pReserved As Any) As Long
Public Declare Function midiDisconnect Lib "winmm.dll" (ByVal hmi As Long, ByVal hmo As Long, pReserved As Any) As Long

'Public Declare Function midiInAddBuffer Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MIDIHDR, ByVal uSize As Long) As Long
'Public Declare Function midiInClose Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
'Public Declare Function midiInGetDevCaps Lib "winmm.dll" Alias "midiInGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As MIDIINCAPS, ByVal uSize As Long) As Long
'Public Declare Function midiInGetErrorText Lib "winmm.dll" Alias "midiInGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
'Public Declare Function midiInGetID Lib "winmm.dll" (ByVal hMidiIn As Long, lpuDeviceID As Long) As Long
'Public Declare Function midiInGetNumDevs Lib "winmm.dll" () As Long
'Public Declare Function midiInMessage Lib "winmm.dll" (ByVal hMidiIn As Long, ByVal msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
'Public Declare Function midiInOpen Lib "winmm.dll" (lphMidiIn As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
'Public Declare Function midiInPrepareHeader Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MIDIHDR, ByVal uSize As Long) As Long
'Public Declare Function midiInReset Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
'Public Declare Function midiInStart Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
'Public Declare Function midiInStop Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
'Public Declare Function midiInUnprepareHeader Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MIDIHDR, ByVal uSize As Long) As Long

Public Declare Function midiOutCacheDrumPatches Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal uPatch As Long, lpKeyArray As Long, ByVal uFlags As Long) As Long
Public Declare Function midiOutCachePatches Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal uBank As Long, lpPatchArray As Long, ByVal uFlags As Long) As Long
Public Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Public Declare Function midiOutGetDevCaps Lib "winmm.dll" Alias "midiOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As MIDIOUTCAPS, ByVal uSize As Long) As Long
Public Declare Function midiOutGetErrorText Lib "winmm.dll" Alias "midiOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Public Declare Function midiOutGetID Lib "winmm.dll" (ByVal hMidiOut As Long, lpuDeviceID As Long) As Long
Public Declare Function midiOutGetNumDevs Lib "winmm" () As Integer
Public Declare Function midiOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Public Declare Function midiOutLongMsg Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
Public Declare Function midiOutMessage Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal Msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
Public Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function midiOutPrepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
Public Declare Function midiOutReset Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Public Declare Function midiOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Public Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long
Public Declare Function midiOutUnprepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
Public Declare Function midiStreamClose Lib "winmm.dll" (ByVal hms As Long) As Long
Public Declare Function midiStreamOpen Lib "winmm.dll" (phms As Long, puDeviceID As Long, ByVal cMidi As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal fdwOpen As Long) As Long
Public Declare Function midiStreamOut Lib "winmm.dll" (ByVal hms As Long, pmh As MIDIHDR, ByVal cbmh As Long) As Long
Public Declare Function midiStreamPause Lib "winmm.dll" (ByVal hms As Long) As Long
Public Declare Function midiStreamPosition Lib "winmm.dll" (ByVal hms As Long, lpmmt As MMTIME, ByVal cbmmt As Long) As Long
Public Declare Function midiStreamProperty Lib "winmm.dll" (ByVal hms As Long, lppropdata As Byte, ByVal dwProperty As Long) As Long
Public Declare Function midiStreamRestart Lib "winmm.dll" (ByVal hms As Long) As Long
Public Declare Function midiStreamStop Lib "winmm.dll" (ByVal hms As Long) As Long

Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long

Public Const MAXPNAMELEN = 32
'Public Const MCI_OPEN = &H803
'Public Const MCI_OPEN_ELEMENT = &H200&
'Public Const MCI_OPEN_TYPE = &H2000&
'Public Const MCI_STATUS = &H814
'Public Const MCI_STATUS_ITEM = &H100&
'Public Const MCI_CLOSE = &H804
'Public Const MCI_NOTIFY = &H1&
'Public Const MCI_PLAY = &H806

Public Const MIDI_MAPPER = -1&
Public Const MIDI_CACHE_ALL = 1
Public Const MIDI_CACHE_BESTFIT = 2
Public Const MIDI_CACHE_QUERY = 3
Public Const MIDI_CACHE_VALID = (MIDI_CACHE_ALL Or MIDI_CACHE_BESTFIT Or MIDI_CACHE_QUERY Or 4) 'MIDI_UNCACHE)
Public Const MIDI_IO_STATUS = &H20&
Public Const MIDI_UNCACHE = 4
Public Const MIDICAPS_CACHE = &H4
Public Const MIDICAPS_LRVOLUME = &H2
Public Const MIDICAPS_STREAM = &H8
Public Const MIDICAPS_VOLUME = &H1
Public Const MIDIERR_BASE = 64
Public Const MIDIERR_INVALIDSETUP = (MIDIERR_BASE + 5)
Public Const MIDIERR_LASTERROR = (MIDIERR_BASE + 5)
Public Const MIDIERR_NODEVICE = (MIDIERR_BASE + 4)
Public Const MIDIERR_NOMAP = (MIDIERR_BASE + 2)
Public Const MIDIERR_NOTREADY = (MIDIERR_BASE + 3)
Public Const MIDIERR_STILLPLAYING = (MIDIERR_BASE + 1)
Public Const MIDIERR_UNPREPARED = (MIDIERR_BASE + 0)
Public Const MIDIMAPPER = (-1)
Public Const MIDIPROP_GET = &H40000000
Public Const MIDIPROP_SET = &H80000000
Public Const MIDIPROP_TEMPO = &H2&
Public Const MIDIPROP_TIMEDIV = &H1&
Public Const MIDISTRM_ERROR = -2
'Public Const MIM_CLOSE = MM_MIM_CLOSE
'Public Const MIM_DATA = MM_MIM_DATA
'Public Const MIM_ERROR = MM_MIM_ERROR
'Public Const MIM_LONGDATA = MM_MIM_LONGDATA
'Public Const MIM_LONGERROR = MM_MIM_LONGERROR
'Public Const MIM_MOREDATA = MM_MIM_MOREDATA
'Public Const MIM_OPEN = MM_MIM_OPEN
Public Const MM_MOM_CLOSE = &H3C8
Public Const MM_MOM_DONE = &H3C9
Public Const MM_MOM_OPEN = &H3C7
Public Const MM_MOM_POSITIONCB = &H3CA
Public Const MM_MIDI_MAPPER = 1
Public Const MOM_CLOSE = MM_MOM_CLOSE
Public Const MOM_DONE = MM_MOM_DONE
Public Const MOM_OPEN = MM_MOM_OPEN
Public Const MOM_POSITIONCB = MM_MOM_POSITIONCB
Public Const CALLBACK_FUNCTION = &H30000
Public Const MMSYSERR_NOERROR = 0
Public Const MHDR_DONE = &H1
Public Const MHDR_INQUEUE = &H4
Public Const MHDR_PREPARED = &H2
Public Const MHDR_VALID = &H7
Public Const CALLBACK_NULL = &H0


Public Const MCI_OPEN = &H803
Public Const MCI_CLOSE = &H804
Public Const MCI_ESCAPE = &H805
Public Const MCI_PLAY = &H806
Public Const MCI_SEEK = &H807
Public Const MCI_STOP = &H808
Public Const MCI_PAUSE = &H809
Public Const MCI_INFO = &H80A
Public Const MCI_GETDEVCAPS = &H80B
Public Const MCI_SPIN = &H80C
Public Const MCI_SET = &H80D
Public Const MCI_STEP = &H80E
Public Const MCI_RECORD = &H80F
Public Const MCI_SYSINFO = &H810
Public Const MCI_BREAK = &H811
Public Const MCI_SOUND = &H812
Public Const MCI_SAVE = &H813
Public Const MCI_STATUS = &H814

Public Const MCI_CUE = &H830

Public Const MCI_REALIZE = &H840
Public Const MCI_WINDOW = &H841
Public Const MCI_PUT = &H842
Public Const MCI_WHERE = &H843
Public Const MCI_FREEZE = &H844
Public Const MCI_UNFREEZE = &H845

Public Const MCI_LOAD = &H850
Public Const MCI_CUT = &H851
Public Const MCI_COPY = &H852
Public Const MCI_PASTE = &H853
Public Const MCI_UPDATE = &H854
Public Const MCI_RESUME = &H855
Public Const MCI_DELETE = &H856

Public Const MCI_LAST = &HFFF

'  the next 0x400 message ID's are reserved for custom drivers
'  all custom MCI command messages must be >= than this value
'Public Const MCI_USER_MESSAGES = (&H400 + MCI_FIRST)
Public Const MCI_ALL_DEVICE_ID = -1   '  Matches all MCI devices

'  Public Constants for predefined MCI device types
Public Const MCI_DEVTYPE_VCR = 513
Public Const MCI_DEVTYPE_VIDEODISC = 514
Public Const MCI_DEVTYPE_OVERLAY = 515
Public Const MCI_DEVTYPE_CD_AUDIO = 516
Public Const MCI_DEVTYPE_DAT = 517
Public Const MCI_DEVTYPE_SCANNER = 518
Public Const MCI_DEVTYPE_ANIMATION = 519
Public Const MCI_DEVTYPE_DIGITAL_VIDEO = 520
Public Const MCI_DEVTYPE_OTHER = 521
Public Const MCI_DEVTYPE_WAVEFORM_AUDIO = 522
Public Const MCI_DEVTYPE_SEQUENCER = 523

Public Const MCI_DEVTYPE_FIRST = MCI_DEVTYPE_VCR
Public Const MCI_DEVTYPE_LAST = MCI_DEVTYPE_SEQUENCER

Public Const MCI_DEVTYPE_FIRST_USER = &H1000

''  return values for 'status mode' command
'Public Const MCI_MODE_NOT_READY = (MCI_STRING_OFFSET + 12)
'Public Const MCI_MODE_STOP = (MCI_STRING_OFFSET + 13)
'Public Const MCI_MODE_PLAY = (MCI_STRING_OFFSET + 14)
'Public Const MCI_MODE_RECORD = (MCI_STRING_OFFSET + 15)
'Public Const MCI_MODE_SEEK = (MCI_STRING_OFFSET + 16)
'Public Const MCI_MODE_PAUSE = (MCI_STRING_OFFSET + 17)
'Public Const MCI_MODE_OPEN = (MCI_STRING_OFFSET + 18)

'  Public Constants used in 'set time format' and 'status time format' commands
Public Const MCI_FORMAT_MILLISECONDS = 0
Public Const MCI_FORMAT_HMS = 1
Public Const MCI_FORMAT_MSF = 2
Public Const MCI_FORMAT_FRAMES = 3
Public Const MCI_FORMAT_SMPTE_24 = 4
Public Const MCI_FORMAT_SMPTE_25 = 5
Public Const MCI_FORMAT_SMPTE_30 = 6
Public Const MCI_FORMAT_SMPTE_30DROP = 7
Public Const MCI_FORMAT_BYTES = 8
Public Const MCI_FORMAT_SAMPLES = 9
Public Const MCI_FORMAT_TMSF = 10

'  Flags for wParam of the MM_MCINOTIFY message
Public Const MCI_NOTIFY_SUCCESSFUL = &H1
Public Const MCI_NOTIFY_SUPERSEDED = &H2
Public Const MCI_NOTIFY_ABORTED = &H4
Public Const MCI_NOTIFY_FAILURE = &H8

'  common flags for dwFlags parameter of MCI command messages
Public Const MCI_NOTIFY = &H1&
Public Const MCI_WAIT = &H2&
Public Const MCI_FROM = &H4&
Public Const MCI_TO = &H8&
Public Const MCI_TRACK = &H10&

'  flags for dwFlags parameter of MCI_OPEN command message
Public Const MCI_OPEN_SHAREABLE = &H100&
Public Const MCI_OPEN_ELEMENT = &H200&
Public Const MCI_OPEN_ALIAS = &H400&
Public Const MCI_OPEN_ELEMENT_ID = &H800&
Public Const MCI_OPEN_TYPE_ID = &H1000&
Public Const MCI_OPEN_TYPE = &H2000&

'  flags for dwFlags parameter of MCI_SEEK command message
Public Const MCI_SEEK_TO_START = &H100&
Public Const MCI_SEEK_TO_END = &H200&

'  flags for dwFlags parameter of MCI_STATUS command message
Public Const MCI_STATUS_ITEM = &H100&
Public Const MCI_STATUS_START = &H200&

'  flags for dwItem field of the MCI_STATUS_PARMS parameter block
Public Const MCI_STATUS_LENGTH = &H1&
Public Const MCI_STATUS_POSITION = &H2&
Public Const MCI_STATUS_NUMBER_OF_TRACKS = &H3&
Public Const MCI_STATUS_MODE = &H4&
Public Const MCI_STATUS_MEDIA_PRESENT = &H5&
Public Const MCI_STATUS_TIME_FORMAT = &H6&
Public Const MCI_STATUS_READY = &H7&
Public Const MCI_STATUS_CURRENT_TRACK = &H8&

'  flags for dwFlags parameter of MCI_INFO command message
Public Const MCI_INFO_PRODUCT = &H100&
Public Const MCI_INFO_FILE = &H200&

'  flags for dwFlags parameter of MCI_GETDEVCAPS command message
Public Const MCI_GETDEVCAPS_ITEM = &H100&

'  flags for dwItem field of the MCI_GETDEVCAPS_PARMS parameter block
Public Const MCI_GETDEVCAPS_CAN_RECORD = &H1&
Public Const MCI_GETDEVCAPS_HAS_AUDIO = &H2&
Public Const MCI_GETDEVCAPS_HAS_VIDEO = &H3&
Public Const MCI_GETDEVCAPS_DEVICE_TYPE = &H4&
Public Const MCI_GETDEVCAPS_USES_FILES = &H5&
Public Const MCI_GETDEVCAPS_COMPOUND_DEVICE = &H6&
Public Const MCI_GETDEVCAPS_CAN_EJECT = &H7&
Public Const MCI_GETDEVCAPS_CAN_PLAY = &H8&
Public Const MCI_GETDEVCAPS_CAN_SAVE = &H9&

'  flags for dwFlags parameter of MCI_SYSINFO command message
Public Const MCI_SYSINFO_QUANTITY = &H100&
Public Const MCI_SYSINFO_OPEN = &H200&
Public Const MCI_SYSINFO_NAME = &H400&
Public Const MCI_SYSINFO_INSTALLNAME = &H800&

'  flags for dwFlags parameter of MCI_SET command message
Public Const MCI_SET_DOOR_OPEN = &H100&
Public Const MCI_SET_DOOR_CLOSED = &H200&
Public Const MCI_SET_TIME_FORMAT = &H400&
Public Const MCI_SET_AUDIO = &H800&
Public Const MCI_SET_VIDEO = &H1000&
Public Const MCI_SET_ON = &H2000&
Public Const MCI_SET_OFF = &H4000&

'  flags for dwAudio field of MCI_SET_PARMS or MCI_SEQ_SET_PARMS
Public Const MCI_SET_AUDIO_ALL = &H4001&
Public Const MCI_SET_AUDIO_LEFT = &H4002&
Public Const MCI_SET_AUDIO_RIGHT = &H4003&

'  flags for dwFlags parameter of MCI_BREAK command message
Public Const MCI_BREAK_KEY = &H100&
Public Const MCI_BREAK_HWND = &H200&
Public Const MCI_BREAK_OFF = &H400&

'  flags for dwFlags parameter of MCI_RECORD command message
Public Const MCI_RECORD_INSERT = &H100&
Public Const MCI_RECORD_OVERWRITE = &H200&

'  flags for dwFlags parameter of MCI_SOUND command message
Public Const MCI_SOUND_NAME = &H100&

'  flags for dwFlags parameter of MCI_SAVE command message
Public Const MCI_SAVE_FILE = &H100&

'  flags for dwFlags parameter of MCI_LOAD command message
Public Const MCI_LOAD_FILE = &H100
Public Const MEVT_F_SHORT = &H0&

Public Const GWL_EXSTYLE = (-20)
Public Const GWL_HINSTANCE = (-6)
Public Const GWL_HWNDPARENT = (-8)
Public Const GWL_ID = (-12)
Public Const GWL_STYLE = (-16)
Public Const GWL_USERDATA = (-21)
Public Const GWL_WNDPROC = (-4)
    
Public lpPrevWndProc As Long 'Used for subclassing
Public Const MM_MCINOTIFY = &H3B9  '  MCI
Public Const MM_MCISIGNAL = &H3CB
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long



Global gHW As Long 'Handle of window to subclass
Global glFrom As Long 'Start time
Global glTo As Long 'End time
Global gsMidiFile As String 'Filename of Midi file to play
Global gbPlaying As Boolean 'Set to true when a midi file is playing
Global gbRepeat As Boolean 'Flag to know whether to repeat the file when it is done playing

Public Sub CloseMidi(SoundID As String)
    Dim lResult As Integer
    Dim sError As String * 255
    
    'Make the call to close the midi file
    lResult = mciSendString("close " & SoundID, 0&, 0&, 0&)
    
    'Check to see if there was an error
    If lResult Then
      lResult = mciGetErrorString(lResult, sError, 255)
      Debug.Print "close: " & CStr(lResult) & ": " & sError
      Debug.Print "(" & SoundID & ")"
      Exit Sub
    End If
    Debug.Print SoundID & " closed"
End Sub


Public Sub UnHook(ByVal hWndHook As Long)

  Dim rtn As Long
  rtn = SetWindowLong(hWndHook, GWL_WNDPROC, lpPrevWndProc)
End Sub



Public Sub Hook(ByVal hWndHook As Long)

  lpPrevWndProc = SetWindowLong(hWndHook, GWL_WNDPROC, AddressOf MidiOutProc)
End Sub


Public Function MidiOutProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  Dim i As Long
  
  On Error Resume Next
  
  Select Case uMsg
  Case MM_MCINOTIFY
    If wParam = MCI_NOTIFY_SUCCESSFUL Then
      'determine which sound is done
      For i = 0 To 15
        If SoundInfo(i).DeviceID = i Then
          Exit For
        End If
      Next i

      CloseMidi SoundInfo(i).SoundID
      'restore soundinfo object
      SoundInfo(i).DeviceID = 0
      SoundInfo(i).SoundID = ""
    End If
  End Select
  
  MidiOutProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function


