VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SourceCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements StringList

Private WithEvents scSource As StringList
Attribute scSource.VB_VarHelpID = -1

Private mLoaded As Boolean
Private mIsDirty As Boolean
Private mSourceFile As String
Private mCRC As Long

Private mParent As AGILogic

'other
Private strErrSource As String
Private mSettingCode As Boolean

Public Event Change()
Public Event Loaded(LoadReason As Long)

Friend Property Let IsDirty(ByVal NewVal As Boolean)
  mIsDirty = NewVal
End Property

Friend Property Let Loaded(ByVal NewVal As Boolean)
  'only called when adding new logic to game
  
  mLoaded = NewVal
End Property

Friend Sub SetCode(NewSourceCode As SourceCode)
  'called by setlogic
  'copies entire sourcecode structure
  
  On Error Resume Next
  
  'set flag so event cascading is not a problem
  mSettingCode = True
  
  With NewSourceCode
    scSource.Assign .Text
    mLoaded = .Loaded
    mIsDirty = .IsDirty
    mSourceFile = .SourceFile
    mCRC = .CRC
  End With
  
  'reenable events
  mSettingCode = False
End Sub


Friend Sub SetParent(NewParent As AGILogic)
  
  Set mParent = NewParent
End Sub

Friend Sub ChangeSourceFile(NewID As String)

  'called by parent logic when id changes
  mSourceFile = agResDir & NewID & agSrcExt
End Sub

Public Property Let SourceFile(NewSourceFile As String)
  
    'if in a game,
  If mParent.Resource.InGame Then
    'can't change sourcefile name
    On Error GoTo 0: Err.Raise vbObjectError + 679, strErrSource, LoadResString(679)
    Exit Property
  End If
  
  mSourceFile = NewSourceFile
End Property



Public Property Get SourceFile() As String

  'if in a game,
  If mParent.Resource.InGame Then
    'sourcefile is predefined
    SourceFile = agResDir & mParent.ID & agSrcExt
  Else
    SourceFile = mSourceFile
  End If
End Property
Public Property Get IsDirty() As Boolean
  IsDirty = mIsDirty
  
End Property


Public Property Get Loaded() As Boolean
  Loaded = mLoaded
  
End Property

Public Sub Load(Optional ByVal LoadFile As String, Optional ByVal Decompile As Boolean = False)
  'loads LoadFile as the source code
  
  Dim intFile As Integer, strInput As String
  
  On Error GoTo ErrHandler
  
  'set flag to avoid event propogation
  mSettingCode = True
  Debug.Assert Err.Number = 0
  
  'if in a game,
  If mParent.Resource.InGame Then
    'load file is predefined
    LoadFile = agResDir & mParent.ID & agSrcExt
    'if it does not exist,
    If Not FileExists(LoadFile) Then
      'check for AGI Studio file format
      If FileExists(agResDir & "logic" & mParent.Number & ".txt") And agSrcExt = ".lgc" Then
        'rename it to correct format
        Name agResDir & "logic" & mParent.Number & ".txt" As LoadFile
      ElseIf FileExists(agResDir & mParent.ID & ".txt") And agSrcExt = ".lgc" Then
        'rename it to correct format
        Name agResDir & mParent.ID & ".txt" As LoadFile
      Else
        'default file does not exist; AGI Studio file does not exist;
        'set to null string to force decompile
        LoadFile = vbNullString
      End If
    End If
  Else
    'if no filename is passed
    If LenB(LoadFile) = 0 Then
      'if this resource has a sourcefile
      'use it; if there is not a sourcefile
      'attempt to decompile (may not work for non-game resources)
      If LenB(mSourceFile) <> 0 Then
        If FileExists(mSourceFile) Then
          LoadFile = mSourceFile
        End If
      End If
    End If
    'set sourcefile property to match loadfile Value
    mSourceFile = LoadFile
  End If
    
  'if still no name, (OR forcing decompile)
  If LenB(LoadFile) = 0 Or Decompile Then
    'get source code by decoding the resource
'''    strInput = Join(DecodeLogic(mParent.Resource.AllData).AllLines, vbNewLine)
    strInput = Join(DecodeLogic(mParent.Resource.AllData).AllLines, vbCr)
   
    'set decompile so correct event is raised after load is complete
    Decompile = True
  Else
    'load sourcecode from file
    On Error Resume Next
    
    intFile = FreeFile()
    Open LoadFile For Binary As intFile
    'if error,
    If Err.Number <> 0 Then
      'close file
      Close intFile
      'return error
      On Error GoTo 0: Err.Raise vbObjectError + 502, strErrSource, Replace(Replace(LoadResString(502), ARG1, CStr(Err.Number)), "%2", LoadFile)
      Exit Sub
    End If
    
    On Error GoTo ErrHandler
    
    'get source code
    strInput = String$(LOF(intFile), 0)
    Get intFile, 1, strInput
    Close intFile
  End If
  
  'convert extended characters
   ByteToExtChar strInput
  'send text in source code string list
  scSource.Assign strInput
  
  'set loaded flag and dirty status
  mLoaded = True
  mIsDirty = False
    
  'get source crc
'''  mCRC = CRC32(StrConv(Join(scSource.AllLines, vbNewLine), vbFromUnicode))
  mCRC = CRC32(StrConv(Join(scSource.AllLines, vbCr), vbFromUnicode))

  If Decompile Then
    'raise loaded event with compiled flag
    RaiseEvent Loaded(1)
  Else
    'raise loaded event with fromfile event
    RaiseEvent Loaded(0)
  End If
  
  'reset event propogation flag
  mSettingCode = False
  'clear any errors
  Err.Clear
Exit Sub

ErrHandler:
  'pass along error
  lngError = Err.Number
  strError = Err.Description
  strErrSrc = Err.Source
  
  'reset event propogation flag
  mSettingCode = False
  
  On Error GoTo 0: Err.Raise lngError, strErrSrc, strError
End Sub

Public Property Let Text(NewSource As String)
  'assigns new text to the source stringlist object
  
  Dim i As Long
  
  scSource.Assign NewSource
  'strip off the extra blank lines at end;
  'NOTE: this will cause trouble with source code saving
  'if not addressed by the logic editor Save function
  
  'strip off any blank lines at the end (but not last line, if it's a blank)
  For i = scSource.Count - 1 To 1 Step -1
    If LenB(scSource.StringLine(i)) = 0 Then
      'remove it
      scSource.Delete i
    Else
      'first line found stops process
      Exit Property
    End If
  Next i
End Property

Public Property Get Text() As String
  'returns all source lines as a single string
  Text = Join(scSource.AllLines, vbCr)
End Property
Public Sub Unload()
  'clear out variables
  
  'if already unloaded, just exit
  If Not mLoaded Then
    Exit Sub
  End If
  
  'set flag so event cascading is not a problem
  mSettingCode = True

  scSource.Clear

  mLoaded = False
  mIsDirty = False
  mSourceFile = vbNullString

  mCRC = 0
End Sub

Public Sub Save(Optional SaveFile As String)
  'saves the source code for this logic to file
  Dim strTempFile As String
  Dim intFile As Integer
  Dim bytText() As Byte
  
  On Error GoTo ErrHandler
 
  'if no save file was passed,
  If LenB(SaveFile) = 0 Then
    'if in a game
    If mParent.Resource.InGame Then
      'filename is predfined
      SaveFile = agResDir & mParent.ID & agSrcExt
    Else
      'if no default,
      If LenB(mSourceFile) = 0 Then
        'build default filename
        mSourceFile = agResDir & mParent.ID
      End If
      'use default name
      SaveFile = mSourceFile
    End If
  End If
  
  'get temporary file
  strTempFile = TempFileName()
  
  'open file for output
  intFile = FreeFile()
  Open strTempFile For Binary As intFile
  
 'convert any extended characters to correct byte value
  bytText() = ExtCharToByte(Join(scSource.AllLines, vbCr))
  
  'write text to file
  Put #intFile, 1, bytText()
  
  'close file,
  Close intFile
  
  'if savefile exists
  If FileExists(SaveFile) Then
    On Error Resume Next
    'delete it
    Kill SaveFile
    On Error GoTo ErrHandler
  End If
  
  'copy tempfile to savefile
  FileCopy strTempFile, SaveFile
  
  'if error
  If Err.Number <> 0 Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 582, strErrSource, LoadResString(582)
    Exit Sub
  End If
  
  'delete temp file
  Kill strTempFile
  Err.Clear
  
  If Not mParent.Resource.InGame Then
    'reset dirty flag
    mIsDirty = False
  End If
  
  'set prop flag of parent
  mParent.WritePropState = True
  
  'if in a game
  If Not mParent.Resource.InGame Then
    'save filename for non-game resources
    mSourceFile = SaveFile
    'update id to match savefile name
    mParent.FriendID = JustFileName(SaveFile)
  End If
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 663, strErrSrc, Replace(LoadResString(663), ARG1, CStr(lngError) & ":" & strError)
End Sub




Friend Property Get Source() As StringList

  Set Source = scSource
End Property



Public Property Get CRC() As Long
    
    CRC = mCRC
End Property


Private Sub Class_Initialize()

  Set scSource = New StringList
  
  strErrSource = "SourceCode"
  
End Sub

Private Sub Class_Terminate()

  'clear out the stringlist
  scSource.Clear
  
  Set scSource = Nothing
End Sub


Private Sub scSource_Change()
  'if changing  because of unload
  '(loaded=false) don't raise event
  
  'if generated from SetCode method,
  If mSettingCode Then
    Exit Sub
  End If
  
  'recalculate crc
'''  mCRC = CRC32(StrConv(Join(scSource.AllLines, vbNewLine), vbFromUnicode))
  mCRC = CRC32(StrConv(Join(scSource.AllLines, vbCr), vbFromUnicode))

'''  Debug.Print StrConv(StrConv(Join(scSource.AllLines, vbNewLine), vbUnicode), vbFromUnicode)
  If mLoaded Then
    'raise source code change event
    RaiseEvent Change
    'indicate source is dirty
    mIsDirty = True
  End If
End Sub

Private Sub StringList_Add(NewString As String, Optional InsertPos As Long = -1&)
  scSource.Add NewString, InsertPos
  
End Sub


Private Property Get StringList_AllLines() As String()
  StringList_AllLines = scSource.AllLines
  
End Property


Private Sub StringList_Assign(ByVal sInput As Variant, Optional ByVal Delimiter As String = vbNewLine)
  scSource.Assign sInput, Delimiter
  
End Sub


Private Sub StringList_Clear()
  scSource.Clear
  
End Sub


Private Property Get StringList_Count() As Long
  StringList_Count = scSource.Count
  
End Property


Private Sub StringList_Delete(ByVal Index As Long)
  scSource.Delete Index
  
End Sub


Private Sub StringList_Sort()
  scSource.Sort
  
End Sub


Private Property Let StringList_StringLine(ByVal Index As Long, RHS As String)
  scSource.StringLine(Index) = RHS
  
End Property

Private Property Get StringList_StringLine(Optional ByVal Index As Long = -1&) As String
  StringList_StringLine = scSource.StringLine(Index)
  
End Property


